<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 29/10/2018
 * Time: 21:53
 */

require_once ("curl_class.php");
//require_once ("database_class.php");
require_once ("company_category_class.php");
class giftingowl_class extends curl_class
{

    private $token = '123456';
    //private $end_point ='https://experiences.rewardsboxnigeria.com/giftingowl/public/api/';
    private $end_point ='https://experiences.perxclm.com/public/api/';
    private  $header;
    //private $rates_table = 'xoxo_rates';
    private $delivery_type = 4;
    private $rims_partner_id = 123;
    private $salt = "gRSEohsJPg";
    //private $store_name = "Loyalty Solutions";
    //private $store_url= "loyaltysolutionsnigeria.com";
    private $log_table = "xoxo_order_log";



    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        $this->header=array(
            'Content-type= application/json',
            'token:'. $this->token
        );
        //return $this->header = array("key: " .$this->key,"content-type: application/json", "cache-control: no-cache");
    }


    public function get_countries(){

        $this->set_header();
        $api = "get_countries";
        $new_url = $this->end_point.$api;

        $get_country = $this->send_get($new_url,$this->header);

        if(is_array($get_country)){

            if($get_country['status'] == 200){

                return $get_country['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No country found";
        }

    }

    public function get_city ($country_id){


        if (is_numeric($country_id)){

            $this->set_header();
            $api = "get_cities";

            $new_url = $this->end_point.$api;

            $body['country_id'] = $country_id;
            $get_city = $this->send_post_v3($new_url,$body,$this->header);

            if(is_array($get_city)){

                if($get_city['status'] == 200){

                    return $get_city['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No city found";
            }

        } else {

            return "Invalid country";
        }
    }


    public function get_products($city, $page = 0, $limit = 20){
        if($page == "" || !is_numeric($page) || $page < 1){

            $page = 0;
        }

        if ($limit == "" || !is_numeric($limit) || $limit < 1){

            $limit = 20;
        }

        $this->set_header();

        $api = "get_experiences_by_city";

        $new_url = $this->end_point.$api;


        $data_array["city_id"] = $city;
        $data_array["page"]=$page;
        $data_array["limit"] = $limit;


        $get_products = $this->send_post_v3($new_url,$data_array,$this->header);

        if(is_array($get_products)){

           if ($get_products['status'] == 200){

               return $get_products;
           } else {

               return "Products not found";
           }


        } else {

            return "No product found";
        }

    }



    public function get_service_products($partner_category_id, $partner_id, $margin, $margin_type, $city_id, $page, $limit){

        if(!isset($city_id)){

            return "City is required";
        } else {


            if($city_id == "" || !is_numeric($city_id) || $city_id < 1){


                return "Invalid City";
            } else {

                $get_data = $this->get_products($city_id, $page, $limit);

                if(is_array($get_data)){

                    if ($get_data['status'] == 200) {
                        if(isset($get_data['data']['total'])) {
                            $get_products ['total'] = $get_data['data']['total'];
                        } else {

                            $get_products ['total'] ="";
                        }
                        $get_products['data'] = $this->arrange_list_cat_item($partner_id, $margin, $margin_type, $get_data['data']['results'], $partner_category_id);

                        if (is_array($get_products)){

                            return $get_products;

                        } else {

                            return "No data found";
                        }
                    } else {

                        return $get_data['message'];
                    }
                } else {

                    return $get_data;


                }
            }
        }



    }

    public function arrange_list_cat_item($partner_id, $margin, $margin_type, $result_array, $category_id){
        $add_margin = new company_category_class();
        $products = array();
//            echo json_encode($result_array);
//            echo "<hr>";
        foreach ($result_array as $result){
            $data = array();
            $d_array['p_id'] = $result['guid'];
            $d_array['c_id'] = $category_id;
//            echo json_encode($d_array);
//            echo "<br>";
            $data['product_code']=base64_encode(json_encode($d_array));
//            echo $data['product_code'];
//            echo "<br>";
            $data['product']=$result['title'];
            $data['image']= $result['picture'];
            $data['country'] = $result['google_country'];
            $data['city'] = $result['google_city'];
            $data['state'] = $result['google_state_long'];
            $data['duration'] = $result['duration_minutes'];

            $new_price = $add_margin->apply_margin($margin, $margin_type, $result['naira_price']);

            if ($new_price >= 0){
                $data['price'] = $new_price;


                $products[] = $data;

            }

        }



        return $products;
    }


    public function get_product_details($partner_id, $margin, $margin_type, $product_code){

        $get_array = $this->list_detail_items($product_code);


        if (is_array($get_array)){

            if($get_array['status'] == 200){


                $get_mod_details = $this->arrange_detail($partner_id,$margin,$margin_type, $get_array['data']);

                return $get_mod_details;
            } else {

                  return $get_array['message'];

            }


        } else {

            return "No data found";
        }

    }

    public function arrange_detail($partner_id,$margin,$margin_type, $detail_array){
        $add_margin = new company_category_class();
        $product_detail = array();
        $product_detail['item_code'] =$detail_array['guid'];
        $product_detail['name'] =$detail_array['name'];
        $product_detail['description'] =$detail_array['description'];
        $product_detail['location'] =$detail_array['location_address'];
        $product_detail['duration'] =$detail_array['duration_minutes'];
        $product_detail['age'] =$detail_array['age'];
        $product_detail['gender'] =$detail_array['gender'];
        $product_detail['image'] =$detail_array['picture'];
        $product_detail['city'] =$detail_array['google_city'];
        $product_detail['state'] =$detail_array['google_state_long'];
        $product_detail['country'] =$detail_array['google_country'];
        $product_detail['extra_info'] =$detail_array['extra_info'];
        $product_detail['images'] =$detail_array['images'];
        $product_detail['extras'] =$detail_array['extras'];
        $product_detail['price'] = $add_margin->apply_margin($margin, $margin_type,$detail_array['price']);

        return $product_detail;

    }


    public function list_detail_items ($product_code){

        $this->set_header();
        $api = "single_experience";

        $new_url = $this->end_point.$api;

        $body['eguid'] = $product_code;
        $get_data = $this->send_post_v3($new_url,$body,$this->header);

        if(is_array($get_data)){

            if($get_data['status'] == 200){

                return $get_data;
            } else {

                return "No data found";
            }


        } else {

            return "No Product found";
        }




    }


    public function list_availability ($product_code){

        $this->set_header();
        $api = "get_experiences_availability";

        $new_url = $this->end_point.$api;

        $body['eguid'] = $product_code;
        $get_data = $this->send_post_v3($new_url,$body,$this->header);

        if(is_array($get_data)){

            if($get_data['status'] == 200){

                return $get_data;
            } else {

                return "No data found";
            }


        } else {

            return "No Product found";
        }




    }


    public function list_popular(){

        $this->set_header();
        $api = "get_popular_cities";

        $new_url = $this->end_point.$api;


        $get_data = $this->send_get($new_url,$this->header);

        if(is_array($get_data)){

            if($get_data['status'] == 200){

                return $get_data['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No Product found";
        }




    }

    public function list_booking_form($product_code){

        $this->set_header();
        $api = "get_experience_booking_form";

        $new_url = $this->end_point.$api;
        $body['eguid'] = $product_code;
        $get_data = $this->send_post_v3($new_url,$body,$this->header);



        if(is_array($get_data)){

            if($get_data['status'] == 200){

                return $get_data['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No Product found";
        }




    }

    public function get_availability($guid, $partner_id, $margin, $margin_type){

        $get_data = $this->list_availability($guid);

        if (is_array($get_data)){

            if ($get_data['status'] == 200){

                $activity_name = $get_data['activity_name'];
                $product_array = array();
                foreach ($get_data['data'] as $product){

                    $get_product = $this->arrange_avail_list($partner_id, $margin, $margin_type, $product, $activity_name);

                    if (is_array($get_product)){

                        $product_array[] = $get_product;
                    }



                }

                return $product_array;


            } else {

                return $get_data['message'];

            }

        } else {

            return "No data found";
        }

    }

    public function arrange_avail_list($partner_id, $margin, $margin_type,$detail_array, $activity_name){

        $data_array = array();

        $data_array['start_time'] = $detail_array['start_time'];
        $data_array['start_time_local'] = $detail_array['start_time_local'];
        $data_array['end_time'] = $detail_array['end_time'];
        $data_array['end_time_local'] = $detail_array['end_time_local'];
        $data_array['seats_available'] = $detail_array['seats_available'];

        $session = $detail_array['start_time_local'];
        $bp_guid = $detail_array['bp_guid'];
        $guid = $detail_array['eguid'];
        $seats_available = $detail_array['seats_available'];


        $data_array['type_options'] = array();

        foreach ($detail_array['price_options'] as $option){

            $get_data = $this->arrange_avail_details($partner_id, $margin, $margin_type, $option, $activity_name, $session, $bp_guid, $seats_available, $guid);
            if (is_array($get_data)){

                $data_array['type_options'][] = $get_data;

            }

        }

        return $data_array;

    }

    public function arrange_avail_details($partner_id, $margin, $margin_type,$detail_array, $activity_name, $session, $bp_guid, $seats_available, $guid){
        $add_margin = new company_category_class();
        $signal = array();
        $main_array = array();
        $signal['item_code'] = $guid;
        $signal['rb_partner_id'] = $partner_id;
        $signal['item_name'] = $activity_name." - ".$detail_array['label'];
        $signal['session'] = $session;
        $signal['bp_guid'] = $bp_guid;
        $signal['max_quantity'] = $seats_available;
        $main_array['price'] = $add_margin->apply_margin($margin, $margin_type,round($detail_array['price'],2));
        $main_array['type'] = $detail_array['bp_po_guid'];
        //$main_array['type_label'] = explode("-",$detail_array['label']);
        $main_array['min_age'] = $detail_array['minAge'];
        $main_array['max_age'] = $detail_array['maxAge'];
        $main_array['type_label'] = $detail_array['label'];
        $main_array['item_code'] = $guid;
        $signal['selling_price'] = $main_array['price'];
        $signal['label'] = $detail_array['label'];
        $signal['seats_used'] = $detail_array['seats_used'];
        $signal['item_price'] = round($detail_array['price'],2) ;
        $signal['send_price'] = $detail_array['price_base'];
        $signal['send_base'] = $detail_array['currency_base'];

        $main_array['signature'] = $this->string_encrypt(json_encode($signal));


        if ($signal['selling_price'] >= $signal['item_price']){


            return $main_array;

        } else {

            return 0;
        }
    }





    public function create_order ($first_name,$last_name,$email,$phone_no,$eguid,$session,$bp_guid,$currency,$base_price,$quantity, $exp_type, $participant_forms, $forms,$label, $seats_used, $reference){

        $get_array = $this->create_order_array($first_name,$last_name,$email,$phone_no,$eguid,$session,$bp_guid,$currency,$base_price,$quantity, $exp_type, $participant_forms, $forms, $label, $seats_used, $reference);
        if(is_array($get_array)) {

            $send_gift = $this->send_order($get_array);
            return $send_gift;
//            echo json_encode($send_xoxo);
//            echo "<br>";
        } else {
            $response_array ['status'] = 99;
            $response_array ['message'] = "Error processing";
            return$response_array;

        }


    }
    public function create_order_array ($first_name,$last_name,$email,$phone_no,$eguid,$session,$bp_guid,$currency,$base_price,$quantity, $exp_type, $participant_forms, $forms,$label, $seats_used, $reference ){

        $body_array = array();

        $body_array['eguid'] = $eguid;
        $body_array['session'] =$session;
        $body_array['bp_guid'] = $bp_guid;
        $body_array['currencyType'] = $currency;
        $body_array['total'] = array();

        $t_array['currency'] = $base_price * $quantity;
        $t_array['currencyType'] = $currency;

        $body_array['total'] = $t_array;

        $body_array['customer'] = array();


        $c_array['given_name']= $first_name;
        $c_array['family_name'] = $last_name;
        $c_array['email'] = $email;
        $c_array['mobile'] = $phone_no;

        $body_array['customer'] = $c_array;

        $body_array['priceOptions'] = array();

        $p_array['bp_po_guid'] = $exp_type;
        $type = explode("-",$exp_type);
        $p_array['label'] =$label ;
        $p_array['price'] = $base_price;
        $p_array['seats_used'] = $seats_used;
        $p_array['seats_booked'] = $quantity;
        $p_array['count'] = $quantity;

        $body_array['priceOptions'][] = $p_array;
        $body_array['forms'] = $forms;


        $t_array = array();
        $t_array['value'] = $label;
        $t_array['bp_po_guid'] =$exp_type;

        $new_p_form = array();
        foreach ($participant_forms as $p_forms){

            $p_forms['ticket_type'] = $t_array;

            $new_p_form[] = $p_forms;
        }

        $body_array['participantForms'] = $new_p_form;
        $body_array['extras'] = array();


        return $body_array;
    }

    public function process_transaction($redemption_array, $delivery_array, $order_no){

        $first_name = $delivery_array['first_name'];
        $last_name = $delivery_array['last_name'];
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[3]['product_details'][0];


        $exp_type = $order_item['type_id'];
        $eguid = $order_item['signature']['item_code'];
        $quantity = $order_item['quantity'];
        $base_price = $order_item['signature']['send_price'];
        $label = $order_item['signature']['label'];
        $seats_used = $order_item['signature']['seats_used'];
        $currency = $order_item['signature']['send_base'];
        $reference = $order_item['voucher_no'];
        $session= $order_item['signature']['session'];
        $bp_guid= $order_item['signature']['bp_guid'];
        $participant_forms = $order_item['participant_forms'];


        //$booking_form = $order_item['booking_form'];
        $forms = $order_item['booking_form'];

//        echo json_encode($redemption_array);
//        echo "<hr>";
//        echo $exp_type;
//        echo "<hr>";
//        die;
        $confirm_order = $this->create_order($first_name,$last_name,$email,$phone_no,$eguid,$session,$bp_guid,$currency,$base_price,$quantity, $exp_type, $participant_forms, $forms, $label, $seats_used, $reference);
//        echo json_encode($confirm_order);
//        echo "<br>";

        if ($confirm_order['status'] == 0){

            $confirm_order['data'] = array($reference);
        }
        return $confirm_order;
        //    echo json_encode($redemption_array);
//    echo "<br>";
//    echo json_encode($delivery_array);
//    echo "<br>";
//    echo json_encode($order_no);
//    echo "<br>";
  //  echo json_encode($is_shipping);
   // echo "<br>";
    //echo json_encode($token);



    }

    public function send_order($data_body){
        $this->set_header();
        $api = "book_experience";
        $new_url = $this->end_point.$api;


        $send_data = $this->send_post_v3($new_url,$data_body,$this->header);
        $this->save_order_request(json_encode($data_body), json_encode($send_data));
        if(is_array($send_data)){

            if ($send_data['status'] == 200){

                $response_array ['status'] = 1;
                $response_array ['message'] = $data_body['priceOptions'][0]['label']. " successfully booked";

                $b_array = array();
                $b_array['customer'] = $send_data['data']['customer'];
                $b_array['booking_id'] = $send_data['data']['transaction']['link_guid'];
                $b_array['type'] = $data_body['priceOptions'][0]['label'];
                $b_array['participants'] = $send_data['data']['booking']['participants'];
                $b_array['forms'] = $send_data['data']['booking']['forms'];

                if(isset($send_data['data']['additional_info'])) {
                    $b_array['additional_info'] = $send_data['data']['additional_info'];
                } else {

                    $b_array['additional_info'] =array();
                }

                if(isset($send_data['data']['experience'])) {
                    $b_array['experience'] = $send_data['data']['experience'];
                } else {

                    $b_array['experience'] =array();
                }
                if(isset($send_data['data']['supplier'])) {
                    $b_array['supplier'] = $send_data['data']['supplier'];
                } else {

                    $b_array['supplier'] =array();
                }

                $response_array['booking_info'] = $b_array;

                return $response_array;

            } else {

                if($send_data['status'] == 400) {
                    $response_array ['status'] = 0;
                    $response_array ['message'] = $send_data['message'];
                } else {

                    $response_array ['status'] = 0;
                    $response_array ['message'] = "Unable to process. Try again Later";
                    //var_dump($response_array['currency']);
                }

                return $response_array;
            }


        } else {

            $response_array ['status'] = 99;
            $response_array ['message'] = "Error processing";
            return$response_array;
        }


    }

    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }

    private function get_random_products(){

        $this->set_header();

        $api = "get_random_experiences";

        $new_url = $this->end_point.$api;

        $get_products = $this->send_get_v4($new_url,$this->header);

        if(is_array($get_products)){

            if ($get_products['status'] == 200){

                return $get_products['data'];
            } else {

                return "Products not found";
            }


        } else {

            return "No product found";
        }

    }

    public function get_service_random_products($partner_id, $margin, $margin_type, $category_id){

        $get_data = $this->get_random_products();

                if(is_array($get_data)){

                    if ($get_data['status'] == 200) {
                        if(isset($get_data['data']['total'])) {
                            $get_products ['total'] = $get_data['data']['total'];
                        } else {

                            $get_products ['total'] ="";
                        }
                        $get_products['data'] = $this->arrange_list_cat_item($partner_id, $margin, $margin_type, $get_data['data']['results'], $category_id);

                        if (is_array($get_products)){

                            return $get_products;

                        } else {

                            return "No data found";
                        }
                    } else {

                        return $get_data['message'];
                    }
                } else {

                    return $get_data;


                }


    }
    
    
}


//$test = new giftingowl_class();
//$number = 49.28999999999999914734871708787977695465087890625;

//$round_number =  round($number, 2);
//echo $round_number;
//$type = explode("-","7525-Adult");
//print_r($type[1]);
//echo json_encode($test->list_booking_form("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo "<hr>";
//echo json_encode($test->get_availability("eadd06b3-dd6e-44eb-5b3c-76110c937fd5",3,0,2));
//echo json_encode(base64_decode("eyJwX2lkIjoiOTcwMDBhMDItZDZiNi03ZWEyLTJmZTMtN2UwMzBlYWZmMTEwIiwiY19pZCI6IjAifQ=="));
//echo json_encode($test->list_availability("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo json_encode($test->list_detail_items("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo json_encode($test->get_products(14));
//echo json_encode($test->get_countries());
//echo json_encode($test->get_city(9));
//echo json_encode($test->send_order("1234"));
//echo json_encode($test->create_order("Test", "Person", "testing@test.com", "9876543210","2018-11-30 05:00:00", 47477,"2",0,0,0,65,"abc1"));
//echo json_encode($test->get_hash("testing@test.com","9876543210","2018-09-29 08:00:00", "4435", 0, "e98opew212412", 1,"0"));
//echo json_encode($test->convert_xoxo_naira("GBP","65"));
//echo json_encode($test->get_product_details("https://corp.xoxoday.com/v2/getProduct?", "3", "1000","2",47477));
//echo json_encode($test->list_detail_items("https://corp.xoxoday.com/v2/",47477));
//echo json_encode($test->get_naira_products("https://corp.xoxoday.com/v2/getProducts","adventure","3","50", 1,5,222,2176));
//echo json_encode($test->get_products(222,2176,"adventure","https://corp.xoxoday.com/v2/getProducts"));
//echo json_encode($test->add_rates());
//echo json_encode($test->get_all_rates());