<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 13/12/2018
 * Time: 10:54
 */

require_once ("curl_class.php");
require_once ("database_class.php");
require_once ("company_category_class.php");
require_once ("main_class.php");
class nairabox_class extends curl_class
{

    private $auth = "0669D607-EF09-4386-8D2E-C6179467F065";
    private $start_url = "https://www.nairabox.com/loyalty/";
    private $cinema_url = "https://movies-apis.nairabox.net/v3/";
    private $rims_partner_id = 24;
    private $log_table = "nairabox_order_log";
    private $header = array('content-type: application/json');
    //private $header = array('content-type: application/x-www-form-urlencoded');




    public function get_all_movies(){

        $end_point = $this->cinema_url."tickets?auth=".$this->auth."&as=cinemas";

        $send_data = $this->send_get($end_point,$this->header);

        if(is_array($send_data)){

            $show_data =$this->arrange_movies($send_data);
            return $show_data;

        } else {

            return "No movie currently showing";
        }



    }


    public function get_movies_select_cinema(){

        $end_point = $this->cinema_url."tickets?auth=".$this->auth."&as=movies";

        $send_data = $this->send_get($end_point,$this->header);

        if($send_data['status'] == 200){

            $show_data =$this->arrange_select_cinema_movies($send_data['movies']);
            return $show_data;

        } else {

            return "No movie currently showing";
        }



    }


    public function arrange_movies($cinema_array){
        $main_array = array();
        foreach ($cinema_array as $cinema){

            $c_array = array();
            $uid = $cinema['uid'];
            $c_array['name']= $cinema['name'];
            $c_array['location'] = $cinema['location'];
            $c_array['state'] =  $cinema['state'];
            $c_array['tickets']= array();
            foreach ($cinema['tickets'] as $ticket){

                $t_array = array();
                $d_array['uid'] = $uid;
                $d_array['id'] = $ticket['id'];

                $t_array['product_code']=base64_encode(json_encode($d_array));
                $t_array['title'] = $ticket['title'];
                $t_array['artwork']= $ticket['artwork'];
                $t_array['thumbnail'] = $ticket['artworkThumbnail'];
                $t_array['genre'] = $ticket['genre'];
                $t_array['starring'] = $ticket['starring'];

                $c_array['tickets'][]= $t_array;
            }


            $main_array[] = $c_array;


        }


        return $main_array;
    }

    public function arrange_select_cinema_movies($movie_array){
        $main_array = array();
        foreach ($movie_array as $movie){


            $id = $movie['id'];
            $m_array['title']= $movie['title'];
            $m_array['artwork'] = $movie['artwork'];
            $m_array['thumbnail'] =  $movie['artworkThumbnail'];
            $m_array['cinemas']= array();
            foreach ($movie['cinemas'] as $cinema){

                $c_array = array();
                $d_array['uid'] = $cinema['_id'];
                $d_array['id'] = $id;

                $c_array['product_code']=base64_encode(json_encode($d_array));
                $c_array['name'] = $cinema['name'];
                $c_array['location']= $cinema['location'];
                $c_array['state'] = $cinema['state'];

                $m_array['cinemas'][]= $c_array;
            }


            $main_array[] = $m_array;


        }


        return $main_array;
    }


    public function get_events_details($partner_id, $margin, $margin_type){

        $end_point = $this->start_url."tickets?auth=".$this->auth."&as=events";

//       $send_data = $this->send_get($end_point,$this->header);

        $data = file_get_contents($end_point);
        $send_data = json_decode($data,true);

        if($send_data['status'] == 200){

            $arrange_data = $this->arrange_list_event_item($partner_id,$margin,$margin_type,$send_data['events']);

            return $arrange_data;


        } else {

            return "No event currently available";
        }


    }

    public function get_movie_details ($partner_id, $margin, $margin_type, $product_code){

        $product_array = base64_decode($product_code);

        $r_array = json_decode($product_array, true);
        if(is_array($r_array)) {

            $uid = $r_array['uid'];
            $movie_id = $r_array['id'];

            $get_details = $this->get_one_movie($movie_id,$uid);

            if(is_array($get_details)){

                $movie_array = $get_details;
                unset($movie_array['id']);
                //echo json_encode($movie_array);
                $get_times = $this->get_movie_times($uid,$movie_id);
                if(is_array($get_times)) {

                    $arrange_data = $this->arrange_list_cat_item($partner_id,$margin,$margin_type,$get_times,$movie_array['title']) ;


                    $movie_array['showtimes'] = $arrange_data;
                    return $movie_array;
                } else {

                    return $get_times;
                }


            } else {

                return $get_details;
            }




        } else{

            return "Invalid Product code";

        }



    }


    public function get_one_movie($movie_id,$uid){

        $end_point = $this->cinema_url."tickets/?auth=".$this->auth."&as=moviedetail&mid=".$movie_id."";

        //$data = file_get_contents($this->file_url."cinema_movies");
        //$send_data = json_decode($data,true);
        $send_data = $this->send_get($end_point,$this->header);

//        echo json_encode($send_data);
//        echo "<br>";
        if($send_data['status'] == 200){
            //echo $uid;
//        echo json_encode($send_data['movies']['cinemas']);
            //echo "<hr>";
            if(in_array($uid,array_column($send_data['movies']['cinemas'],'id'))) {
                $product_movie = $this->add_product_code($send_data['movies']['cinemas'], $movie_id, $uid);
                $send_data['movies']['cinemas'] = $product_movie['cinemas'];
                $send_data['movies']['cinemas_name'] = $product_movie['this_cinema']['cinema'];
                $send_data['movies']['location'] = $product_movie['this_cinema']['location'];
                $send_data['movies']['state'] = $product_movie['this_cinema']['state'];
                return $send_data['movies'];
            } else {

                return "Movie not showing in selected cinema";
            }

        } else {

            return "No movie currently showing";
        }


    }

    public function add_product_code($movie_array, $movie_id, $uid){
        $cinema_array = array();
        foreach ($movie_array as $key =>$list_movie){

            if($list_movie['id'] == $uid){
                $cinema_array['cinema'] = $list_movie['name'];
                $cinema_array['location'] = $list_movie['location'];
                $cinema_array['state'] = $list_movie['state'];

                unset($movie_array[$key]);
            } else {

                $d_array['uid'] = $list_movie['id'];
                $d_array['id'] = $movie_id;
//            echo json_encode($d_array);
//            echo "<br>";
                $movie_array[$key]['product_code']=base64_encode(json_encode($d_array));
            }



        }

        $movie['cinemas'] = $movie_array;
        $movie['this_cinema'] = $cinema_array;
        return $movie;


    }
    public function get_movie_times($cinema_id, $ticket_id){


        $end_point = $this->cinema_url."tickets?auth=".$this->auth."&as=showtimes&cinemaId=".$cinema_id."&ticketId=".$ticket_id."";

        //$data = file_get_contents($this->file_url."showtimes");
        //$send_data = json_decode($data,true);

        $send_data = $this->send_get($end_point,$this->header);

//        echo json_encode($send_data);
        //echo "<hr>";
        if($send_data['status'] == 200){

            return $send_data['showtimes'];

        } else {

            return "No movie time available";
        }

    }






    public function arrange_list_event_item($partner_id, $margin, $margin_type, $result_array)
    {
        $add_margin = new company_category_class();
        $products = array();
        foreach ($result_array as $detail_array) {

            $main_detail = array();

            $main_detail['title'] = $detail_array['title'];
            $main_detail['description'] = $detail_array['description'];
            $main_detail['artwork'] = $detail_array['eventArtwork'];
            $main_detail['banner'] = $detail_array['eventBanner'];
            $main_detail['organizer'] = $detail_array['organizer'];
            $main_detail['organizer_logo'] = $detail_array['organizerLogo'];
            $main_detail['date'] = $detail_array['date'];
            $main_detail['tickets'] = array();

            foreach ($detail_array['ticketClassses'] as $tickets){
                $s_array= array();
                $signal = array();
                $s_array['title'] = $tickets['title'];
                $s_array['price'] = $add_margin->apply_margin($margin, $margin_type, $tickets['price']);
                $s_array['venue'] = $tickets['venue'];
                $signal['item_code'] = $tickets['classid'];
                $signal['rb_partner_id'] = $partner_id;
                $signal['item_name'] = $tickets['title'] ."-".$detail_array['title'];
                $signal['selling_price'] = $s_array['price'];
                $signal['item_price'] = $tickets['price'];
                $signal['is_variant'] = 0;
                $signal['rims_partner_id'] = $this->rims_partner_id;
                $signal['max_quantity'] = 9;
                $s_array['signature'] = $this->string_encrypt(json_encode($signal));
                $main_detail['tickets'][]=$s_array;
            }
            $products[] = $main_detail;
        }

        return $products;
    }




    public function arrange_list_cat_item($partner_id, $margin, $margin_type, $result_array, $item_name){
        $add_margin = new company_category_class();
        $products = array();
        $admin_fee = 100;
        $products['day'] = array();
        foreach ($result_array as $detail_array) {


            $dt = new DateTime($detail_array['date']);
            $date = $dt->format('d-m-Y');
            $time = $dt->format('H:i:s');

            if(!in_array($detail_array['day'],array_column($products['day'],'day'))){

                $day_array['day'] =$detail_array['day'];
                //$day_array['date'] = $detail_array['date'];
                $day_array['date'] = $date;
                $day_array['times']= array();
                //$key2 = array_search($day_array['times'], array_column($detail_array['date'], 'time'));
                $products['day'][] = $day_array;

                $key = array_search($detail_array['day'], array_column($products['day'], 'day'));

            } else {
//
                $key = array_search($detail_array['day'], array_column($products['day'], 'day'));
            }


            $tickets = array();
            $tickets['date_time']= $detail_array['date'];
            $tickets['time']= $time;



            foreach ($detail_array['ticketTypes'] as $key2=> $ticketType) {
                $t_array['type'] = $key2;
                $t_array['price'] = $add_margin->apply_margin($margin, $margin_type, $ticketType['price']);
                $t_array['max_quantity'] = 9;
                $t_array_signal['type'] = $t_array['type'];
                $t_array_signal['t_id']= $ticketType['id'];
                $t_array_signal['item_code'] = $detail_array['id'];
                $t_array_signal['rb_partner_id'] = $partner_id;
                $t_array_signal['item_name'] = $item_name . "-" . $t_array['type'] . "-" . $detail_array['date'];
                $t_array_signal['selling_price'] = $t_array['price'];
                $t_array_signal['item_price'] = $ticketType['price'];
                $t_array_signal['is_variant'] = 0;
                $t_array_signal['rims_partner_id'] = $this->rims_partner_id;
                $t_array_signal['max_quantity'] = 9;
                $t_array['signature'] = $this->string_encrypt(json_encode($t_array_signal));

                $tickets['ticket'][] = $t_array;

            }




            $products['day'][$key]['times'][]= $tickets;
            //$products = $main_detail;
        }



        array_multisort( array_column($products['day'], "date"), SORT_ASC, $products['day'] );

        return $products['day'];
    }


    public function process_transaction($redemption_array, $delivery_array){


        $full_name = $delivery_array['first_name']." ".$delivery_array['last_name'];
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[7]['product_details'][0];
        $ticket_id = $order_item['signature']['item_code'];


        $reference = $order_item['voucher_no'];

        $delivery_type = $order_item['delivery_type'];
        if($delivery_type == 6) {



            if(isset($order_item['signature']['type']) ){


                $type = $order_item['signature']['type'];

                if(isset($order_item['signature']['item_code']) ){

                    $showtime_id = $order_item['signature']['item_code'];

                    if(isset($order_item['signature']['t_id']) ){

                        $ticket_type_id = $order_item['signature']['t_id'];
                    } else {

                        return "Ticket Type ID required";
                    }
                } else {

                    return "Showtime required";
                }
            } else {

                return "Ticket type required";
            }

            $total_ticket = $order_item['quantity'];





            $confirm_order = $this->make_order_cinema($showtime_id, $total_ticket, $full_name, $type, $ticket_type_id,$phone_no, $email, $total_ticket, $reference);

            return $confirm_order;
        } elseif ($delivery_type == 7){

            $quantity = $order_item['quantity'];
            $confirm_order = $this->make_order_event($ticket_id, $phone_no, $email, $quantity, $reference);
//            echo json_encode($confirm_order);
//            echo "<br>";
            return $confirm_order;
        }


        $response_array['status'] = 0;
        $response_array['message'] = "Invalid order";
        $response_array['data'] = array($reference);
        return $response_array;

    }

    public function make_order_cinema($showtime_id, $total_ticket, $full_name, $type, $ticket_type_id,$phone_no, $email, $total_ticket, $reference){

        $end_point = $this->cinema_url."tickets?as=pay";
        $data['auth'] = $this->auth;
        $show_array = array();
        $show_array['showTimeId'] = $showtime_id;
        $data['ticketInfo'] = $show_array;
        $data['totalTickets'] = (int)$total_ticket;
        $user_array = array();
        $user_array['fullname'] = $full_name;
        $user_array['ticketType'] = $type;
        $user_array['ticketTypeId'] = $ticket_type_id;
        $user_array['phone'] = $phone_no;
        $user_array['email'] = $email;
        $user_array['quantity'] = (int)$total_ticket;
        $data['userDetails'] = array();
        $data['userDetails'][] = $user_array;

        $data['reference'] = $reference;

        $send_data = $this->send_post($end_point,json_encode($data),$this->header);
        $this->save_order_request(json_encode($data), json_encode($send_data));

        if(is_array($send_data)){

            if($send_data['status'] ==200){

                $response_array['status'] = 1;
                $response_array['message'] = $send_data['reason'];

                $response_array['data'] = array($reference);
                return $response_array;
            } elseif($send_data['status'] ==400) {

                $response_array['status'] = 0;
                $response_array['message'] = $send_data['message'];
                $response_array['data'] = array($reference);
                return $response_array;
            } else {

                $response_array['status'] = 99;
                $response_array['message'] = "Error Processing. Contact Admin";
                $response_array['data'] = array($reference);
                return $response_array;
            }

        } else {

            $response_array['status'] = 99;
            $response_array['message'] = "Error Processing. Contact Admin";
            $response_array['data'] = array($reference);
            return $response_array;
        }






    }


    public function make_order_event($ticket_id, $phone_no, $email, $quantity, $reference){

        $end_point = $this->start_url."tickets/";
        $data['auth'] = $this->auth;
        $data['classid'] = $ticket_id;
        $data['phone'] = $phone_no;
        $data['email'] = $email;
        $data['qty'] = $quantity;
        $data['reference'] = $reference;

        $send_data = $this->send_post_v3($end_point,$data,$this->header);
        $this->save_order_request(json_encode($data), json_encode($send_data));
        if(is_array($send_data)){

            if($send_data['status'] ==200){

                $response_array['status'] = 1;
                $response_array['message'] = $send_data['message'];
                $response_array['data'] = array($reference);
                return $response_array;
            } else {

                $response_array['status'] = 0;
                $response_array['message'] = $send_data['message'];
                $response_array['data'] = array($reference);
                return $response_array;
            }

        } else {

            $response_array['status'] = 99;
            $response_array['message'] = "Error processing. Contact Admin";
            $response_array['data'] = array($reference);
            return $response_array;
        }






    }



    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }

    public function check_purchase_details ($price, $delivery_type, $quantity, $signature_array){

        if (isset($signature_array['selling_price'])){

            if($price == $signature_array['selling_price']){

                //if(isset($signature_array['item_price'])) {
                $get_purchase = $this->get_purchase_details($signature_array['selling_price'], $signature_array['item_price'], $quantity, $delivery_type);
                return $get_purchase;
//                } else {
//
//                    return "Price Confirmation Error";
//                }
            } else {

                return "Price mismatch";
            }
        } else {

            return "price not set";
        }
    }



    public function get_purchase_details($unit_selling_price, $unit_cost_price, $quantity, $delivery_type)
    {



        if ($delivery_type == 6){

            $cinema_price = $this->cinema_cost_profit($unit_selling_price,$unit_cost_price,$quantity);
            return $cinema_price;

        } else {

            $event_price = $this->event_cost_profit($unit_selling_price,$unit_cost_price,$quantity);
            return $event_price;
        }
    }

    public function cinema_cost_profit($unit_selling_price, $unit_cost_price, $quantity){
        $use_main = new Rewardsbox_main();
        $partner_commission = 60 ; // per quantity
        $total_selling_price = (float)$unit_selling_price * (int)$quantity;
        $total_ini_cost_price = (float)$unit_cost_price * (int)$quantity;
        $rb_profit = $total_selling_price - $total_ini_cost_price;

        $unit_partner_cost = (float)$unit_cost_price - $partner_commission;
        $total_partner_cost = $unit_partner_cost * $quantity;

        $profit_partner = $total_ini_cost_price - $total_partner_cost;

        $total_profit = $profit_partner + $rb_profit;

        $r_array['selling_price'] = $unit_selling_price;
        $r_array['cost_price'] = $use_main->get_unit_cost_price($total_partner_cost, $quantity);
        $r_array['total_cost'] = $total_partner_cost;
        $r_array['profit'] = $total_profit;

        return $r_array;


    }

    public function event_cost_profit($unit_selling_price ,$unit_cost_price, $quantity ){
        $use_main = new Rewardsbox_main();
        $partner_commission = 4 ; // percent
        $total_selling_price = (float)$unit_selling_price * (int)$quantity;
        $total_ini_cost_price = (float)$unit_cost_price * (int)$quantity;
        $rb_profit = $total_selling_price - $total_ini_cost_price;

        $profit_partner = ($partner_commission/100) * $total_ini_cost_price;

        $total_partner_cost = $total_ini_cost_price - $profit_partner;
        $total_profit = $rb_profit + $profit_partner;

        $r_array['selling_price'] = $unit_selling_price;
        $r_array['cost_price'] = $use_main->get_unit_cost_price($total_partner_cost, $quantity);
        $r_array['total_cost'] = $total_partner_cost;
        $r_array['profit'] = $total_profit;

        return $r_array;
    }
}


//$page_test = new nairabox_class();
//echo json_encode(($page_test->get_events_details(8,0,2)));
//echo json_encode($page_test->make_order_event("5b60149ec71c0e2a5c28c62e","08122890094","adeoye@loyaltysolutionsnigeria.com","2","YC7538D975B9G6"));
//echo json_encode($page_test->make_order("5b5f06052f93ae0c7492042d","08122890094","adeoye@loyaltysolutionsnigeria.com",1,0,0,"abc123"));
//echo json_encode($page_test->get_movie_details("123",4,100,"eyJ1aWQiOiI1YjZiMGY5NWUyNmZjMDIyMjgyNTA2NjUiLCJpZCI6IjViNWVmZTJiNmEwNmNlMGJmY2NjN2UzNCJ9"));
//echo json_encode($page_test->get_one_movie("5b5efe2b6a06ce0bfccc7e34"));
//echo json_encode($page_test->get_all_movies());