<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 18/12/2018
 * Time: 13:05
 */
require_once ("main_class.php");
require_once ("portal_user_class.php");
class report_class extends Rewardsbox_main
{

    private $table = "rewardsbox_com_report";
    private $account_table = "rewardsbox_com_account";


    public function create_entry($company_id, $expiry_date){

        $columns = array("company_id", "expiry_date");
        $values = array($company_id, $expiry_date);

        $put_data = $this->insert_data($this->table, $columns, $values);

        if ($put_data > 0) {

            return $put_data;
        } else {

            return 0;
        }

    }


    public function update_customers($company_id,$total_customers){

        $get_total = $this->get_total_customers($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_customers'];

            $new_total = (int)$total_customers + (int)$present_total;

            $update_data = $this->update_total_customers($company_id, $new_total);

            if($update_data == 1){

                return "Total Customer update successful";
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_customers($company_id, $new_total_customers){

        $first_set['column_name'] = "total_customers";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_customers;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_customers($company_id){

        $column = array("total_customers");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_refund_credit($company_id,$total_amount, $remark){
        // tran type bank transfer;
        $this->auto_commit_off();
        $get_total = $this->get_total_top_up($company_id);

        if (is_array($get_total)){

            $present_balance = $get_total[0]['current_balance'];
            $new_balance = (float)$present_balance + (float)$total_amount;

            $update_data = $this->update_refund_balance($company_id,$new_balance);

            if($update_data == 1){

                $put_tran = $this->credit_com_transactions($company_id, $total_amount, $new_balance, $remark);

                if ($put_tran == 1) {
                    $this->commit_now();
                    $s_array['company_id'] = $company_id;
                    $s_array['balance'] = $new_balance;
                    $s_array['amount_credited'] = $total_amount;
                    return $s_array;

                } else {
                    $this->rollback_now();
                    return $put_tran;
                }
            } else {
                $this->rollback_now();
                return "Error updating";
            }
        } else {
            $this->rollback_now();
            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_refund_balance($company_id, $present_balance){


        $first_set['column_name'] = "current_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $present_balance;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }

    public function set_top_up($company_id,$total_amount, $top_up_count=1, $transaction_type){
        // tran type bank transfer;
        $this->auto_commit_off();
        $get_total = $this->get_total_top_up($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_credited'];
            $present_count = $get_total[0]['no_of_top_up'];
            $present_balance = $get_total[0]['current_balance'];
            $new_balance = (float)$present_balance + (float)$total_amount;
            $last_balance = (float)$present_balance + (float)$total_amount;

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$top_up_count;

//            echo $new_total;
//            echo "<br>";
//            echo $new_balance;
//            echo "<br>";
            $update_data = $this->update_total_credit($company_id, $new_total, $new_count, $new_balance, $last_balance);
//            echo $update_data;
//            echo "<br>";
            if($update_data == 1){

                $put_tran = $this->credit_com_transactions($company_id, $total_amount, $new_balance, $transaction_type);

                if ($put_tran == 1) {
                    $this->commit_now();
                    $s_array['company_id'] = $company_id;
                    $s_array['balance'] = $new_balance;
                    $s_array['amount_credited'] = $total_amount;
                    return $s_array;

                } else {
                    $this->rollback_now();
                    return $put_tran;
                }
            } else {
                $this->rollback_now();
                return "Error updating";
            }
        } else {
            $this->rollback_now();
            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_credit($company_id, $new_total_credited, $credit_count,$present_balance, $last_balance){

        $first_set['column_name'] = "total_credited";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_credited;
        $set[] = $first_set;

        $first_set['column_name'] = "no_of_top_up";
        $first_set['sign'] = "=";
        $first_set['value'] = $credit_count;
        $set[] = $first_set;

        $first_set['column_name'] = "current_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $present_balance;
        $set[] = $first_set;

        $first_set['column_name'] = "last_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $last_balance;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }

    public function set_debit_reversal ($company_id, $credit_amount, $member_id, $remark = "Credit from member account"){
        $this->auto_commit_off();


        $update_portal = $this->set_portal_refund($company_id, $credit_amount);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($update_portal)){

                $new_balance= $update_portal['balance'];

                $put_tran = $this->credit_com_transactions($company_id, $credit_amount,$new_balance,$remark,$member_id);

                if ($put_tran == 1) {
                    $this->commit_now();
                    return $put_tran;

                } else {
                    $this->rollback_now();
                    return $put_tran;
                }


        } else {
            $this->rollback_now();
            return $update_portal;
        }
    }


    public function set_debit($company_id,$total_amount, $debit_count=1, $remark, $member_id,  $portal_access = 0){

        $this->auto_commit_off();


        $get_total = $this->get_total_debit($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_debit'];
            $present_count = $get_total[0]['no_of_debit'];
            $present_balance = $get_total[0]['current_balance'];

            $new_balance = (float)$present_balance - (float)$total_amount;


            if ($get_total[0]['payment_type'] == 1 && $new_balance < 0){
                $this->rollback_now();
                return "Insufficient funds to process";

            } else {
                $new_total = (float)$total_amount + (float)$present_total;
                $new_count = (int)$present_count + (int)$debit_count;

                $update_data = $this->update_total_debited($company_id, $new_total, $new_count, $new_balance);

                if ($update_data == 1) {

                    //$remark = "Transfer to member account";
                    $put_tran = $this->debit_com_transactions($company_id, $total_amount, $new_balance, $remark, $member_id);
                    if ($put_tran == 1) {

                        if ($portal_access == 1) {

                            $use_portal = new portal_user_class();
                            $transfer_data = $use_portal->rb_credit_user($member_id, $total_amount);
                            if (is_array($transfer_data)) {
                                $this->commit_now();
                                return $transfer_data;
                            } else {

                                return $transfer_data;
                            }
                        } else {
                            $this->commit_now();
                            $s_array['balance'] = $new_balance;
                            $s_array['amount_debited'] = $new_total;
                            return $s_array;
                            
                        }
                    } else {
                        $this->rollback_now();
                        return $put_tran;
                    }
                } else {
                    $this->rollback_now();
                    return "Error updating";
                }
            }
        } else {
            $this->rollback_now();
            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_debited($company_id, $new_total_debited, $debit_count,$present_balance){

        $first_set['column_name'] = "total_debit";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_debited;
        $set[] = $first_set;

        $first_set['column_name'] = "no_of_debit";
        $first_set['sign'] = "=";
        $first_set['value'] = $debit_count;
        $set[] = $first_set;

        $first_set['column_name'] = "current_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $present_balance;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }

    public function get_total_debit($company_id){

        $column = array("total_debit","no_of_debit","current_balance","payment_type");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_manual_debit($company_id,$total_amount,$remark){

        $this->auto_commit_off();
        $get_total = $this->manual_total_debit($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['manual_debit_value'];
            $present_balance = $get_total[0]['current_balance'];

            $new_balance = (float)$present_balance - (float)$total_amount;

            if ($get_total[0]['payment_type'] == 1 && $new_balance < 0){
                $this->rollback_now();
                return "Insufficient funds to process";

            } else {
                $new_total = (float)$total_amount + (float)$present_total;


                $update_data = $this->update_manual_debited($company_id, $new_total,$new_balance);

                if ($update_data == 1) {

                    //$remark = "Manual debit";
                    $put_tran = $this->debit_com_transactions($company_id, $total_amount, $new_balance, $remark, 0);
                    if ($put_tran == 1) {
                        $this->commit_now();
                        $s_array['company_id'] = $company_id;
                        $s_array['balance'] = $new_balance;
                        $s_array['amount_debited'] = $total_amount;
                        return $s_array;
                    } else {
                        $this->rollback_now();
                        return $put_tran;
                    }
                } else {
                    $this->rollback_now();
                    return "Error updating";
                }
            }
        } else {
            $this->rollback_now();
            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_manual_debited($company_id, $new_total_manual_debited, $present_balance){

        $first_set['column_name'] = "manual_debit_value";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_manual_debited;
        $set[] = $first_set;

        $first_set['column_name'] = "current_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $present_balance;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }

    private function manual_total_debit($company_id){

        $column = array("manual_debit_value", "current_balance","payment_type");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    private function get_total_top_up($company_id){

        $column = array("total_credited","no_of_top_up","current_balance");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_api_redemption($company_id, $total_amount,$item_count, $order_no){
        $remark ="Redemption: Order no ".$order_no;
        $debit_account = $this->set_debit($company_id,$total_amount,1,$remark,0,0);

        if(is_array($debit_account)){
                $this->set_redemption($company_id, $total_amount,$item_count);
                return $debit_account;

        } else {

            return $debit_account;
        }


    }


    public function set_api_refund($company_id, $total_amount,$item_count, $order_no, $item_name, $type){

        // 1- cancel 2- expire 3- failed
        if($type == 1 || $type == 2 || $type == 3) {

            if($type == 1) {
                $remark ="Cancellation: Order no ".$order_no." - ".$item_name."(".$item_count.")";
                $credit_account = $this->set_refund_credit($company_id,$total_amount,$remark);
                if (is_array($credit_account)) {
                    $this->set_cancelled($company_id, $total_amount, $item_count);
                    return $credit_account;

                } else {

                    return $credit_account;
                }
            } elseif ($type == 2) {

                $remark ="Expired: Order no ".$order_no." - ".$item_name."(".$item_count.")";
                $credit_account = $this->set_refund_credit($company_id,$total_amount,$remark);
                if (is_array($credit_account)) {
                    $this->set_expired($company_id, $total_amount, $item_count);
                    return $credit_account;

                } else {

                    return $credit_account;
                }
            } elseif ($type == 3) {

                $remark ="Failed: Order no ".$order_no." - ".$item_name."(".$item_count.")";
                $credit_account = $this->set_refund_credit($company_id,$total_amount,$remark);
                if (is_array($credit_account)) {
                    $this->set_failed($company_id, $total_amount, $item_count);
                    return $credit_account;

                } else {

                    return $credit_account;
                }
            } else {

                return "Invalid type sent";
            }
        } else {

            return "Invalid type";
        }

    }

    public function set_redemption($company_id,$total_amount, $item_count){

        $get_total = $this->get_total_redemption($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_redemption_value'];
            $present_count = $get_total[0]['total_redemptions'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$item_count;

            $update_data = $this->update_total_redemption($company_id, $new_total, $new_count);

            if($update_data == 1){
                $s_array ['total_redemption_value'] =$present_total;
                $s_array['amount'] = $total_amount;
                return $s_array;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_redemption($company_id, $new_total_purchase, $item_count){

        $first_set['column_name'] = "total_redemption_value";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_purchase;
        $set[] = $first_set;

        $first_set['column_name'] = "total_redemptions";
        $first_set['sign'] = "=";
        $first_set['value'] = $item_count;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_redemption($company_id){

        $column = array("total_redemption_value","total_redemptions");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }


    public function set_opening_balance($company_id, $balance){

        $first_set['column_name'] = "opening_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $balance;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return "Opening balance updated successfully";
        } else {

            return "No data found";
        }


    }


    public function set_expiry($company_id, $expiry_date){

        $first_set['column_name'] = "expiry_date";
        $first_set['sign'] = "=";
        $first_set['value'] = $expiry_date;
        $set[] = $first_set;

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return "Expiry update successfully";
        } else {

            return "No data found";
        }


    }

    public function view_report(){
        $columns = array("company_name","user_mgt_company.status","total_credited",$this->table.".create_date","expiry_date","no_of_top_up","total_customers","total_redemptions","opening_balance","total_redemption_value","total_cancel_value","total_cancel","total_expire_value","total_expired","current_balance", "total_debit", "no_of_debit", "name", "total_settled_value", "total_profit", "(total_debit - customer_refund + manual_debit_value) AS net_debit", "(total_redemptions - total_cancel - total_expired) AS net_redemption_count", "(total_redemption_value - total_expire_value - total_cancel_value) AS net_redemption_value");

        $firstjoin ['table_name'] = "user_mgt_company";
        $firstjoin ['first_column'] = "user_mgt_company.company_id";
        $firstjoin ['second_column'] = $this->table . ".company_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "rewardsbox_payment_type";
        $firstjoin ['first_column'] = "rewardsbox_payment_type.payment_id";
        $firstjoin ['second_column'] = $this->table . ".payment_type";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table,$columns,"","","","","","",$leftjoin);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }

    public function send_account_utilization(){
        $use_mail = new send_mail_class();
        $check_balance = $this->view_active_balance();

        if (is_array($check_balance)){

            $e_array = array();
            foreach ($check_balance as $balance){

                //$client_no = $balance['client_no'];
                 $current_balance =$balance['current_balance'];
                 $util =floor($balance['utilization']);
                 $email =$balance['email'];
                 $company_name = $balance['company_name'];

                 if ($util >= 85){


//                     echo $current_balance;
//                     echo "<br>";

                    if($util >= 85 ) {

                        $send_mail = $use_mail->utilization_reminder($company_name, $util, $current_balance, $email);
                        $se_array['company'] = $company_name;
                        $se_array['data'] = $send_mail;
                        $e_array[] = $se_array;

//                    } elseif ($util == 99){
//
//                        $send_mail = $use_mail->utilization_reminder($company_name, 99,$current_balance,$email);
//                        $se_array['company'] =$company_name;
//                        $se_array['data'] = $send_mail;
//                        $e_array[] = $se_array;
//                    }
                    }else {

                        $e_array[] = $company_name." Invalid utilization value";
                    }
                 } else {

                     $e_array[] = "No send ".$company_name." utilization ".$util."%";

                 }
            }
            return $e_array;
        } else {

            return "No active Company found";
        }

    }



    public function view_active_balance($company_id = null){
        $columns = array($this->table.".company_id","company_name", "email","client_no","expiry_date","current_balance", "name", "last_balance","(((last_balance - current_balance)/last_balance)* 100) AS utilization", "total_credited","(total_debit + manual_debit_value - customer_refund) AS net_debit");

        $firstjoin ['table_name'] = "user_mgt_company";
        $firstjoin ['first_column'] = "user_mgt_company.company_id";
        $firstjoin ['second_column'] = $this->table . ".company_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "user_mgt_com_details";
        $firstjoin ['first_column'] = "user_mgt_com_details.company_id";
        $firstjoin ['second_column'] = $this->table . ".company_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "rewardsbox_payment_type";
        $firstjoin ['first_column'] = "rewardsbox_payment_type.payment_id";
        $firstjoin ['second_column'] = $this->table . ".payment_type";
        $leftjoin [] = $firstjoin;

        $ci_where['column_name'] = "user_mgt_company.status";
        $ci_where['sign'] = "=";
        $ci_where['value'] = 1;

        $where[] = $ci_where;

        if($company_id != null || $company_id!="") {
            $p_where['column_name'] = $this->table . ".company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;
        }

        $get_data = $this->select_tb($this->table,$columns,$where,"","","","","",$leftjoin);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }



    public function set_cancelled($company_id,$total_amount, $item_count){

        $get_total = $this->get_total_cancel($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_cancel_value'];
            $present_count = $get_total[0]['total_cancel'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$item_count;

            $update_data = $this->update_total_cancel($company_id, $new_total, $new_count);

            if($update_data == 1){

                return $update_data;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_cancel($company_id, $new_total_cancel, $item_count){

        $first_set['column_name'] = "total_cancel_value";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_cancel;
        $set[] = $first_set;

        $first_set['column_name'] = "total_cancel";
        $first_set['sign'] = "=";
        $first_set['value'] = $item_count;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_cancel($company_id){

        $column = array("total_cancel_value","total_cancel");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_expired($company_id,$total_amount, $item_count){

        $get_total = $this->get_total_expired($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_expire_value'];
            $present_count = $get_total[0]['total_expired'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$item_count;

            $update_data = $this->update_total_expired($company_id, $new_total, $new_count);

            if($update_data == 1){

                return $update_data;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_expired($company_id, $new_total_cancel, $item_count){

        $first_set['column_name'] = "total_expire_value";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_cancel;
        $set[] = $first_set;

        $first_set['column_name'] = "total_expired";
        $first_set['sign'] = "=";
        $first_set['value'] = $item_count;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_expired($company_id){

        $column = array("total_expire_value","total_expired");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_failed($company_id,$total_amount, $item_count){

        $get_total = $this->get_total_failed($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_failed_value'];
            $present_count = $get_total[0]['total_failed'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$item_count;

            $update_data = $this->update_total_failed($company_id, $new_total, $new_count);

            if($update_data == 1){

                return $update_data;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_failed($company_id, $new_total_failed, $item_count){

        $first_set['column_name'] = "total_failed_value";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_failed;
        $set[] = $first_set;

        $first_set['column_name'] = "total_failed";
        $first_set['sign'] = "=";
        $first_set['value'] = $item_count;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_failed($company_id){

        $column = array("total_failed_value","total_failed");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_portal_refund($company_id,$total_amount){
        // manual debit customer refund company
        $get_total = $this->get_total_portal_refund($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['customer_refund'];
            $balance = $get_total[0]['current_balance'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_balance = (float)$balance + (float)$total_amount;

            $update_data = $this->update_total_portal_refund($company_id, $new_total,$new_balance);

            if(is_array($update_data)){

                return $update_data;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_portal_refund($company_id, $new_total_refund, $balance){

        $first_set['column_name'] = "customer_refund";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_refund;
        $set[] = $first_set;

        $first_set['column_name'] = "current_balance";
        $first_set['sign'] = "=";
        $first_set['value'] = $balance;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            $s_array['balance'] = $balance;
            $s_array['amount'] = $new_total_refund;
            return $s_array;
        } else {

            return "No data found";
        }


    }
    private function get_total_portal_refund($company_id){

        $column = array("current_balance", "customer_refund");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function set_total_settled($company_id,$settle_amount, $quantity, $profit){

        $get_total = $this->get_total_settled($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_settled_value'];
            $present_items = $get_total[0]['no_items_settled'];
            $present_profit = $get_total[0]['total_profit'];


            $new_total = (float)$settle_amount + (float)$present_total;
            $new_total_items = (float)$quantity + (float)$present_items;
            $new_total_profit = (float)$profit + (float)$present_profit;

            $update_data = $this->update_total_settled($company_id, $new_total,$new_total_items, $new_total_profit);

            if($update_data == 1){

                return "Total Customer update successful";
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_settled($company_id, $new_total, $quantity, $new_profit){

        if(isset($company_id) && isset($new_total) && isset($quantity) && isset($new_profit) && $new_total > 0 && $quantity > 0) {
            $first_set['column_name'] = "total_settled_value";
            $first_set['sign'] = "=";
            $first_set['value'] = $new_total;
            $set[] = $first_set;

            $first_set['column_name'] = "no_items_settled";
            $first_set['sign'] = "=";
            $first_set['value'] = $quantity;
            $set[] = $first_set;

            $first_set['column_name'] = "total_profit";
            $first_set['sign'] = "=";
            $first_set['value'] = $new_profit;
            $set[] = $first_set;

            $ci_where['column_name'] = "company_id";
            $ci_where['sign'] = "=";
            $ci_where['value'] = $company_id;

            $where[] = $ci_where;

            $update_data = $this->update_data($this->table, $set, $where);

            if ($update_data == 1) {

                return $update_data;
            } else {

                return "No data found";
            }
        } else {

            return "Invalid parameters";
        }

    }
    private function get_total_settled($company_id){

        $column = array("total_settled_value", "no_items_settled", "total_profit");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }


    private function insert_com_transactions ($company_id, $amount_in, $amount_out, $balance, $tran_type, $description= null, $member_id = null){
        // 1 credit 2 debit

        $columns = array("company_id","amount_in","amount_out","balance","tran_type","member_id","remark");
        $values = array($company_id, $amount_in,$amount_out, $balance, $tran_type, $member_id, $description);

        $put_data = $this->insert_data($this->account_table, $columns, $values);

        if (is_numeric($put_data) && $put_data > 0) {

            return 1;
        } else {

            return "Error saving transaction";
        }




    }


    public function credit_com_transactions($company_id, $amount_in, $balance, $remark,$member_id = 0){

        if(isset($company_id) && isset($amount_in) && isset($balance) && isset($remark)){

            if (is_numeric($amount_in) && is_numeric($balance)  && $amount_in >0 && $balance >=0){

                $credit_com = $this->insert_com_transactions($company_id,$amount_in, 0,$balance,1, $remark,$member_id);
                return $credit_com;

            } else {

                return "Invalid amount or balance";
            }

        } else {

            return "Missing parameters";
        }

    }


    public function debit_com_transactions($company_id, $amount_out, $balance, $remark, $member_id){

        if(isset($company_id) && isset($amount_out) && isset($balance) && isset($remark)){

            if (is_numeric($amount_out) && is_numeric($balance)  && $amount_out >0){

                $debit_com = $this->insert_com_transactions($company_id,0, $amount_out,$balance,2, $remark, $member_id);
                return $debit_com;

            } else {

                return "Invalid amount or balance";
            }

        } else {

            return "Missing parameters";
        }

    }

    public function view_com_transactions($company_id = null, $start_date=null, $end_date=null, $type = null)
    {

        $columns = array("account_id", "company_name", $this->account_table . ".create_date", "tran_type", "amount_in", "amount_out", "balance", "remark");


        $firstjoin ['table_name'] = "user_mgt_company";
        $firstjoin ['first_column'] = "user_mgt_company.company_id";
        $firstjoin ['second_column'] = $this->account_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $where= null;

        if($company_id != null || $company_id!="") {
            $p_where['column_name'] = $this->account_table . ".company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;
        }

        if($type != null || $type!="" || $type == 1 || $type == 2) {
            if ($type == 1) { // credit
                $p_where['column_name'] = $this->account_table . ".tran_type";
                $p_where['sign'] = "=";
                $p_where['value'] = $type;
                $where[] = $p_where;
            } elseif ($type == 2) {//debit

                $p_where['column_name'] = $this->account_table . ".tran_type";
                $p_where['sign'] = "=";
                $p_where['value'] = $type;
                $where[] = $p_where;

            }
        }


        if($start_date != null || $start_date!=""){

            if($end_date != null || $end_date!=""){

                $p_where['column_name'] = $this->account_table.".create_date";
                $p_where['sign'] = ">=";
                $p_where['value'] = $start_date;
                $where[] = $p_where;

                $p_where['column_name'] = $this->account_table.".create_date";
                $p_where['sign'] = "<=";
                $p_where['value'] = $end_date;
                $where[] = $p_where;
            }



        }


        $get_data = $this->select_tb($this->account_table, $columns, $where, "", "", "", "", "", $leftjoin);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }
    }

    public function totals_com_transactions($company_id, $start_date=null, $end_date=null, $type = null){

        if(isset($company_id)) {
            $get_totals = $this->view_active_balance($company_id);

            if (is_array($get_totals)) {

                $d_array['current_balance'] = $get_totals[0]['current_balance'];
                $d_array['total_credit'] = $get_totals[0]['total_credited'];
                $d_array['total_debit'] = $get_totals[0]['net_debit'];

                $get_tran = $this->view_com_transactions($company_id, $start_date, $end_date, $type);

                if (is_array($get_tran)) {

                    $d_array['data'] = $get_tran;
                    return $d_array;
                } else {

                    return $get_tran;
                }

            } else {

                return $get_totals;
            }


        } else {

            return "No company sent";
        }
    }
    
    public function set_forfeit($company_id,$total_amount, $item_count){

        $get_total = $this->get_total_forfeit($company_id);

//        echo json_encode($get_total);
//        echo "<br>";
        if (is_array($get_total)){

            $present_total = $get_total[0]['total_forfeit'];
            $present_count = $get_total[0]['no_of_forfeit'];

            $new_total = (float)$total_amount + (float)$present_total;
            $new_count = (int)$present_count + (int)$item_count;

            $update_data = $this->update_total_forfeit($company_id, $new_total, $new_count);

            if($update_data == 1){

                return $update_data;
            } else {

                return "Error updating";
            }
        } else {

            return "Invalid Company";
        }


        //$update_data = $this->update_data($this->table, $set, $where);
    }

    private function update_total_forfeit($company_id, $new_total_cancel, $item_count){

        $first_set['column_name'] = "total_forfeit";
        $first_set['sign'] = "=";
        $first_set['value'] = $new_total_cancel;
        $set[] = $first_set;

        $first_set['column_name'] = "no_of_forfeit";
        $first_set['sign'] = "=";
        $first_set['value'] = $item_count;
        $set[] = $first_set;


        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;

        $update_data = $this->update_data($this->table, $set, $where);

        if($update_data == 1){

            return $update_data;
        } else {

            return "No data found";
        }


    }
    private function get_total_forfeit($company_id){

        $column = array("total_forfeit","no_of_forfeit");

        $ci_where['column_name'] = "company_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $company_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

}


//$page_test = new report_class();
//echo json_encode($page_test->set_failed(10, 1000, 1));
//echo json_encode($page_test->totals_com_transactions(10,"","",2));
//echo json_encode($page_test->set_debit_reversal(10,500,1));
//echo json_encode($page_test->send_account_utilization());
//echo json_encode($page_test->view_com_transactions("","","",2));
//echo json_encode($page_test->view_active_balance());
//echo json_encode($page_test->set_debit(10, 800));
//echo json_encode($page_test->set_expired(10,1000,1));
//echo json_encode($page_test->set_cancelled(10,500,1));
//echo json_encode($page_test->view_report());
//echo json_encode($page_test->set_opening_balance(10,300));
//echo json_encode($page_test->set_expiry(10, "2019-01-30"));
//echo json_encode($page_test->set_redemption(10,2000,2));
//echo json_encode($page_test->set_top_up(12, 500000,"",1));
//echo json_encode($page_test->update_customers(10,20));