<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 13/12/2018
 * Time: 10:54
 */

require_once ("curl_class.php");
require_once ("database_class.php");
require_once ("company_category_class.php");
class seamfix_class extends curl_class
{

    private $start_url = "https://fuelvoucher.com.ng/ws/rest/app/voucher/purchase";
    private $station_url ="https://fuelvoucher.com.ng/ws/rest/app/dealer/stations/list";
    private $pump_image = "https://www.rewardsboxnigeria.com/rewardsbox/img/station.png";
    private $file_url = "https://rewardsbox.perxclm.com/rewardsbox_app/v1/json/";
    private $user ="08122890094";
    private $password = "fuel4life@19";
    private $rims_partner_id = 132;
    private $log_table = "seamfix_order_log";
    private $header = array('content-type: application/json');


    public function get_service_products ($partner_id, $margin, $margin_type){

        $result_array[0]['amount'] = 500;
        $result_array[0]['name'] = "Fuel Voucher (500)";
        $result_array[0]['code'] = "sx-500";
        $run_array[] = $result_array[0];

        $result_array[0]['amount'] = 1000;
        $result_array[0]['name'] = "Fuel Voucher (1000)";
        $result_array[0]['code'] = "sx-1000";
        $run_array[] = $result_array[0];

        $result_array[0]['amount'] = 2000;
        $result_array[0]['name'] = "Fuel Voucher (2000)";
        $result_array[0]['code'] = "sx-2000";
        $run_array[] = $result_array[0];

        $result_array[0]['amount'] = 5000;
        $result_array[0]['name'] = "Fuel Voucher (5000)";
        $result_array[0]['code'] = "sx-5000";
        $run_array[] = $result_array[0];

        $result_array[0]['amount'] = 10000;
        $result_array[0]['name'] = "Fuel Voucher (10000)";
        $result_array[0]['code'] = "sx-10000";
        $run_array[] = $result_array[0];

        $result_array[0]['amount'] = 20000;
        $result_array[0]['name'] = "Fuel Voucher (20000)";
        $result_array[0]['code'] = "sx-20000";
        $run_array[] = $result_array[0];



        foreach ($run_array as $detail_array){
            $signal = array();
            $signal['item_code'] = $detail_array['code'];
            $signal['rb_partner_id'] = $partner_id;
//            if($partner_cat_id == 905){
//
//                $detail_array['amount'] = 500000;
//            }
            $signal['item_price'] = (float)$detail_array['amount'] ;
            $signal['item_name'] = $detail_array['name'];

//            $signal['is_variant'] = 0;
//            $signal['max_quantity'] = 1;






            $add_margin = new company_category_class();
            $main_detail = array();

            $main_detail['product_name'] = $detail_array['name'];
            if (isset($detail_array['item_desc'])) {
                $main_detail['description'] = $detail_array['item_desc'];
            } else {

                $main_detail['description'] ="";
            }

            $main_detail['max_quantity'] = 1;
            $main_detail['price'] = $add_margin->apply_margin($margin, $margin_type,$signal['item_price']);
            $signal['selling_price'] = $main_detail['price'];
            $signal['cost_price'] = $signal['item_price'];


            $signal['rims_partner_id'] = $this->rims_partner_id;

            //echo json_encode($signal);
            //echo "<br>";

            $main_detail['signature'] = $this->string_encrypt(json_encode($signal));


            if ($signal['selling_price'] >= $signal['item_price']){


                $products[] = $main_detail;

            }






        }

        return $products;
    }

    private function set_header() {

        $this->header=array(
            'Content-Type:application/x-www-form-urlencoded',
            'Authorization: Basic '. base64_encode($this->user.":".$this->password)
        );

    }

    private function build_body($amount, $payment_mode, $mobile_no, $email) {
        $return_string= "";
        if(is_numeric($amount) && $amount > 0){

            $return_string= "amount=".$amount;
        } else {

            return "Invalid Amount";
        }

        if($payment_mode == ""){

            return "Blank Payment mode";
        } else {

            $return_string = $return_string."&paymentMode=".$payment_mode;
        }

        if($mobile_no == "") {

            return "Blank Mobile";
        }elseif (!is_numeric($mobile_no)){

            return "Invalid Mobile no";
        } else {

            //$return_array['beneficiaryMobileNumber'] = $mobile_no;
            $return_string = $return_string."&beneficiaryMobileNumber=".$mobile_no;
        }



        if($email == "") {

            return "Blank Email";
        }elseif (filter_var($email, FILTER_VALIDATE_EMAIL)){

            //$return_array['beneficiaryEmail'] = $email;
            $return_string = $return_string."&beneficiaryEmail=".$email;
        } else {

            return "Invalid Email";
        }

        $return_array['status'] = 1;
        $return_array['string'] = $return_string;
//        echo $return_string;
//        echo "<br>";
        return $return_array;
    }


    private function send_transaction($body, $reference){
        $this->set_header();
        $send_data = $this->send_post($this->start_url,$body,$this->header);
        //$send_data = $this->send_post($end_point,json_encode($data),$this->header);
        $this->save_order_request($body, json_encode($send_data));


        if(is_array($send_data)){

            if($send_data['response_code'] == "success"){

                $response_array['status'] =  1;
                $response_array['message'] =  "success Voucher: ".$send_data['voucher_number']." with amount: ".$send_data['voucher_amount'];
                $response_array['voucher_no'] =  $send_data['voucher_number'];
                $response_array['amount'] = $send_data['voucher_amount'];
                $response_array['data'] = array($reference);

            } else {

                $response_array['status'] =  0;
                $response_array['message'] =  $send_data['response_code'];
                $response_array['data'] = array($reference);

            }

        } else {

            $response_array['status'] =  0;
            $response_array['message'] = $send_data;
        }

        //echo json_encode($response_array);
        //echo "<hr>";
        return $response_array;
    }

    public function get_fuel_voucher($amount, $mobile_no, $email, $reference){

        $payment_mode = "WALLET";
        $check_data = $this->build_body($amount, $payment_mode, $mobile_no, $email);
        if (is_array($check_data)){

            $send_data = $this->send_transaction($check_data['string'], $reference);

            return $send_data;

        } else {

            return $check_data;
        }

    }



    public function process_transaction($redemption_array, $delivery_array){

//echo json_encode($redemption_array);
//echo "<br>";
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[8]['product_details'][0];



        $quantity = $order_item['quantity'];
        //$payment_code = $order_item['signature']['item_code'];

        $price = $order_item['signature']['cost_price'];
        $total_price = (float)$price * (int)$quantity;
        $reference = $order_item['voucher_no'];


        $confirm_order = $this->get_fuel_voucher($total_price, $phone_no, $email, $reference);

        return $confirm_order;




    }

    public function get_fuel_stations($cat_id){

        //$this->set_header();
        //$send_data = $this->send_get($this->station_url,$this->header);
        $data = file_get_contents($this->file_url."fuel_stations.json");
        $send_data = json_decode($data,true);
        if (is_array($send_data)){
            $fuel_array = array();

            foreach($send_data as $fuel_data){

                $fuel_data['image'] = $this->pump_image;
                $fuel_data['id'] = $cat_id;

//                echo json_encode($fuel_data);
//                echo "<br>";
                $fuel_array[]= $fuel_data;
            }

            return $fuel_array;

        } else {

            return "No data found";
        }

        //return $send_data;


    }


    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }
}


//$page_test = new seamfix_class();
//echo json_encode($page_test->get_fuel_stations(213));
//echo json_encode($page_test->get_service_products(8,100,2));
//echo json_encode($page_test->get_fuel_voucher(2000,"08122890094","adeoye1225@gmail.com"));