<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 27/09/2018
 * Time: 09:06
 */
require_once("database_class.php");



class shipping_class extends Database
{


    private $table_weight_master = "lsl_weight_master";
    private $table_delivery_price = "lsl_delivery_price_master";
    private $table_state = "lsl_state_master";

    public function  get_multi_state_price($state_product_array){
        $total_price = 0;
        foreach ($state_product_array as $product_array){

            $get_state_price = $this->get_state_price($product_array['from_state'],$product_array['to_state'],$product_array['product_details']);

                if (is_array($get_state_price)) {
                    $state_price = $get_state_price['Weight_range_price'];
                    $total_price = $total_price + $state_price;
                } else {

                    return $get_state_price;
                }
        }

        return $total_price;

    }

    public function get_state_price($from_state, $to_state, $product_details){

        if (is_numeric($from_state) && is_numeric($to_state) && is_array($product_details)){

            //return "ok";
            $state_array = array($from_state, $to_state);

            $check_states = $this->multi_state_check($state_array);

            if (is_array($check_states)) {

                //return $check_states;
                $get_total_weight = $this->total_state_weight($product_details);

                if (is_numeric($get_total_weight)) {

                    $get_weight_id = $this->get_weight_id($get_total_weight);

                        if (is_array($get_weight_id)) {

                            $weight_id = $get_weight_id['Weight_id'];

                            $get_price = $this->get_weight_price($from_state, $to_state, $weight_id);

                            if (is_numeric($get_price)){

                                return $get_price;
                            } else {

                                return $get_price;
                            }
                        } else {

                            return $get_weight_id;
                        }
                } else {

                    return $get_total_weight;
                }

            } else {

                return $check_states;
            }


        } else {

            return "Invalid data sent";
        }


    }



    public function multi_state_check ($state_array){

        foreach ($state_array as $check_state ){

            $get_state = $this -> check_state($check_state);

            if (is_array($get_state)){

                $state_name [] = $get_state['State_name'];


            } else {

                return "Invalid state passed";
            }


        }

        return $state_name;

    }

    public function check_state($state_id){

        $column = array("State_name");

        $w_where['column_name'] ="State_id";
        $w_where['sign'] ="=";
        $w_where['value'] =$state_id;
        $where[] = $w_where;

         $check_state = $this->select_tb($this->table_state, $column, $where);

         if (is_array($check_state)){

             return $check_state['data'][0];
         } else {

             return "No state found";
         }



    }

    public function get_weight_id ($weight){
        //SELECT * FROM lsl_weight_master WHERE 5.9 BETWEEN Weight_start_range AND Weight_end_range
        if(is_numeric($weight)){

            $column = array("Weight_id","Weight_start_range","Weight_end_range");
            $w_where['column_name'] =$weight;
            $w_where['sign'] ="BETWEEN";
            $w_where['value'] =array("Weight_start_range","Weight_end_range");
            $where[] = $w_where;

               $get_weight_id = $this->select_tb($this->table_weight_master,$column,$where);

               if(is_array($get_weight_id)){

                   return $get_weight_id['data'][0];
               } else {
                   return "No weight found";
               }

        } else {

            return "invalid weight";
        }
    }


    public function get_weight_price ($from_state, $to_state, $weight_id){

        $column = array("Price_id","Weight_range_price");
        $w_where['column_name'] ="Weight_id";
        $w_where['sign'] ="=";
        $w_where['value'] =$weight_id;
        $where[] = $w_where;

        $w_where['column_name'] ="State_from";
        $w_where['sign'] ="=";
        $w_where['value'] =$from_state;
        $where[] = $w_where;

        $w_where['column_name'] ="State_to";
        $w_where['sign'] ="=";
        $w_where['value'] =$to_state;
        $where[] = $w_where;

        $get_weight_price = $this->select_tb($this->table_delivery_price,$column, $where);

        if (is_array($get_weight_price)){

            return $get_weight_price['data'][0];

        } else {

            return "No data found";
        }

    }

    public function total_weight ($weight, $quantity){

        $total_weight = (float)$weight * (int)$quantity;
        return $total_weight;
    }


    public function total_state_weight ($weight_array){
        $all_total_weight = 0;
        if (is_array($weight_array)) {

            foreach ($weight_array as $weight){
                if (isset($weight['weight']) || isset($weight['quantity'])|| isset($weight['product_name'])){

                    if ($weight['weight'] == "" || !is_numeric($weight['weight'])) {

                        return "Invalid weight parameter in array";
                        }
                     elseif ($weight['quantity'] == "" || !is_numeric($weight['quantity'])){
                         return "Invalid quantity parameter in array";
                     }  elseif ($weight['product_name'] == ""){

                        return "Blank product name parameter in array";

                    } else{
                        //return "ok";
                        $total_weight = $this->total_weight($weight['weight'], $weight['quantity']);

                        $all_total_weight = (float)$total_weight + $all_total_weight;

                    }

                } else {

                    return "Invalid parameter sent in array";
                }



            }

            return $all_total_weight;
        } else {

            return "Invalid data";
        }

    }



} // class end






//$page_test = new shipping_class();
//
//$one_array['product_name'] = "Test Product";
//$one_array['quantity'] = 5;
//$one_array['weight'] = 0.5;
//$w_array []=$one_array;
//
//
//$one_array['product_name'] = "Test Product2";
//$one_array['quantity'] = 1;
//$one_array['weight'] = 1;
//$w_array []=$one_array;
//
//$first_array['from_state'] = 7;
//
//$first_array['to_state'] = 14;
//$first_array['product_details'] = $w_array;
//$main_array [] = $first_array;
//
//$second_array['from_state'] = 7;
//$second_array['to_state'] = 7;
//$second_array['product_details'] = $w_array;
//
//$main_array[] = $second_array;
//
////echo json_encode($main_array);
//
//
//
////echo json_encode($page_test->total_state_weight( $w_array));
////echo json_encode($page_test->get_weight_price(7,7,12));
////echo json_encode($page_test->get_weight_id(5.9));
////echo json_encode($page_test->get_state_price(7,14,$w_array));
////echo json_encode($page_test->check_state(500));
////echo json_encode($page_test->multi_state_check(array("10","7")));
//echo json_encode($page_test->get_multi_state_price($main_array));