<?php
require_once("main_class.php");
require_once("pages_class.php");
require_once("permission_class.php");


class Reward_user_role extends Rewardsbox_main {

    private $role_table = "user_mgt_roles";



    public function create_role ($role_name){

        $columns = array("role_name", "status");
        $values = array($role_name,"1");

        $thirdwhere['column_name'] ="role_name";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$role_name;
        $where[] = $thirdwhere;

        $create_role = $this->insert_check_duplicate($this->role_table,$columns, $values, $where);
        if ($create_role > 0){

            $open_pages = new Create_pages();
            $open_permissions = new Reward_permission();
            $get_pages = $open_pages->view_all_pages();

            if (is_array($get_pages)) {

                $error_page = array();
                foreach ($get_pages as $page) {

                    $create_permission = $open_permissions->create_permission($page['page_id'], $create_role,0,0,0,0);
                    if ($create_permission < 1){

                        $error_page[] =$page['page_name'];
                    }
                }

                $error_length = count($error_page);
                if ($error_length >0) {

                    return "Role Created .. Errors ".json_encode($error_page);
                }else {

                    $insert_array['id'] = $create_role;
                    $insert_array['name'] = $role_name;

                    return $insert_array;

                }

            } else {
                return "Error Creating roles";

            }


        } elseif ($create_role < 0) {
            return "Role Already exists";

        } else {
            return "An error occurred";
        }


    } // end create role


    public function edit_role_name($role_name, $new_role_name) {
        $key = "role_id";
        $columns_name = "role_name";

        $edit_name = $this->edit_single_data($role_name,$new_role_name,$this->role_table,$columns_name,$key);

        if ($edit_name == 101){
            return "Successfully changed from ".$role_name." to ".$new_role_name;

        } elseif ($edit_name ==202) {
            return "Cannot locate service";

        }  else {
            return "An error occurred";
        }

    } // end edi name function

    public function edit_role($id, $role_name) {
        $key = "role_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="role_name";
        $firstset['sign'] ="=";
        $firstset['value'] =$role_name;
        $set[] = $firstset;
        $whereduplicate[] = $firstset;

        $first_where['column_name'] =$key;
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_check_duplicate($this->role_table, $set, $where, $whereduplicate, $key);
        //print_r($edit_name);

        if ($edit_result == 1){
            return 1;

        } elseif ($edit_result ==-1) {
            return "Role already exists";

        }  else {
            return "Invalid role";
        }

    } // end edi name function

    public function change_role_status ($role_id, $new_status){
        $key = "role_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($role_id, $new_status,$this->role_table,$key);
        if ($change_status == 1){
            $d_array = array();
            $d_array['status'] = $new_status;
            $d_array['message'] = "Successfully made ".$msg;
            return $d_array;

        } elseif ($change_status ==-2) {
            return "Cannot locate role";

        } elseif ($change_status ==-1) {
            return "Role already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status


    public function view_active_roles(){
        $columns = array("role_id","role_name");

        $get_role = $this->view_all_active_data($this->role_table,$columns);

        if (is_array($get_role)) {

            return $get_role;
        } else {
            return "No role Found";
        }

    }


    public function view_all_roles(){
        $columns = array("role_id","role_name", "status");

        $get_role = $this->select_tb($this->role_table,$columns);

        if (is_array($get_role)) {

            return $get_role['data'];

        } else {

            return "No role found";
        }
    }


    public function view_role(){
        $columns = array("role_id", "role_name", "status");

        $get_data = $this->select_tb($this->role_table, $columns);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }


    public function get_role_name($id){
        $column = array("role_name");
        $first_where['column_name'] ="role_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $get_name = $this->select_tb($this->role_table,$column,$where);

        if (is_array($get_name)){

            return $get_name['data'][0];
        } else {

            return 0;
        }
    }
}// end class


//$page_test = new Reward_user_role();
//echo json_encode($page_test->view_all_roles());
//echo json_encode ($page_test->create_permission(1,1,1,1,0,0));
//echo json_encode($page_test->create_role("IT Manager2"));
//echo json_encode($page_test->change_service_status(1,1));
//echo json_encode($page_test->edit_service_name("Wallet_123","Wallet"));
//echo json_encode($page_test->view_active_services());