<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 12/10/2018
 * Time: 08:30
 */

require_once ("curl_class.php");
require_once ("service_access_class.php");
require_once ("company_class.php");
require_once ("company_access_class.php");
require_once ("partner_class.php");
require_once ("report_class.php");
require_once ("send_mail_class.php");
class wallet_service_class extends curl_class

{

    private $service_id = 4;
    private $master_token ="1002";
    private $url ='https://rewardsbox.perxclm.com/wallet/v1/?API_flag=';
    private $admin_url = 'https://rewardsbox.perxclm.com/wallet/v1/admin/?API_flag=';

    public function set_header($client_no){

        return $header = array('content-type: multipart/form-data','master: ' . $this->master_token,'client: ' . $client_no);
    }

    public function set_master(){

        return $header = array('content-type: multipart/form-data','master: ' . $this->master_token);
    }

    public function check_balance ($client_no){

        $api = 'checkbalance';
        $url = $this->url.$api;
        $set_header = $this->set_header($client_no);
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }


    }




    public function complete_delivery ($wallet_ref, $company_id){

        $use_company = new company_access_class();
        $get_token_array = $use_company->get_token_company($company_id);

        if (is_array($get_token_array)) {

            $token = $get_token_array['client_no'];

                $api = 'complete_delivery';
                $url = $this->url.$api;
                $set_header = $this->set_header($token);
                $body['tran_id'] = $wallet_ref;
                $send_data = $this->send_post($url, $body,$set_header);

                if (is_array($send_data)){

                    return $send_data;
                } else {

                    return 0;
                }

        } else {
            return "Invalid Token";
        }
    }


    public function send_transaction ($client_no, $body){
//        echo json_encode($body);
//        echo "<br>";
        $api = 'wallettran';
        $url = $this->url.$api;
        $set_header = $this->set_header($client_no);
        $send_data = $this->send_post($url,$body,$set_header);
//        echo json_encode($send_data);
//        echo "<br>";
        if (is_array($send_data)){
//        echo json_encode($send_data);
//        echo "<hr>";
            return $send_data;
        } else {
//            echo "abcd";
//            echo "<br>";
            //return $send_data;
            return 0;
        }


    }


    public function cancel_transaction ($client_no, $body){
//        echo json_encode($body);
//        echo "<br>";
        $api = 'cancel_tran';
        $url = $this->url.$api;
        $set_header = $this->set_header($client_no);
        $send_data = $this->send_post($url,$body,$set_header);
//        echo json_encode($send_data);
//        echo "<br>";
        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }


    }


    public function full_send_transaction($client_no, $transaction_array){
        if (is_array($transaction_array)){

            if (isset($transaction_array['amount']) && isset($transaction_array['desc']) && isset($transaction_array['payment_details'])){

//                if(is_array($transaction_array['payment_details'])) {
                    $check_array = $this->build_transaction_body($transaction_array['desc'], $transaction_array['amount'], $transaction_array['payment_details']);

                        if ($check_array == 1){

                            $send_transaction = $this->send_transaction($client_no, $transaction_array);
//                            echo json_encode($transaction_array);
//                            echo "<br>";
 //                           echo json_encode($send_transaction);
//                            echo "<br>";
                            if (is_array($send_transaction)){
                                if($send_transaction['status'] == 1001){
                                    $response_array['status'] = 1;
                                    $response_array['ref_no'] = $send_transaction['tran_id'];
                                    return $response_array;

                                    // update wallet ref and insert confirm job / reject
                                } else {

                                    //return $send_transaction['message'];
									return $send_transaction['message'];
                                }


                            } else {
                                //return $send_transaction;
                                return "Error updating wallet";
                            }
                        } else {

                            return $check_array;
                        }
//                } else {
//
//                    return "Invalid transaction_array";
//                }
            } else{

                return "Missing parameters";
            }

        } else {

            return "Invalid transaction array";
        }


    }



    private function build_transaction_body ($description, $amount, $payment_details){

        if($description == ""){

            return "Blank description";
        } elseif ($amount == ""){

            return "Blank amount";

        } elseif ($payment_details == ""){

            return "blank payment details";
        } else{

            if(is_numeric($amount) && $amount > 0){
            $payment_details= json_decode($payment_details);
                if(is_array($payment_details)){

                    return 1;
                } else {

                    return "Invalid payment details";
                }

            } else{

                return "Invalid amount";
            }


        }

    }

    private function check_payment_details($payment_details_array){
        if(isset($payment_details_array['client_no']) &&isset($payment_details_array['amount'])&&isset($payment_details_array['description'])&&isset($payment_details_array['ref'])) {

            if ($payment_details_array['ref'] == ""){

                return "blank reference";
            } elseif ($payment_details_array['amount'] == ""){

                return "blank amount ref".$payment_details_array['ref'];
            } elseif ($payment_details_array['description'] ==""){

                return "blank description";
            } elseif ($payment_details_array['client_no'] ==""){

                return "blank client no";
            } else{

                if(is_numeric($payment_details_array['amount'])){

                    return 1;
                } else{

                    return "Invalid amount";
                }


            }


        } else {

            return "Missing array parameter";
        }

    }

    private function multi_check_payment_details($multi_payment_array){

        foreach ($multi_payment_array as $payment_array){

            $check_payment = $this->check_payment_details($payment_array);

            if($check_payment !== 1){

                return $check_payment;
            }

        }

        return 1;
    }



    public function build_confirm_transaction ($token, $ref_no, $failed_array, $status){

        if($ref_no == "") {

            return "Blank ref_no";

        } else {
            if (is_array($failed_array)){

                $send_array['tran_id'] = $ref_no;
                $send_array['status'] = $status;
                $send_array['failed'] = json_encode($failed_array);

                $send_confirm = $this->send_confirm_transaction($token, $send_array);

                if (is_array($send_confirm)) {

                    if($send_confirm['status'] == 1001){

                        $s_array['ref'] = $ref_no;
                        $s_array['message'] = $send_confirm['message'];
                        return $s_array;
                    } else {

                        return $send_confirm['message'];
                    }

                } else {

                    return "Error getting confirmation";
                }
            } else{

                return "Invalid failed array";
            }

        }








    }


    public function wallet_job($client_no, $w_array){

        $run_wallet_ref = $this->full_send_transaction($client_no, $w_array);

        if (is_array($run_wallet_ref)){

            $wallet_ref = $run_wallet_ref['ref_no'];
            $use_purchase = new purchase_class();
            $save_wallet_ref = $use_purchase->update_wallet_ref($wallet_ref, $w_array['order_no']);

            if ($save_wallet_ref == 1){

                $get_failed = $use_purchase->get_failed_array($w_array['order_no']);

                if (is_array($get_failed) || $get_failed == 1){

                    if ($get_failed == 1){
                        $status = 1;
                        $failed_array = array();
                    } else {

                        $status = 0;
                        $failed_array = $get_failed;
                    }

                    $run_confirm = $this->build_confirm_transaction($client_no,$wallet_ref, $failed_array, $status);
                    return $run_confirm;

                } else {

                    return $get_failed;
                }

            } else {

                return "Error updating wallet information";
            }

        } else {

            return $run_wallet_ref;
        }



    }

    private function send_confirm_transaction ($client_no, $body){
       // echo json_encode($body);
        //echo "<br>";
        $api = 'credit';
        $url = $this->url.$api;
        $set_header = $this->set_header($client_no);
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }

    private function send_company ($body){

        $api = 'register_wallet';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }

    private function list_wallet ($client_type){

        $api = 'get_client_by_type';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_type'] = $client_type;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }


    public function list_transactions ($client_no){

        $api = 'walletstatement';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = $client_no;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){
                $d_array['total_debit'] = $send_data['total_debit'];
                $d_array['total_credit'] = $send_data['total_credit'];
                $d_array['current_balance'] = $send_data['current_balance'];
                $d_array['data'] = $send_data['data'];
                return $d_array;
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }

    public function list_detail_transactions ($client_no, $ref_no){

        $api = 'transaction_details';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = $client_no;
        $body['reference'] = $ref_no;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                return $send_data['data'];
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }

    public function create_company($client_no, $client_token, $token_expiry, $company_id){

        $client_type = 3;
        $service_id = $this->service_id;
        $make_company = $this->create_client($client_no, $client_type, $client_token, $token_expiry,$company_id, $service_id);

        return $make_company;

    }


    public function list_client_wallet(){

        $use_company = new Reward_company();
        $list_company = $this->list_wallet(3);

        if (is_array($list_company)){

            if($list_company['status'] == 1001){

                $w_company = $list_company['data'];

                $rb_company = $use_company->list_all_company();

                foreach ($w_company as $company){

                    $key = array_search($company['client_no'], array_column($rb_company, 'client_no'));

                    if ($key == ""){
                        $company['company_name'] = "";
                        $company['rb_id'] = "";

                    } else {

                        $company['company_name'] = $rb_company[$key]['company_name'];
                        $company['rb_id']= $rb_company[$key]['company_id'];

                    }

                    $data [] = $company;

                }

                return $data;
            } else {

                return $list_company['message'];
            }

        } else {

            return "Error getting data";
        }


    }


    public function list_partner_wallet(){

        $list_company = $this->list_wallet(4);

        if (is_array($list_company)){

            if($list_company['status'] == 1001){

                return $list_company['data'];
            } else {

                return $list_company['message'];
            }

        } else {

            return "Error getting data";
        }


    }

    public function create_partner($client_no, $company_id = 0){

        $service_id = $this->service_id;
        $client_token = mt_rand(1, 1000);
        $check_days = 1095;
        $token_expiry = $expire_date = Date('Y-m-d', strtotime("+".$check_days."days"));
        $client_type = 4;
        $make_company = $this->create_client($client_no, $client_type, $client_token, $token_expiry,$company_id, $service_id);

        return $make_company;

    }


    public function create_client($client_no, $client_type,$client_token, $token_expiry,$company_id, $service_id){
        $body = array();
        if($client_no ==""){

            return "Invalid Client no";


        } else {

            $body['client_no'] = $client_no;
            if ($client_type == 5 || $client_type == 4 || $client_type == 3){

                $body['client_type'] = $client_type;
                if ($client_token == ""){

                    return "Token required";
                } else {
                    $body['client_token'] = $client_token;
                    if($token_expiry == ""){

                        return "Expiry date require";
                    } else {
                        $body['client_token_expiry'] = $token_expiry;
                        $make_company = $this->send_company($body);

                        if (is_array($make_company)) {

                            $use_service_access = new service_access_class();
                            if ($make_company['status'] == 1001){

                                $status = 1;
                            } else {
                                $status = 0;
                            }
                            $store_access = $use_service_access->register_access($company_id,$service_id,$make_company['status'],$make_company['message'],$status);
                            return $make_company;


                        } else {

                            return "Error creating client";
                        }
                    }

                }
            } else {

                return "Invalid client type";
            }



        }


    }

    public function get_deposit_type_name($type)
    {

        if ($type == 1) {

            return "Cash";

        } elseif ($type == 2){

            return "Bank Transfer";

        }  elseif ($type == 3){
            return "Cheque";
        }  elseif ($type == 4){
            return "Credit Card";
        }  elseif ($type == 5){
            return "Debit Card";
        } else {

            return "";
        }

    }

    public function deposit_types(){

        $t_array['id'] = 1;
        $t_array['name'] = "Cash";
        $type_array[] = $t_array;

        $t_array['id'] = 2;
        $t_array['name'] = "Bank Transfer";
        $type_array[] = $t_array;

        $t_array['id'] = 3;
        $t_array['name'] = "Cheque";
        $type_array[] = $t_array;

        $t_array['id'] = 4;
        $t_array['name'] = "Credit Card";
        $type_array[] = $t_array;

        $t_array['id'] = 5;
        $t_array['name'] = "Debit Card";
        $type_array[] = $t_array;

        return $type_array;
    }

    public function credit_wallet ($company_id, $desc, $amount, $tran_type){

        $use_company = new Reward_company();

        $get_no = $use_company->get_company_details($company_id);



        if (is_array($get_no)) {

            $client_no = $get_no['client_no'];
            $company_name = $get_no['company_name'];
            $email = $get_no['email'];
            if ($client_no == "" || $desc == "" || $amount == "") {

                return "Missing or parameters";
            } elseif (!is_numeric($amount) || $amount < 1) {

                return "Invalid amount";
            } else {
                $api = 'rbcreditwallet';
                $url = $this->admin_url . $api;
                $set_header = $this->set_master();
                $body['client_no'] = $client_no;
                $body['amount'] = $amount;
                $body['desc'] = $desc;
                $send_data = $this->send_post($url, $body, $set_header);

                if (is_array($send_data)) {

                    if ($send_data['status'] == 1001) {
                        $use_report = new report_class();
                        if(isset($send_data['open_flag']) && $send_data['open_flag'] == 1){
                            $use_report->set_opening_balance($company_id,$amount);

                        }
                        $array['balance'] = $send_data['new_current_balance'];
                        $array['message'] = $send_data['message'];

                        $remark = $this->get_deposit_type_name($tran_type)." : ".$desc;
                        $credit_account =$use_report->set_top_up($company_id,$amount,1,$remark);
                        if(is_array($credit_account)) {
                            $use_send_email = new send_mail_class();
                            $use_send_email->send_wallet_credit($company_name, $amount, $credit_account['balance'], $client_no, $email);
                            return $credit_account;
                        } else {

                            return $credit_account;
                        }
                    } else {

                        return $send_data['message'];
                    }

                } else {

                    return "Invalid data sent";
                }
            }
        } else {

            return "Invalid Company";
        }
    }

    public function debit_wallet ($company_id, $desc, $amount, $tran_type){

        $use_company = new Reward_company();

        $get_no = $use_company->get_company_details($company_id);


        if (is_array($get_no)) {

            $client_no = $get_no['client_no'];
            $company_name = $get_no['company_name'];
            $email = $get_no['email'];
            if ($client_no == "" || $desc == "" || $amount == "") {

                return "Missing or parameters";
            } elseif (!is_numeric($amount) || $amount < 1) {

                return "Invalid amount";
            } else {
                $api = 'refundrb';
                $url = $this->admin_url . $api;
                $set_header = $this->set_master();
                $body['client_no'] = $client_no;
                $body['amount'] = $amount;
                $body['desc'] = $desc;
                $send_data = $this->send_post($url, $body, $set_header);

                if (is_array($send_data)) {

                    if ($send_data['status'] == 1001) {

                        $array['balance'] = $send_data['new_current_balance'];
                        $array['message'] = $send_data['message'];

                        $use_report= new report_class();
                        $remark = $this->get_deposit_type_name($tran_type)." : ".$desc;
                        $debit_account =$use_report->set_manual_debit($company_id,$amount,$remark);
                        if(is_array($debit_account)) {
                            $use_send_email = new send_mail_class();
                            $use_send_email->send_wallet_debit($company_name, $amount, $debit_account['balance'], $client_no,$email);
                            return $debit_account;
                        } else {

                            return $debit_account;
                        }
                    } else {

                        return $send_data['message'];
                    }

                } else {

                    return "Invalid array sent";
                }
            }
        } else {

            return "Invalid Company";
        }
    }


    public function total_out($client_no){

        $api = 'get_wallet_total';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = $client_no;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                return $send_data['data'];
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }

    public function list_lsl_statement(){

        $client_no = "LSL";

        $send_data = $this->list_transactions($client_no);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "No data found";
        }
    }

    public function list_rb_statement(){

        $client_no = "Rewardsbox";

        $send_data = $this->list_transactions($client_no);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "No data found";
        }
    }

    public function balance_rewards_box(){

        $get_balance = $this->check_balance("Rewardsbox");
        if (is_array($get_balance)){

            return $get_balance;
        } else {

           $d_array['available_balance'] = $get_balance['available_balance'];
            $d_array['current_balance'] = $get_balance['current_balance'];
            $d_array['total_credit'] = $get_balance['total_credit'];
            $d_array['total_debit'] = $get_balance['total_debit'];
            return $d_array;
        }

    }

    public function credit_prepaid_wallet ($partner_id, $desc, $amount){

        $use_partner = new partner_class();

        $get_no = $use_partner->get_partner_id($partner_id);


        if (is_array($get_no)) {



            $client_no = $get_no['partner_no'];
            $payment_type = $get_no['payment_type'];
            $partner_name = $get_no['partner_name'];


            if($payment_type == 1) {
                if ($client_no == "" || $desc == "" || $amount == "") {

                    return "Missing or parameters";
                } elseif (!is_numeric($amount) || $amount < 1) {

                    return "Invalid amount";
                } else {
                    $api = 'creditvirtualwallet';
                    $url = $this->admin_url . $api;
                    $set_header = $this->set_master();
                    $body['client_no'] = $client_no;
                    $body['amount'] = $amount;
                    $body['desc'] = $desc;
                    $send_data = $this->send_post($url, $body, $set_header);

                    if (is_array($send_data)) {

                        if ($send_data['status'] == 1001) {

                            $array['balance'] = $send_data['new_balance'];
                            $array['message'] = $send_data['message'];

                            $use_send_email = new send_mail_class();
                            $use_send_email->send_prepaid_credit($partner_name,$amount,$send_data['new_balance']);
                            return $array;
                        } else {

                            return $send_data['message'];
                        }

                    } else {

                        return 0;
                    }
                }
            } else{

                return "Only available for Pre-paid partners";
            }
        } else {

            return "Invalid Company";
        }
    }


    private function list_prepaid_partners (){

        $api = 'fetchvirtualwallet';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = "";

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                return $send_data['data'];
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }

    public function prepaid_partners(){


        $use_partner = new partner_class();
        $get_partners = $use_partner->view_partners();
//echo json_encode($get_partners);
//echo "<br>";
        if(is_array($get_partners)){

            $get_prepaid = $this->list_prepaid_partners();

            if(is_array($get_prepaid)){

                foreach ($get_prepaid as $prepaid){

                    $key = array_search($prepaid['client_no'], array_column($get_partners, 'partner_no'));
                    if ($key == ""){
                        $prepaid['partner_name'] = "";


                    } else {

                        $prepaid['partner_name'] = $get_partners[$key]['partner_name'];


                    }

                    $data [] = $prepaid;

                }

                return $data;

            } else {

                return "No prepaid partner found";
            }


        } else {

            return "No partner found";
        }
    }

    public function credit_rb ($amount){

        $api = 'creditrb';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['amount'] = $amount;
        $body['tran_desc'] = "Account top up";

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $s_array['activity'] = "Credit rewardsbox";
                $s_array['message'] = $send_data['message'];
                return $s_array;
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }

    public function get_wallet_util (){

        $api = 'util';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = "";

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                return $send_data['data'];
            } else {

                return $send_data['message'];
            }

        } else {

            return 0;
        }
    }


    public function wallet_util_reminder(){

        $get_data = $this->get_wallet_util();

        $use_company = new Reward_company();
        if(is_array($get_data)){



                foreach ($get_data as $d_array){



                    $client_no = $d_array['client_no'];
                    $percentage = $d_array['percentage'];
                    $balance = $d_array['avail_bal'];

                    $get_details = $use_company->single_company_detail($client_no);
                    if(is_array($get_details)) {
                        $email = $get_details['email'];
                        $company_name = $get_details['company_name'];


                        if ($percentage == 85 || $percentage == 99) {

//
                            $use_mail = new send_mail_class();
                            $use_mail->utilization_reminder($company_name, $percentage, $balance, $email);

                        }

                    } else {


                        return "Invalid Company";
                    }

                }

                return "Done";


        } else {

            return "Error getting data";
        }


    }
}



//$page_test = new wallet_service_class();
//echo json_encode($page_test->list_lsl_statement());
//echo json_encode($page_test->check_balance(142078));
//echo json_encode($page_test->wallet_util_reminder());
//echo json_encode($page_test->get_wallet_util());
//echo json_encode($page_test->prepaid_partners());
//echo json_encode($page_test->credit_prepaid_wallet(7,"test",2000));
//echo json_encode($page_test->list_rb_statement());
//echo json_encode($page_test->total_out(127892));
//echo json_encode($page_test->list_detail_transactions("142078", "4767858"));
//echo json_encode($page_test->create_partner(345, 123,100));
//echo json_encode($page_test->credit_wallet("12","To diamond account from GTB", "20000",2));
//echo json_encode($page_test->debit_wallet(12,"Test debit",1000,1));
//echo json_encode($page_test->list_client_wallet());
//echo json_encode($page_test->list_transactions('127892'));
//echo json_encode($page_test->list_transactions('LSL'));


//echo json_encode($page_test->create_company("457","9876","2019-10-25",2,5));
//echo json_encode($page_test->build_confirm_transaction(1200,1144540, array()));
//
//echo json_encode($page_test->check_balance("1001"));
//
//$one['ref']="abcd";
//$one['client_no'] = "partner_123";
//$one['amount'] = 500;
//$one['description'] = "CK hand bag";
//
//$details [] = $one;
//
//$one['ref']="bcde";
//$one['client_no'] = "partner_234";
//$one['amount'] = 1000;
//$one['description'] = "CK hand belt";
//
//$details [] = $one;
//
//
//$main_array ['amount'] = 2000;
//$main_array ['desc'] = "Purchase order no 123";
//$main_array['payment_details'] = json_encode($details);

//echo json_encode($main_array);
////echo "<br>";
//
//echo json_encode($page_test->full_send_transaction(12847,$main_array));