<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 29/10/2018
 * Time: 21:53
 */

require_once ("curl_class.php");
require_once ("database_class.php");
require_once ("company_category_class.php");
class xoxoday_class extends curl_class
{

    private $key = '65ee0b0b9b414e6c86dfc22c4b944e6fTG95YWx0eVNvbHV0aW9uc0x0ZDE1MjUwOTU3NzA0MjN4MFgwZEB5TG95YWx0eVNvbHV0aW9uc0x0ZA==';
    private $end_point ='https://corp.xoxoday.com/v2/';
    private  $header;
    private $rates_table = 'xoxo_rates';
    private $delivery_type = 4;
    private $rims_partner_id = 123;
    private $salt = "gRSEohsJPg";
    private $store_name = "Loyalty Solutions";
    private $store_url= "loyaltysolutionsnigeria.com";
    private $log_table = "xoxo_order_log";



    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        return $this->header = array("key: " .$this->key,"content-type: application/json", "cache-control: no-cache");
    }


    public function get_countries(){

        $this->set_header();
        $api = "getCountries";
        $new_url = $this->end_point.$api;

        $get_country = $this->send_get($new_url,$this->header);

        if(is_array($get_country)){

            if($get_country['success'] == 1){

                return $get_country['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No country found";
        }

    }

    public function get_city ($country_id){


        if (is_numeric($country_id)){

            $this->set_header();
            $api = "getCities";

            $new_url = $this->end_point.$api.'?country_id='.$country_id;

            $get_city = $this->send_get($new_url,$this->header);

            if(is_array($get_city)){

                if($get_city['success'] == 1){

                    return $get_city['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No city found";
            }

        } else {

            return "Invalid country";
        }
    }

    public function get_tags(){

        $this->set_header();
        $api = "getPartnerTags";

        $new_url = $this->end_point.$api;

        $get_tags = $this->send_get($new_url,$this->header);

        if(is_array($get_tags)){

            if($get_tags['success'] == 1){

                return $get_tags['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No category found";
        }

    }

    public function get_products($country, $city, $tag_data,$end_point, $page = 1, $limit = 20){
        if($page == "" || !is_numeric($page) || $page < 1){

            $page = 1;
        }

        if ($limit == "" || !is_numeric($limit) || $limit < 1){

            $limit = 20;
        }

        $this->set_header();

        $new_url = $end_point;

        $data_array = array();
        $country_id = array();
        $tags = array();
        $tags[]=$tag_data;
        $country_id[] = $country;
        $City_id = array();
        $City_id[]=$city;
        $data_array["country_id"] = $country_id;
        $data_array["City_id"] = $City_id;
        $data_array["tags"]=$tags;
        $data_array["Page"]=$page;
        $data_array["limit"] = $limit;
        $data_body = array();
        $data_body["data"] = $data_array;

        $get_products = $this->send_post($new_url,json_encode($data_body),$this->header);

        if(is_array($get_products)){

           if ($get_products['success'] == 1){

               return $get_products;
           } else {

               return "Products not found";
           }


        } else {

            return "No product found";
        }

    }

    public function get_rates(){

        $url='https://www.xoxoday.com/php/api.php';
        $header = array("method: currency","url_type:currency");

        $get_rates = $this->send_post($url, array(), $header);

        if (is_array($get_rates)){


            if ($get_rates['Error'] == false){

                return $get_rates['Result'];

            } else {

                return $get_rates['Message'];
            }
        } else {

            return "No data found";
        }

    }


    public function add_rates(){

        $rates_array = $this->get_rates();

        if (is_array($rates_array)){

            $use_database = new Database();
            $columns = array("xoxo_currency_id","title","code","value");

            foreach ($rates_array as $rates){

                $values= array($rates['currency_id'],$rates['title'],$rates['code'],$rates['value']);
                $insert_data = $use_database->insert_data($this->rates_table,$columns,$values );
//                echo $insert_data;
//                echo "<br>";

            }

        return 1;

        } else {

            return $rates_array;
        }



    }

    public function get_xoxo_val($from_code, $to_code, $amount){

        if (is_numeric($amount)) {
            $columns = array("code", "value");
            $ci_where['column_name'] = "code";
            $ci_where['sign'] ="=";
            $ci_where['value'] =$from_code;
            $where []= $ci_where;

            $ci_where['column_name'] = "code";
            $ci_where['sign'] ="=";
            $ci_where['value'] =$to_code;
            $where []= $ci_where;


            $get_data = $this->select_tb($this->rates_table, $columns,$where,"OR");

            if(is_array($get_data)){




                foreach ($get_data['data'] as $key=>$result) {
                    if ($from_code == $result['code']) {
                        $from_value = (float)$result['value'];
//                        echo $from_value;
//                        echo "<br>";
                    }

                    if ($to_code == $result['code']) {
                        $to_value = (float)$result['value'];
//                        echo $to_value;
//                        echo "<br>";
                    }


                }



                $from_to_inr =$amount / $from_value ;

//                echo $from_to_inr;
//                echo "<br>";

                $inr_to = $from_to_inr * $to_value;
//                echo $inr_to;
//                echo "<br>";

                $result_array [$from_code] = $amount;
                $result_array ['INR'] = $from_to_inr;
                $result_array[$to_code] = $inr_to;
                //echo json_encode($result_array);
                return $result_array;
            } else {

                return $get_data;
            }
        } else {

            return "Invalid Amount";
        }
    }




    public function convert_xoxo_naira($from_code, $amount){
        $to_code = "NGN";
        $get_naira = $this->get_xoxo_val($from_code,$to_code,$amount);

        if (is_array($get_naira)) {

            $naira_val = $get_naira['NGN'];
            //echo $naira_val;
            //echo "<br>";
            if (is_numeric($naira_val) && $naira_val > 0) {

                return round($naira_val,2);
            } else {
                return 0;
            }
        } else {
            return 0;
        }


    }


    public function get_all_rates(){

        $columns = array("code", "value");


        $get_rates = $this->select_tb($this->rates_table, $columns);

        if(is_array($get_rates)) {

            return $get_rates['data'];

        } else {

            return "No data found";
        }

    }


    public  function calc_rates($from_value, $to_value, $amount){

        $from_to_inr =$amount / $from_value ;

        $naira_val = $from_to_inr * $to_value;

        if (is_numeric($naira_val) && $naira_val > 0) {

            return round($naira_val,2);
        } else {
            return 0;
        }

    }


    public function get_naira_products ($end_point, $partner_category_name, $partner_id, $margin, $margin_type, $category_id, $country_id, $city_id, $page = 1, $limit = 20){

        if (!isset($country_id)){

            return "Country Required";


        } else{

            if($country_id =="" || !is_numeric($country_id) || $country_id < 1){

                return "Invalid Country";

            } else {

                if(!isset($city_id)){

                    return "City is required";
                } else {


                    if($city_id == "" || !is_numeric($city_id) || $city_id < 1){


                        return "Invalid City";
                    } else {

                        if ($partner_category_name == ""){


                            return "Category required";
                        } else {


                            $get_products = $this->get_products($country_id, $city_id, $partner_category_name, $end_point, $page, $limit);

                            if(is_array($get_products)){

                                $get_rates = $this->get_all_rates();
                               // $key = array_search($menu['parent_id'], array_column($parent_array, 'menu_id'));
                                $response_array_data['total'] = $get_products['total'];
                                foreach ($get_products['data'] as $key1 =>$product){

                                    $d_array['p_id'] = $product['product_id'];
                                    $d_array['c_id'] = $category_id;

                                    $response_array['product_code']=base64_encode(json_encode($d_array));
                                    //$response_array['product_id'] = $product['product_id'];
                                    $response_array['image'] = $product['image_path'].$product['images'][0];
                                    $response_array['product'] = $product['activity_name'];
                                    $check_price =$product['packageArray'][0]['type'];

                                    $total_price = 0;
                                    foreach ( $product['packageArray'][0]['type'] as $key => $package) {
                                        //echo $key;
                                        //echo "<br>";
                                        if ($key == "Kid") {

                                            $min_kid = (int)$package['min_kids'];
                                            $price_kid = (float)$package['price_kid'];
                                            $total_price_kid = $price_kid * $min_kid;
                                            $total_price = $total_price + $total_price_kid;
                                            //echo $price_kid. " | ".$min_kid ." | ".$total_price_kid. " | " .$total_price;
                                            //echo "<br>";
                                        } elseif ($key == "Adult") {

                                            $min_adult = (int)$package['min_adults'];
                                            $price_adult = (float)$package['price_adult'];
                                            $total_price_adult = $price_adult * $min_adult;
                                            $total_price = $total_price + $total_price_adult;

                                        } // end if

                                    } // end foreach package array

//                                    echo $total_price;
//                                    echo "<br>";
                                    $key = array_search($product['currency']['currency_code'], array_column($get_rates, 'code'));
//                                    echo $key;
//                                    echo "<br>";
                                    $key2 = array_search("NGN", array_column($get_rates, 'code'));
//                                    echo $key2;
//                                    echo "<br>";
                                    if($key !=="" || $key2 !=="") {
                                        $from_value = $get_rates[$key]['value'];
//                                        echo $from_value;
//                                        echo "<br>";
                                        $to_value = $get_rates[$key2]['value'];
//                                        echo $to_value;
//                                        echo "<br>";
                                        $naira_price = $this->calc_rates($from_value, $to_value, $total_price);
//                                        echo $naira_price;
//                                        echo "<br>";

                                        //print_r($naira_price);
                                        if ($naira_price > 0) {

                                            $use_company_category = new company_category_class();
                                            $apply_margin = $use_company_category->apply_margin($margin, $margin_type, $naira_price);
                                            $response_array['price'] = $apply_margin;
                                            $response_array_data['data'][] = $response_array;

                                            //print_r($response_array_data);
                                        }
                                    }
                                } // end for each product
                                return $response_array_data;
                            } else {


                                return $get_products;
                            }

                        }


                    }
                }

            }



        }




    }


    public function get_product_details ($url, $partner_id, $margin, $margin_type, $product_code){
        $get_array = $this->list_detail_items($url,$product_code);

        //echo $get_array;
        //echo "<br>";
        if (is_array($get_array)){

            if($get_array['success'] == 1){

                $get_mod_details = $this->arrange_list_detail($partner_id,$margin,$margin_type, $get_array['data']);

                if (is_array($get_mod_details)){

                    return $get_mod_details;
                } else {

                    return "An error has occurred";
                }

            } else {

                return "Unable to get data";
            }
        } else {

            return "No details found";
        }

    }



    public function list_detail_items ($url,$product_code){

        $this->set_header();

        $new_url = $url."&product_id=".$product_code;
        $send_data = $this->send_get($new_url,$this->header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }



    }


    public function arrange_list_detail($partner_id, $margin, $margin_type,$detail_array){

        $signal = array();
        $signal['item_code'] = $detail_array['product_id'];
        $signal['rb_partner_id'] = $partner_id;

        $signal['item_name'] = $detail_array['activity_name'];
        $signal['advance_book'] = $detail_array['advance_book'];
        $signal['advance_book_format'] = $detail_array['advance_book_format'];
        $signal['start_date'] = $detail_array['start_date'];
        $signal['end_date'] = $detail_array['end_date'];


        $add_margin = new company_category_class();
        $main_detail = array();

        $main_detail['product_name'] = $detail_array['activity_name'];
        $main_detail['duration'] = $detail_array['experience_duration'];
        $main_detail['advance_book'] = $detail_array['advance_book'];
        $main_detail['advance_book_format'] = $detail_array['advance_book_format'];
        $main_detail['description'] = $detail_array['exp_description'];
        $main_detail['start_date'] = $detail_array['start_date'];
        $main_detail['end_date'] = $detail_array['end_date'];
        $main_detail['delivery_type'] = $this->delivery_type;

        $add_margin = new company_category_class();
        $total_price = 0;
        $response_array['package']= array();
        foreach ( $detail_array['packageArray'][0]['type'] as $key => $package) {
            //echo $key;
            //echo "<br>";
            if ($key == "Kid") {

                $min_kid = (int)$package['min_kids'];
                $price_kid = (float)$package['price_kid'];
                $kid_array['min_kid'] = $min_kid;
                $kid_array['max_kid'] = (int)$package['max_kids'];


                $kid_cost_price = $this->convert_xoxo_naira($detail_array['currency']['currency_code'],$price_kid);
                if (is_numeric($kid_cost_price) && $kid_cost_price >0) {

                    $kid_array['kid_price'] = $add_margin->apply_margin($margin, $margin_type, $kid_cost_price);
                } else {

                    return "Error";
                }
                $total_price_kid = $kid_array['kid_price'] * $min_kid;
                $total_price = $total_price + $total_price_kid;


                $signal_kid_array['min_kid'] = $min_kid;
                $signal_kid_array['max_kid'] = (int)$package['max_kids'];
                $signal_kid_array['kid_cost_price'] = $kid_cost_price;
                $signal_kid_array['kid_sell_price'] = $kid_array['kid_price'];
                $signal_kid_array['kid_currency_price'] = $price_kid;

                //echo $price_kid. " | ".$min_kid ." | ".$total_price_kid. " | " .$total_price;
                //echo "<br>";


                $main_detail['package']['kid'] = $kid_array;
                $signal['package']['kid'] = $signal_kid_array;
            } elseif ($key == "Adult") {

                               $min_adult = (int)$package['min_adults'];
                $price_adult = (float)$package['price_adult'];
                $adult_array['min_adult'] = $min_adult;
                $adult_array['max_adult'] = (int)$package['max_adults'];
                $adult_cost_price = $this->convert_xoxo_naira($detail_array['currency']['currency_code'],$price_adult);
                if (is_numeric($adult_cost_price) && $adult_cost_price >0) {
                    $adult_array['adult_price'] = $add_margin->apply_margin($margin, $margin_type, $adult_cost_price);
                } else {

                    return "Error";
                }
                $total_price_adult = $adult_array['adult_price'] * $min_adult;
                $total_price = $total_price + $total_price_adult;

                $signal_adult_array['min_adult'] = $min_adult;
                $signal_adult_array['max_adult'] = (int)$package['max_adults'];
                $signal_adult_array['adult_currency_price'] = $price_adult;
                $signal_adult_array['adult_cost_price'] = $adult_cost_price;
                $signal_adult_array['adult_sell_price'] = $adult_array['adult_price'];


                $main_detail['package']['adult'] = $adult_array;
                $signal['package']['adult'] = $signal_adult_array;
            } // end if


        } // end foreach package array



        if ($total_price >0) {
            $response_array['price'] = $total_price;

        }


        foreach ($detail_array['location'] as $key => $address){
            $location_array['id'] = $key;
            $location_array['exp_address'] = $address['exp_address']['address'];
            $location_array['city'] = $address['exp_address']['city_name'];
            $location_array['store_name'] = $address['exp_address']['vendor_poc'];

            if(!empty($address['pickup_address'])){
                foreach ($address['pickup_address'] as $key1 => $pickup){
                    $pickup_array['pickup_address'] = $pickup['address'];
                    $pickup_array['longitude'] = $pickup['longitude'];
                    $pickup_array['latitude'] = $pickup['latitude'];

                } //for each address
                $location_array['pickup_address'][] = $pickup_array;
            } else {

                $location_array['pickup_address']= array();
            }

            $main_detail['location'][] = $location_array;
        } // for each location

        $image_path = $detail_array['image_path'];

        foreach ($detail_array['images'] as $key=>$image) {
            $image_array[]=$image_path.$image;
        }
        $main_detail['image'] = $image_array;
        $signal['product_id'] = $detail_array['product_id'];
        $main_detail['day_slots'] = $detail_array['gfx_day_timeslots'];
        $main_detail['faqs'] = $detail_array['faq'];
        $main_detail['disable_date'] = $detail_array['disable_dates'];



        $signal['is_variant'] = 0;

        $signal['rims_partner_id'] = $this->rims_partner_id;


        $main_detail['signature'] = $this->string_encrypt(json_encode($signal));
        //$main_detail['signature'] = json_encode($signal);
        return $main_detail;
    }


    public function get_hash ($email, $phone, $date, $product_id, $package_index, $reference_id, $price, $address_id){


        $value =$email."|".$phone."|".$date."|".$product_id."|".$package_index."|".$reference_id."|".$price."|".$this->salt."|".$address_id;
        //echo $value;
        //echo "<br>";
        $hash = hash("SHA512",$value);
        return $hash;


    }

    public function create_order ($first_name, $last_name, $email, $phone, $date, $product_id, $adult_count=0,$kid_count=0,$package_index=0, $address_id =0, $price, $reference ){

        $get_array = $this->create_order_array($first_name, $last_name, $email, $phone, $date, $product_id, $adult_count,$kid_count,$package_index=0, $address_id =0, $price, $reference);
        if(is_array($get_array)){

            $send_xoxo = $this->send_order($get_array);

//            echo json_encode($send_xoxo);
//            echo "<br>";
            if ($send_xoxo['status'] == 1){

                return $send_xoxo;
            } else {

                $response_array['status'] = $send_xoxo['status'];
                $response_array['message'] = $send_xoxo['message'];
                $response_array['data'] = array($reference);
//                echo json_encode($response_array);
//                echo "<br>";
                return $response_array;
            }

        } else {

            $response_array['status'] = 0;
            $response_array['message'] = "Invalid Parameters";
            $response_array['data'] = array($reference);
            return $response_array;

        }

    }
    public function create_order_array ($first_name, $last_name, $email, $phone, $date, $product_id, $adult_count=0,$kid_count=0,$package_index=0, $address_id =0, $price, $reference ){

        $body_array = array();
        $body_array['firstname']= $first_name;
        $body_array['lastname'] = $last_name;
        $body_array['email'] = $email;
        $body_array['phone'] = $phone;
        $body_array['date'] = $date;
        $body_array['product_id'] = $product_id;

        $info = array();
        $info['items'] = [];
        $info_array = array();
        if($adult_count > 0){

            $adult_guest = array();
            $adult_guest['guest_count'] = $adult_count;


            $info_array['Adult'] = $adult_guest;


        }

        if($kid_count > 0){

            $kid_guest = [];
            $kid_guest['guest_count'] = $kid_count;

            $info_array = array();
            $info_array['Kid'] = $kid_guest;


        }


        $info['type'] =$info_array;

        $body_array['package_info'] = $info;
        $body_array['package_index'] = $package_index;
        $body_array['address_id'] = $address_id;
        $body_array['price'] = $price;
        $body_array['comments'] = "";
        $body_array['store_name'] = $this->store_name;
        $body_array['store_url'] = $this->store_url;
        $body_array['reference_id'] = $reference;
        $body_array['hash'] = $this->get_hash($email,$phone,$date,$product_id,$package_index,$reference,$price, $address_id);
        $body_array['ipAddress'] = "";

        //echo $adult_count;
        //echo json_encode($adult_guest);
        //echo "<br>";
        return $body_array;
    }

    public function process_transaction($redemption_array, $delivery_array, $order_no){

        $first_name = $delivery_array['first_name'];
        $last_name = $delivery_array['last_name'];
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[3]['product_details'][0];

//        echo json_encode($order_item);
//        echo "<br>";
        $date = $order_item['date'];
        $address_id = $order_item['address_id'];
        $product_id = $order_item['signature']['product_id'];
        $adult_count = $order_item['adult_quantity'];
        $kid_count = $order_item['kid_quantity'];
        $price = $order_item['currency_price'];
        $reference = $order_item['voucher_no'];


        $confirm_order = $this->create_order($first_name,$last_name,$email,$phone_no,$date,$product_id,$adult_count,$kid_count,0,$address_id, $price, $reference);
//        echo json_encode($confirm_order);
//        echo "<br>";
        return $confirm_order;
        //    echo json_encode($redemption_array);
//    echo "<br>";
//    echo json_encode($delivery_array);
//    echo "<br>";
//    echo json_encode($order_no);
//    echo "<br>";
  //  echo json_encode($is_shipping);
   // echo "<br>";
    //echo json_encode($token);



    }

    public function send_order($data_body){
        $this->set_header();
        $api = "createOrder";
        $new_url = $this->end_point.$api;


        $send_data = $this->send_post($new_url,json_encode($data_body),$this->header);
        $this->save_order_request(json_encode($data_body), json_encode($send_data));
        if(is_array($send_data)){

            if ($send_data['success'] == 1){

                $response_array ['status'] = 1;
                $response_array ['message'] = $send_data['data']['Message'];
                $response_array['order_id'] = $send_data['data']['order_id'];
                $response_array['experience_order_id'] = $send_data['data']['experience_order_id'];

                return $response_array;

            } else {

                if(isset($send_data['error'])) {
                    $response_array ['status'] = 0;
                    $response_array ['message'] = $send_data['error']['message'];
                } else {

                    $response_array ['status'] = 0;
                    $response_array ['message'] = "Unable to process. Try again Later";
                }

                return $response_array;
            }


        } else {

            $response_array ['status'] = 99;
            $response_array ['message'] = "Error processing. Contact rewardsbox";
            return$response_array;
        }


    }

    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }

}


//$test = new xoxoday_class();
//echo json_encode($test->send_order("1234"));
//echo json_encode($test->create_order("Test", "Person", "testing@test.com", "9876543210","2018-11-30 05:00:00", 47477,"2",0,0,0,65,"abc1"));
//echo json_encode($test->get_hash("testing@test.com","9876543210","2018-09-29 08:00:00", "4435", 0, "e98opew212412", 1,"0"));
//echo json_encode($test->convert_xoxo_naira("GBP","65"));
//echo json_encode($test->get_product_details("https://corp.xoxoday.com/v2/getProduct?", "3", "1000","2",47477));
//echo json_encode($test->list_detail_items("https://corp.xoxoday.com/v2/",47477));
//echo json_encode($test->get_naira_products("https://corp.xoxoday.com/v2/getProducts","adventure","3","50", 1,5,222,2176));
//echo json_encode($test->get_products(222,2176,"adventure","https://corp.xoxoday.com/v2/getProducts"));
//echo json_encode($test->add_rates());
//echo json_encode($test->get_all_rates());