<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 30/10/2018
 * Time: 23:01
 */
require_once ("main_class.php");
require_once ("company_user_token_class.php");
require_once ("send_mail_class.php");
class company_user_class extends Rewardsbox_main
{

    private $table = "user_mgt_com_users";
    private $access_table = "user_mgt_com_user_access";





    public function create_company_user($first_name, $last_name, $email, $phone_no, $password, $company_id, $user_type){

        if(isset($first_name) && isset($last_name) && isset($email) && isset($phone_no) && isset($password) && isset($company_id) && isset( $user_type)){

            if($first_name == "" || $last_name == "" || $email == "" || $password == "" || $phone_no == "" || $company_id == "" || $user_type == "") {

                return "Blank parameters";

            }elseif (!is_numeric($phone_no) || !is_numeric($user_type) || strlen($phone_no)< 10 || strlen($phone_no)> 11) {


                return "Invalid mobile number";


            }elseif(strlen($password) < 6){

                return "Password minimum of 6 characters";

            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email address";


            } else {

                $check_type = $this->check_access($user_type);

                if (is_array($check_type)) {
                    $hash_password = hash('sha512', $password);
                    $columns = array("company_id", "username", "password", "first_name", "last_name", "phone_no", "status", "access_type");
                    $values = array($company_id, $email, $hash_password, $first_name, $last_name, $phone_no, 1, $user_type);
                    $p_where['column_name'] = "username";
                    $p_where['sign'] = "=";
                    $p_where['value'] = $email;
                    $where[] = $p_where;

                    $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where);

                    if (is_numeric($insert_data) && $insert_data > 0) {

                        $insert_array['id'] = $insert_data;
                        $insert_array['first_name'] = $first_name;
                        $insert_array['last_name'] = $last_name;
                        $insert_array['email'] = $email;
                        $insert_array['phone_no'] = $phone_no;
                        $insert_array['access_type'] = $check_type['access_type'];

                        $use_mail = new send_mail_class();
                        $use_mail->send_company_portal_enrol($first_name, $last_name, $email,$password);
                        return $insert_array;
                    } elseif ($insert_data < 0) {

                        return "User already exists";
                    } else {

                        return "Error creating user";
                    }
                } else {

                    return "Invalid User type";
                }

            }


        } else {


            return "Missing parameter";
        }


    }


    public function verify_account($username, $password){

        if (isset($username) && isset($password) && $password != "" && $username != "") {
            $columns = array("user_id", "company_id","access_type");

            $p_where['column_name'] = "username";
            $p_where['sign'] = "=";
            $p_where['value'] = $username;
            $where[] = $p_where;

            $hash_password = hash('sha512', $password);
            $p_where['column_name'] = "password";
            $p_where['sign'] = "=";
            $p_where['value'] = $hash_password;
            $where[] = $p_where;

            $get_data = $this->select_tb($this->table, $columns, $where);

            if (is_array($get_data)){

                $token_details= $get_data['data'][0];

                $use_com_token = new company_user_token_class();
                $create_token = $use_com_token->create_token($token_details['company_id'], $token_details['user_id'],$token_details['access_type']);
                return $create_token;

            } else {

                return "Invalid username or password okm";
            }

        } else {


            return "Missing Parameters";
        }

    }


    public function view_company_users ($company_id){

        $column = array("user_id","username", "first_name", "last_name", "phone_no","create_date",$this->access_table.".status", $this->access_table .".access_type");

        $p_where['column_name'] = "company_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $company_id;
        $where[] = $p_where;

        $firstjoin ['table_name'] = $this->access_table;
        $firstjoin ['first_column'] = $this->table.".access_type";
        $firstjoin ['second_column'] = $this->access_table . ".access_id";
        $leftjoin [] = $firstjoin;

        $get_data = $this->select_tb($this->table, $column, $where,"","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data;

        } else {

            return "No data found";
        }


    }

    public function change_password($user_id, $old_password, $new_password){

        if (isset($user_id) && isset($old_password) && isset($new_password)){

            if(strlen($new_password) < 6){

                return "Minimum length of 6 Characters";
            } else {

                $columns= array("user_id","username", "first_name", "last_name");

                $p_where['column_name'] = "user_id";
                $p_where['sign'] = "=";
                $p_where['value'] = $user_id;
                $where[] = $p_where;

                $p_where['column_name'] = "password";
                $p_where['sign'] = "=";
                $p_where['value'] = $hash_password = hash('sha512',$old_password);;
                $where[] = $p_where;

                $firstset['column_name'] = "password";
                $firstset['sign'] = "=";
                $firstset['value'] = $hash_password = hash('sha512',$new_password);;
                $set[] = $firstset;

                $check_user = $this->select_tb($this->table, $columns,$where);

                if (is_array($check_user)){

                    $update_data = $this->update_data($this->table,$set,$where);

                    if ($update_data == 1){

                        $use_mail = new send_mail_class();
                        $use_mail->company_portal_send_change_password($check_user['data'][0]['first_name'],$check_user['data'][0]['user_name'],$check_user['data'][0]['last_name']);
                        return $update_data;

                    } else {

                        return "Error changing password";
                    }

                } else {

                    return "Invalid Current Password";
                }


            }

        } else {

            return "Missing Parameter";
        }


    }

    public function view_profile($user_id){

        $columns= array("user_id","first_name", "last_name", "username", "phone_no");

        $p_where['column_name'] = "user_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $user_id;
        $where[] = $p_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }

    }

    public function view_access(){
        $columns = array("access_id","access_type");

        $p_where['column_name'] = "status";
        $p_where['sign'] = "=";
        $p_where['value'] = 1;
        $where[] = $p_where;

        $get_data = $this->select_tb($this->access_table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }

    public function check_access ($access_id){

        $columns = array("access_id","access_type");

        $p_where['column_name'] = "status";
        $p_where['sign'] = "=";
        $p_where['value'] = 1;
        $where[] = $p_where;

        $p_where['column_name'] = "access_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $access_id;
        $where[] = $p_where;

        $get_data = $this->select_tb($this->access_table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }

    }


    public function verify_active_account($user_name){

        $columns= array("user_id","first_name", "last_name", "username");

        $p_where['column_name'] = "username";
        $p_where['sign'] = "=";
        $p_where['value'] = $user_name;
        $where[] = $p_where;

        $p_where['column_name'] = "status";
        $p_where['sign'] = "=";
        $p_where['value'] = 1;
        $where[] = $p_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }


    }


    public function reset_password($user_name){

        if (filter_var($user_name, FILTER_VALIDATE_EMAIL)) {
            $check_user_name = $this->verify_active_account($user_name);

            if (is_array($check_user_name)) {

                $today_date = Date('Y-m-d H:i:s');


                $randno = mt_rand(1000000, 99999999);
                $hash_password = hash('sha512', $randno);

                $p_where['column_name'] = "user_id";
                $p_where['sign'] = "=";
                $p_where['value'] = $check_user_name['user_id'];
                $where[] = $p_where;

                $firstset['column_name'] = "password";
                $firstset['sign'] = "=";
                $firstset['value'] = $hash_password;
                $set[] = $firstset;

                $update_data = $this->update_data($this->table,$set,$where);

                    if ($update_data == 1){

                        $use_mail = new send_mail_class();
                        $use_mail->company_portal_reset_password($check_user_name['first_name'],$check_user_name['username'],$check_user_name['last_name'],$randno);
                        return $update_data;

                    } else {

                        return "Error changing password";
                    }


            } else {

                return "Invalid Account";
            }
        } else {

            return "Invalid Email address";
        }
    }


    public function view_managers($company_id){

        if(isset($company_id)) {
            $columns = array("user_id", "first_name", "last_name", "access_type");

            $p_where['column_name'] = "status";
            $p_where['sign'] = "=";
            $p_where['value'] = 1;
            $where[] = $p_where;

            $p_where['column_name'] = "access_type";
            $p_where['sign'] = "=";
            $p_where['value'] = $this->manger_type;
            $where[] = $p_where;

            $get_data = $this->select_tb($this->table, $columns, $where);

            if (is_array($get_data)) {

                return $get_data['data'];

            } else {

                return "No data found";
            }

        } else {

            return "Company required";
        }
    }


    public function confirm_manager($company_id, $user_id){

        if(isset($company_id)) {
            $columns = array("user_id", "first_name", "last_name", "access_type");

            $p_where['column_name'] = "status";
            $p_where['sign'] = "=";
            $p_where['value'] = 1;
            $where[] = $p_where;

            $p_where['column_name'] = "user_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $user_id;
            $where[] = $p_where;

            $p_where['column_name'] = "access_type";
            $p_where['sign'] = "=";
            $p_where['value'] = $this->manger_type;
            $where[] = $p_where;

            $get_data = $this->select_tb($this->table, $columns, $where);

            if (is_array($get_data)) {

                return $get_data['data'][0];

            } else {

                return "No data found";
            }

        } else {

            return "Company required";
        }
    }
}



//$test = new company_user_class();
//echo json_encode($test->view_managers(10));
//echo json_encode($test->confirm_manager(10,6));
//echo json_encode($test->reset_password("adeoye@loyaltysolutionsnigeria.com"));
//echo json_encode($test->verify_active_account("john@smith2.com"));
//echo json_encode($test->check_access(2));
//echo json_encode($test->view_access());
//echo json_encode($test->view_profile(5));
//echo json_encode($test->change_password(5,123457, 123458));
////echo json_encode($test->create_company_user("John","Smith","john@smith.com","08122890094", "123456","10"));
//echo json_encode($test->create_company_user("Jane","Smith","jane@smith.com","08122890095", "123456","10",7));
//echo json_encode($test->verify_account("john@smith.com", "123456"));
//echo json_encode($test->view_company_users(10));