<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 30/11/2018
 * Time: 13:08
 */
 
 
    header("Access-Control-Allow-Origin: *");
    header("Content-Type: application/json; charset=UTF-8");    
    header("Access-Control-Allow-Methods: GET, POST, DELETE, OPTIONS");    
    header("Access-Control-Max-Age: 3600");    
    header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, token, X-Requested-With");

require_once ("curl_class.php");
require_once ("company_category_class.php");
class interswitch_class extends curl_class
{

    private $clinet_id = "IKIA5F62AD1A1A3B2824CD75932518B2C9ED56513EE9";
    private $secret = "n1lzzpV86NsyMYgywZDg7m8A9/Ng2kZhdV3CBudwXk8=";
    private $start_url = "https://saturn.interswitchng.com/";
    private $auth_text = "InterswitchAuth";
    private $terminal_id = "3LYS0001";
    private $request_ref = 1738;
    private $table = "rewardsbox_gen_inter";
    private $order_no_table = "rewardsbox_gen_inter_order";
    private $signature_method = "SHA1";
    private $rims_partner_id = 122;
    private $log_table = "interswitch_order_log";
    private $airtime_wallet = 9;





    public function generateSignature($resourceUrl, $httpMethod, $timestamp, $nonce, $transactionParams) {

        $clientId = $this->clinet_id;
        $clientSecretKey = $this->secret;
        $resourceUrl = strtolower($resourceUrl);
        $resourceUrl = str_replace('http://', 'https://', $resourceUrl);
        $encodedUrl = urlencode($resourceUrl);

        $signatureCipher = $httpMethod . '&' . $encodedUrl . '&' . $timestamp . '&' . $nonce . '&' . $clientId . '&' . $clientSecretKey;

        if (!empty($transactionParams) && is_array($transactionParams)) {
            $parameters = implode("&", $transactionParams);
            $signatureCipher = $signatureCipher . $parameters;
        }

        $signature = base64_encode(sha1($signatureCipher, true));
        return $signature;
    }




    public function auth(){


        $auth = $this->auth_text." ".base64_encode($this->clinet_id);
        return $auth;
    }


    public function get_unique_nonce ($reason = "API Request"){

        $columns = array("details");
        $values = array($reason);

        $get_unique_no = $this->insert_data($this->table, $columns, $values);

        if($get_unique_no > 0){

            return $get_unique_no;

        } else {

            return 0;
        }

    }

    public function get_unique_order_no ($reason = "API order"){

        $columns = array("details");
        $values = array($reason);

        $get_unique_no = $this->insert_data($this->order_no_table, $columns, $values);

        if($get_unique_no > 0){

            return $get_unique_no;

        } else {

            return 0;
        }

    }

    public function get_header($verb, $end_point,$transactionParams = array()){

        $time_stamp = time();
        $nonce = $this->get_unique_nonce($end_point);
        $authorization = $this->auth();
        $signature = $this->generateSignature($end_point, $verb,$time_stamp,$nonce,$transactionParams);

        return $header = array('content-type: application/json','Authorization: ' . $authorization,'Signature: ' . $signature,'Timestamp: ' . $time_stamp,'Nonce: ' . $nonce,'SignatureMethod: ' . $this->signature_method,'TerminalID: ' . $this->terminal_id);
    }


    public function get_billers(){
        $verb = "GET";
        $end_point = $this->start_url."api/v2/quickteller/billers";
        $header = $this->get_header($verb, $end_point);

        $send_data = $this->send_get_v2($end_point,$header);

        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }



    }

    public function get_category(){
        $verb = "GET";
        $end_point = $this->start_url."api/v2/quickteller/categorys";
        $header = $this->get_header($verb, $end_point);

        $send_data = $this->send_get_v2($end_point,$header);

        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }



    }

    public function billers_category($id){
        $verb = "GET";
        $end_point = $this->start_url."api/v2/quickteller/categorys/".$id."/billers";
        $header = $this->get_header($verb, $end_point);

        $send_data = $this->send_get_v2($end_point,$header);

        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }



    }

    public function billers_items($biller_id){
        $verb = "GET";
        $end_point = $this->start_url."api/v2/quickteller/billers/".$biller_id."/paymentitems";
        $header = $this->get_header($verb, $end_point);

        $send_data = $this->send_get_v2($end_point,$header);
        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }



    }

    public function query_order($request_reference){
        $verb = "GET";
        $end_point = $this->start_url."api/v2/quickteller/transactions?requestreference=".$request_reference;
        $header = $this->get_header($verb, $end_point);

        $send_data = $this->send_get_v2($end_point,$header);

        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }
    }

    public function get_service_products ($partner_cat_id, $partner_id, $margin, $margin_type,$id_text){
        // echo $partner_cat_id;
        // echo "<br>";

        $get_data = $this->billers_items($partner_cat_id);

        
        if (is_array($get_data)){



                //$get_products_array ['total'] = $get_data['total'];
                $get_products = $this->arrange_list_cat_item($partner_id,$margin, $margin_type, $get_data['paymentitems'],$id_text, $partner_cat_id);

                if (is_array($get_products)){

                    $get_products_array['data'] = $get_products;
                    return $get_products_array;

                } else {

                    return "No product found under category";
                }




        } else {

            return "No products found";
        }

    }


    public function arrange_list_cat_item($partner_id, $margin, $margin_type, $result_array, $id_text, $partner_cat_id){
        $add_margin = new company_category_class();
        $products = array();
        $run_array = array();
        if($partner_cat_id == 217 || $partner_cat_id == 766 || $partner_cat_id == 848 || $partner_cat_id == 536 || $partner_cat_id == 158 || $partner_cat_id == 767 || $partner_cat_id == 1473 || $partner_cat_id == 1143 || $partner_cat_id == 2593 || $partner_cat_id == 2975 || $partner_cat_id == 995 || $partner_cat_id == 924 || $partner_cat_id == 561 || $partner_cat_id == 3253 || $partner_cat_id == 704 || $partner_cat_id == 267 || $partner_cat_id == 538 || $partner_cat_id == 3624) {

			$result_array[0]['amount'] = 50000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];
			
            $result_array[0]['amount'] = 100000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];

            $result_array[0]['amount'] = 200000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];

            $result_array[0]['amount'] = 500000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];

            $result_array[0]['amount'] = 1000000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];

            $result_array[0]['amount'] = 2000000;
			$result_array[0]['add_name'] = " - ".($result_array[0]['amount'] / 100);
            $run_array[] = $result_array[0];

	   		
        }elseif ($partner_cat_id == 901){
            unset($result_array[4]);

            $run_array = $result_array;
			
		}elseif ($partner_cat_id == 913){
            unset($result_array[7]);

            $run_array = $result_array;
		
		}elseif ($partner_cat_id == 109){
            unset($result_array[5]);

            $run_array = $result_array;
		
		}elseif ($partner_cat_id == 908){
            unset($result_array[5]);

            $run_array = $result_array;
		
		}elseif ($partner_cat_id == 104){
            unset($result_array[6]);

            $run_array = $result_array;
		}elseif ($partner_cat_id == 991){
            unset($result_array[89]);
			unset($result_array[90]);

            $run_array = $result_array;
		}elseif ($partner_cat_id == 857){
            unset($result_array[18]);
			
            $run_array = $result_array;
		}elseif ($partner_cat_id == 2950){
            unset($result_array[13]);
			
            $run_array = $result_array;
		}elseif ($partner_cat_id == 3241){
            unset($result_array[1]);
            unset($result_array[2]);
            unset($result_array[3]);
			
            $run_array = $result_array;
		}elseif ($partner_cat_id == 448){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            $result_array[2]['amount'] = 5000000;
            $result_array[3]['amount'] = 5000000;
            $result_array[4]['amount'] = 5000000;
            $result_array[5]['amount'] = 5000000;
			
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 936){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            $result_array[2]['amount'] = 5000000;
            $result_array[3]['amount'] = 5000000;
            
			
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 983){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 598){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 832){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 824){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 2678){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 831){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            
            $run_array = $result_array;
            
		}elseif ($partner_cat_id == 3286){
            $result_array[6]['amount'] = 5000000;
            $result_array[7]['amount'] = 5000000;
            $result_array[8]['amount'] = 5000000;
            $result_array[9]['amount'] = 5000000;
            $result_array[12]['amount'] = 5000000;
            $result_array[13]['amount'] = 5000000;
            $result_array[14]['amount'] = 5000000;
            $result_array[15]['amount'] = 5000000;
            $result_array[16]['amount'] = 5000000;
            $result_array[17]['amount'] = 5000000;
            $result_array[18]['amount'] = 5000000;
            $result_array[19]['amount'] = 5000000;
            $result_array[20]['amount'] = 5000000;
            
            $run_array = $result_array;
		}elseif ($partner_cat_id == 2956){
            $result_array[2]['amount'] = 5000000;
            
            
            $run_array = $result_array;
		}elseif ($partner_cat_id == 528){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            $result_array[2]['amount'] = 5000000;
            $result_array[3]['amount'] = 5000000;
            $result_array[4]['amount'] = 5000000;
            $result_array[5]['amount'] = 5000000;
            $result_array[6]['amount'] = 5000000;
			
            $run_array = $result_array;
		}elseif ($partner_cat_id == 3318){
            $result_array[0]['amount'] = 5000000;
            $result_array[1]['amount'] = 5000000;
            $result_array[2]['amount'] = 5000000;
            $result_array[3]['amount'] = 5000000;
            $result_array[4]['amount'] = 5000000;
            $result_array[5]['amount'] = 5000000;
            $result_array[6]['amount'] = 5000000;
            $result_array[7]['amount'] = 5000000;
            $result_array[8]['amount'] = 5000000;
            $result_array[9]['amount'] = 5000000;
			
            $run_array = $result_array;
		}elseif ($partner_cat_id == 3328){
            
            $result_array[1]['amount'] = 5000000;
            $result_array[2]['amount'] = 5000000;
            $result_array[3]['amount'] = 5000000;
            $result_array[4]['amount'] = 5000000;
            $result_array[5]['amount'] = 5000000;
            $result_array[6]['amount'] = 5000000;
            $result_array[7]['amount'] = 5000000;
            $result_array[9]['amount'] = 5000000;
			$result_array[11]['amount'] = 5000000;
            $result_array[12]['amount'] = 5000000;
            $result_array[14]['amount'] = 5000000;
            $result_array[15]['amount'] = 5000000;
            $result_array[16]['amount'] = 5000000;
            $result_array[17]['amount'] = 5000000;
            $result_array[19]['amount'] = 5000000;
            
            $result_array[20]['amount'] = 5000000;
            $result_array[23]['amount'] = 5000000;
            $result_array[24]['amount'] = 5000000;
            $result_array[25]['amount'] = 5000000;
            $result_array[27]['amount'] = 5000000;
            $result_array[28]['amount'] = 5000000;
            $result_array[29]['amount'] = 5000000;
            $result_array[32]['amount'] = 5000000;
			$result_array[36]['amount'] = 5000000;
            $result_array[37]['amount'] = 5000000;
            $result_array[39]['amount'] = 5000000;
            $result_array[40]['amount'] = 5000000;
            $result_array[41]['amount'] = 5000000;
            $result_array[42]['amount'] = 5000000;
            $result_array[43]['amount'] = 5000000;
            $result_array[44]['amount'] = 5000000;
            $result_array[45]['amount'] = 5000000;
            $result_array[46]['amount'] = 5000000;
            $result_array[47]['amount'] = 5000000;
            $result_array[48]['amount'] = 5000000;
            $result_array[49]['amount'] = 5000000;
            $result_array[50]['amount'] = 5000000;
            $result_array[51]['amount'] = 5000000;
			$result_array[52]['amount'] = 5000000;
            $result_array[53]['amount'] = 5000000;
            $result_array[56]['amount'] = 5000000;
            $result_array[57]['amount'] = 5000000;
            $result_array[58]['amount'] = 5000000;
            $result_array[59]['amount'] = 5000000;
            $result_array[60]['amount'] = 5000000;
            $result_array[61]['amount'] = 5000000;
            $result_array[62]['amount'] = 5000000;
			$result_array[63]['amount'] = 5000000;
            $result_array[64]['amount'] = 5000000;
            $result_array[65]['amount'] = 5000000;
            $result_array[66]['amount'] = 5000000;
            $result_array[67]['amount'] = 5000000;
            $result_array[68]['amount'] = 5000000;
            $result_array[69]['amount'] = 5000000;
            $run_array = $result_array;
        } else {

            $run_array = $result_array;
        }
        foreach ($run_array as $detail_array){
            $signal = array();
            $signal['item_code'] = $detail_array['paymentCode'];
            $signal['rb_partner_id'] = $partner_id;
//            if($partner_cat_id == 217){
//
//                $detail_array['amount'] = 500000;
//            }
            $signal['item_price'] = ((float)$detail_array['amount'] + (float)$detail_array['itemFee'] )/100 ;
            $signal['item_name'] = $detail_array['paymentitemname'];
            $signal['send_price'] = $detail_array['amount'];
            //$signal['is_variant'] = 0;
            //$signal['max_quantity'] = 1;






            $add_margin = new company_category_class();
            $main_detail = array();

			if (isset($detail_array['add_name'])) {
				$main_detail['product_name'] = $detail_array['paymentitemname'].$detail_array['add_name'];              
			  
            } else {
				$main_detail['product_name'] = $detail_array['paymentitemname'];
                
            }
			
            //$main_detail['product_name'] = $detail_array['paymentitemname'];
            if (isset($detail_array['item_desc'])) {
                $main_detail['description'] = $detail_array['item_desc'];
            } else {

                $main_detail['description'] ="";
            }

            $main_detail['max_quantity'] = 1;
            $main_detail['price'] = $add_margin->apply_margin($margin, $margin_type,$signal['item_price']);
            $signal['selling_price'] = $main_detail['price'];
            $main_detail['customer_id_text'] = $id_text;

            $signal['rims_partner_id'] = $this->rims_partner_id;

            //echo json_encode($signal);
            //echo "<br>";

            $main_detail['signature'] = $this->string_encrypt(json_encode($signal));


            if ($signal['selling_price'] >= $signal['item_price']){


                $products[] = $main_detail;

            }






        }

        return $products;
    }


    public function make_order ($payment_code, $customer_id, $mobile, $email, $send_amount,$reference){

        if (strlen($customer_id) > 50){

            $response_array ['status'] = 0;
            $response_array ['message'] ="Invalid length of Customer ID";
            $response_array['data'] = array($reference);
            return $response_array;

        } elseif ( strlen($mobile) > 13){

            $response_array ['status'] = 0;
            $response_array ['message'] ="Invalid length of Mobile Number";
            $response_array['data'] = array($reference);
            return $response_array;
        } else {
            //$ref_no = "00000003";
            $order_ref = $this->get_unique_order_no();
            $ref_no = str_pad($order_ref, 8, '0', STR_PAD_LEFT);
            $ref = $this->request_ref . $ref_no;
            $trans_array = array();
            $trans_array['TerminalId'] = $this->terminal_id;
            $trans_array['paymentCode'] = $payment_code;
            $trans_array['customerId'] = $customer_id;
            $trans_array['customerMobile'] = $mobile;
            $trans_array['customerEmail'] = $email;
            $trans_array['amount'] = $send_amount;
            $trans_array['requestReference'] = $ref;

            $verb = "POST";
            $end_point = $this->start_url . "api/v2/quickteller/payments/advices";
            $header = $this->get_header($verb, $end_point);

            $send_data = $this->send_post_v2($end_point, json_encode($trans_array), $header);
//echo json_encode($send_data);return;
            $result= json_decode($send_data,true);
            if (isset($result['responseCode']) && $result['responseCode'] = 90000) {

                $this->save_order_request(json_encode($trans_array), json_encode($send_data));
                $response_array ['status'] = 1;
                $response_array ['message'] = "success";
                return $response_array;
                //return $send_data;
            }elseif (isset($result['error'])){

                if(isset($result['errors'][0]['code']) && $result['errors'][0]['code'] == 90009){
                    $this->save_order_request(json_encode($trans_array), json_encode($send_data));
                    $response_array ['status'] = 99;
                    $response_array ['message'] = "Pending";
                    $response_array['data'] = array($reference);
                    return $response_array;

                } else {
                    $this->save_order_request(json_encode($trans_array), json_encode($send_data));
                    // $response_array ['status'] = 0;
                    // $response_array ['message'] = $result['errors'][0]['message'];
                    $response_array ['status'] = 99;
                    $response_array ['message'] = "Request Pending";
                    $response_array['data'] = array($reference);
                    return $response_array;
                }


            } else {

                $this->save_order_request(json_encode($trans_array), json_encode($send_data));
                $response_array ['status'] = 99;
                $response_array ['message'] = "Processing Request";
                $response_array['data'] = array($reference);
                return $response_array;
            }
        }


    }

    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }

    public function process_transaction($redemption_array, $delivery_array, $order_no){

//echo json_encode($redemption_array);
//echo "<br>";
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[4]['product_details'][0];

//        echo json_encode($order_item);
//        echo "<br>";
        $customer_id = $order_item['customer_id'];

        $payment_code = $order_item['signature']['item_code'];

        //$price = $order_item['signature']['send_price'];
		$send_price = $order_item['signature']['send_price'];
        $quantity = $order_item['quantity'];
        $price = (float)$send_price * (int)$quantity;
        $reference = $order_item['voucher_no'];


        $confirm_order = $this->make_order($payment_code, $customer_id, $phone_no, $email,$price, $reference);

        return $confirm_order;




    }

    public function send_customer_validation($body){






    }

    public function customer_validation ($payment_code, $customer_id)
    {

        $reference = "verify";
        if (strlen($customer_id) > 50) {

            $response_array ['status'] = 0;
            $response_array ['message'] = "Invalid length of Customer ID";
            $response_array['data'] = array($reference);
            return $response_array;
        } else {
            $send_array = array();
            $customer_array = array();

            $trans_array['paymentCode'] = $payment_code;
            $trans_array['customerId'] = $customer_id;

            $customer_array[] = $trans_array;
            $send_array['customers'] = $customer_array;
// echo json_encode($send_array);
            $verb = "POST";
            $end_point = $this->start_url . "api/v2/quickteller/customers/validations";
            $header = $this->get_header($verb, $end_point);

            $send_data = $this->send_post_v2($end_point, json_encode($send_array), $header);

            $result= json_decode($send_data,true);

            if(is_array($result)){

                if($result['Customers'][0]['responseCode'] ==90000){

                    $response_array ['status'] = 1;
                    $response_array ['message'] = "Success";
                    $response_array['name'] = $result['Customers'][0]['fullName'];
                    return $response_array;

                } else {
                    $response_array ['status'] = 0;
                    $response_array ['message'] = $result['Customers'][0]['responseDescription'];
                    return $response_array;
                }

            } else {
                $response_array ['status'] = 0;
                $response_array ['message'] = "unable to verify customer";
                return $response_array;
            }

        }
    }

    public function check_purchase_details ($price, $delivery_type, $quantity, $signature_array){

        if (isset($signature_array['selling_price'])){

            if($price == $signature_array['selling_price']){

                //if(isset($signature_array['item_price'])) {
                $get_purchase = $this->get_purchase_details($signature_array['selling_price'], $signature_array['item_price'], $quantity, $signature_array['item_code']);
                return $get_purchase;
//                } else {
//
//                    return "Price Confirmation Error";
//                }
            } else {

                return "Price mismatch";
            }
        } else {

            return "price not set";
        }
    }


    public function get_purchase_details($unit_selling_price, $unit_cost_price, $quantity, $item_code)
    {
        $get_type = $this->check_aritime_bill($item_code);

        if ($get_type == 1){

            $airtime_price = $this->airtime_cost_profit($unit_selling_price,$unit_cost_price,$quantity);
            return $airtime_price;

        } else {

            $bill_price = $this->bills_cost_profit($unit_selling_price,$unit_cost_price,$quantity);
            return $bill_price;
        }
    }

    public function check_aritime_bill ($item_code){
        //901 - airtel
        //913 - glo
        //109 - mtn
        //908 - 9mobile
        $code_array= array(90101,90102,90103,90104,90105,90106,91302,91303,91304,91305,91306,91307,91308,91309,10901,10902,10903,10904,10905,10906,10907,10908,90801,90802,90803,90804,90805,90806);

        if (in_array($item_code, $code_array)){

            return 1;
        } else {

            return 0;
        }

    }
    public function airtime_cost_profit($unit_selling_price ,$unit_cost_price, $quantity ){
        $use_main = new Rewardsbox_main();
        $partner_commission = 4 ; // percent
        $total_selling_price = (float)$unit_selling_price * (int)$quantity;
        $total_ini_cost_price = (float)$unit_cost_price * (int)$quantity;
        $rb_profit = $total_selling_price - $total_ini_cost_price;

        $profit_partner = ($partner_commission/100) * $total_ini_cost_price;

        $total_partner_cost = $total_ini_cost_price - $profit_partner;
        $total_profit = $rb_profit + $profit_partner;

        $r_array['selling_price'] = $unit_selling_price;
        $r_array['cost_price'] = $use_main->get_unit_cost_price($total_partner_cost, $quantity);
        $r_array['total_cost'] = $total_partner_cost;
        $r_array['profit'] = $total_profit;
        $r_array['alternate_wallet'] = $this->airtime_wallet;

        return $r_array;
    }


    public function bills_cost_profit($unit_selling_price, $unit_cost_price, $quantity){
        $use_main = new Rewardsbox_main();
        $admin_fee = 100;
        $partner_commission = 60 ; // on total cost
        $inter_commision = $admin_fee - $partner_commission;
        $total_selling_price = (float)$unit_selling_price * (int)$quantity;
        $total_ini_cost_price = (float)$unit_cost_price * (int)$quantity;
        $rb_profit = $total_selling_price - $total_ini_cost_price;

        $unit_partner_cost = (float)$unit_cost_price - $admin_fee;
        $total_partner_cost = ($unit_partner_cost * $quantity) + $inter_commision;

        $profit_partner = $total_ini_cost_price - $total_partner_cost;

        $total_profit = $profit_partner + $rb_profit;

        $r_array['selling_price'] = $unit_selling_price;
        $r_array['cost_price'] = $use_main->get_unit_cost_price($total_partner_cost, $quantity);
        $r_array['total_cost'] = $total_partner_cost;
        $r_array['profit'] = $total_profit;

        return $r_array;


    }
}



//$page_test = new interswitch_class();
//echo json_encode($page_test->query_order("141300000198"));
//echo json_encode($page_test->billers_items(158));
//echo json_encode(($page_test->billers_category(3)));
//echo json_encode(($page_test->get_category()));
//echo json_encode($page_test->customer_validation("90501","0000000001","abd"));
//echo json_encode($page_test->billers_category());
//echo json_encode($page_test->make_order("90101", "0000000001", "08122890094","adeoye@loyaltysolutionsnigeria.com", "1460000","1234sdf"));
//echo json_encode($page_test->get_service_products(104,"5","1000", "2","Decoder Number"));