<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 30/11/2018
 * Time: 23:30
 */

require_once ("curl_class.php");
require_once ("service_access_class.php");
require_once ("company_class.php");
require_once ("company_access_class.php");
class notification_class extends curl_class
{

    private $service_id = 5;
    private $master_token ="1002";
    private $url ='https://rewardsbox.perxclm.com/notification/v1/notification/?API_flag=';
    private $admin_url = 'https://rewardsbox.perxclm.com/notification/v1/notadmin/?API_flag=';
    private $lsl_no = "Client-LSL";

    public function set_header($token){

        return $header = array('content-type: multipart/form-data','master: ' . $this->master_token,'token: ' . $token);
    }

    public function set_master(){


        return $header = array('Content-type= multipart/form-data','master: ' . $this->master_token);
    }

    /********************** Template Types *******************************/

    public function fetch_template_types(){

        $api= "fetch_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    public function add_template_type($service_name){

        $api= "add_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['service_name'] = $service_name;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['service_name'] = $service_name;
                $d_array['id'] = $send_data['id'];
                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }


        } else {

            return "An error occurred";
        }

    }

    public function edit_default_template_type($service_name, $id){

        $api= "edit_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['service_name'] = $service_name;
        $body['id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['service_name'] = $service_name;

                $d_array['message'] = "Update successful";
                return $d_array;

            } else {

                return $send_data['message'];
            }


        } else {

            return "An error occurred";
        }

    }


    private function enable_template_type($id){

        $api= "enable_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_template_type($id){

        $api= "disable_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_template_type_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_template_type($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_template_type($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }



    /*********************************************************************/

    /********************** Default Templates *******************************/
    public function fetch_admin_templates(){

        $api= "fetch_default_templates";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    public function add_admin_templates($id, $subject, $content, $name){

        $api= "add_default_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_type_id'] = $id;
        $body['subject'] = $subject;
        $body['content'] = $content;
        $body['name'] = $name;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['subject'] = $subject;
                $d_array['id'] = $send_data['id'];
                $d_array['type'] = $send_data['not_type'];
                $d_array['name'] = $send_data['name'];
                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    public function edit_admin_template($id, $type_id, $subject, $content,$name){

        $api= "edit_default_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_type_id'] = $type_id;
        $body['not_temp_id'] = $id;
        $body['name'] = $name;
        $body['subject'] = $subject;
        $body['content'] = $content;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['subject'] = $subject;

                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }


        } else {

            return "An error occurred";
        }

    }


    private function enable_admin_templates($id){

        $api= "enable_default_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_temp_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_admin_templates($id){

        $api= "disable_default_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_temp_id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_admin_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_admin_templates($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_admin_templates($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }

    /*********************************************************************/
    /****************************company mail group******************************/

    public function add_lsl_mail_groups($group_name){

        $body['client_no'] = $this->lsl_no;
        $api = "add_copy_group";
        $url = $this->admin_url . $api;
        $set_header = $this->set_master();
        $body['group_name'] = $group_name;

        $send_data = $this->send_post($url, $body, $set_header);

        if (is_array($send_data)) {

            if ($send_data['status'] == 1001) {

                $d_array['subject'] = $group_name;
                $d_array['id'] = $send_data['id'];
                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }
    }


    public function add_com_mail_group($id, $group_name){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($id);
        if (is_array($get_company)) {

            $body['client_no'] = $get_company['client_no'];
            $api = "add_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_name'] = $group_name;

            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                if ($send_data['status'] == 1001) {

                    $d_array['subject'] = $group_name;
                    $d_array['id'] = $send_data['id'];
                    $d_array['message'] = "success";
                    return $d_array;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }
        } else {

            return "Invalid Company";
        }
    }

    public function edit_lsl_mail_group($group_id, $group_name){

        $body['client_no'] = $this->lsl_no;
        $api = "edit_copy_group";
        $url = $this->admin_url . $api;
        $set_header = $this->set_master();
        $body['group_name'] = $group_name;
        $body['group_id'] = $group_id;

        $send_data = $this->send_post($url, $body, $set_header);

        if (is_array($send_data)) {

            if ($send_data['status'] == 1001) {


                $d_array['message'] = "Updated successfully";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    public function edit_com_mail_group($id, $group_id, $group_name){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($id);
        if (is_array($get_company)) {

            $body['client_no'] = $get_company['client_no'];
            $api = "edit_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_name'] = $group_name;
            $body['group_id'] = $group_id;

            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                if ($send_data['status'] == 1001) {


                    $d_array['message'] = "Updated successfully";
                    return $d_array;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }
        } else {

            return "Invalid Company";
        }
    }

    private function enable_mail_group($id, $company_id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);
        if (is_array($get_company)) {

            $body['client_no'] = $get_company['client_no'];
            $api = "enable_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_id'] = $id;
            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return "An error occurred";
            }
        } else {

            return "Invalid Company";
        }
    }

    private function disable_mail_group($id,$company_id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);
        if (is_array($get_company)) {

            $body['client_no'] = $get_company['client_no'];
            $api = "disable_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_id'] = $id;
            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return "An error occurred";
            }
        } else {

            return "Invalid Company";
        }
    }

    public function change_group_status($status, $id, $company_id){
        if ($status == 0){

            $send_data = $this->disable_mail_group($id, $company_id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_mail_group($id, $company_id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }


    private function enable_lsl_mail_group($id){



            $body['client_no'] = $this->lsl_no;
            $api = "enable_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_id'] = $id;
            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return "An error occurred";
            }

    }

    private function disable_lsl_mail_group($id){

            $body['client_no'] = $this->lsl_no;
            $api = "disable_copy_group";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_id'] = $id;
            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return "An error occurred";
            }

    }

    public function change_lsl_group_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_lsl_mail_group($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_lsl_mail_group($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }

    public function fetch_email_group($client_no){

        $api= "fetch_copy_group";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_no'] = $client_no;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }


    public function fetch_email_group_admin($id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($id);
        if (is_array($get_company)){

            $client_no = $get_company['client_no'];
            return $this->fetch_email_group($client_no);
        } else {

            return "Invalid Company";
        }

    }

    public function fetch_email_group_lsl(){

        $client_no = $this->lsl_no;
        $get_data = $this->fetch_email_group($client_no);

        return $get_data;
    }
    /*********************************************************************/
    /***************************Add group mail***************************/

    public function add_group_email($group_id, $email){

//        $use_company = new Reward_company();
//        $get_company = $use_company->get_company($id);
//        if (is_array($get_company)) {


            $api = "add_group_email";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['group_id'] = $group_id;
            $body['email'] = $email;

            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                if ($send_data['status'] == 1001) {

                    $d_array['email'] = $email;
                    $d_array['id'] = $send_data['id'];
                    $d_array['message'] = "success";
                    return $d_array;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }
//        } else {
//
//            return "Invalid Company";
//        }
    }

    public function add_lsl_group_email_admin($group_id, $email){


            return $this->add_group_email($group_id,$email);


    }

    public function add_group_email_admin($id,$group_id, $email){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($id);
        if (is_array($get_company)) {

            $client_no = $get_company['client_no'];
            return $this->add_group_email($group_id,$email);
        } else {

            return "Invalid Company";
        }

    }


    public function edit_group_email($group_id, $group_email_id, $email){

        $api= "edit_group_email";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['group_email_id'] = $group_email_id;
        $body['group_id'] = $group_id;
        $body['email'] = $email;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                $d_array['message'] = "Updated successfully";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

//    public function edit_group_email_admin($id,$group_id, $group_email_id, $email){
//
//        $use_access = new company_access_class();
//        $get_token = $use_access->get_token_company($id);
//        if (is_array($get_token)){
//
//            $token = $get_token['company_token'];
//            return $this->edit_group_email($token,$group_id, $group_email_id, $email);
//        } else {
//
//            return "Invalid Company";
//        }
//
//    }


    private function enable_group_email($client_no, $id){

        $api= "enable_group_email";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['group_email_id'] = $id;
        $body['client_no'] = $client_no;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_group_email($client_no,$id){

        $api= "disable_group_email";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['group_email_id'] = $id;
        $body['client_no'] = $client_no;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_group_email_status($company_id, $status, $id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);
        if (is_array($get_company)) {

            $client_no = $get_company['client_no'];
            if ($status == 0) {

                $send_data = $this->disable_group_email($client_no, $id);

                if ($send_data['status'] == 1001) {

                    $d_array = array("success");
                    return $d_array;

                } else {

                    return $send_data['message'];
                }

            } elseif ($status == 1) {

                $send_data = $this->enable_group_email($client_no, $id);

                if ($send_data['status'] == 1001) {

                    $d_array = array("success");
                    return $d_array;

                } else {

                    return $send_data['message'];
                }

            } else {

                return "Invalid Status";
            }
        } else {

            return "Invalid Company";
        }

    }

    private function enable_lsl_group_email($id){

        $api= "enable_group_email";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['group_email_id'] = $id;
        $body['client_no'] = $this->lsl_no;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_lsl_group_email($id){

        $api= "disable_group_email";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['group_email_id'] = $id;
        $body['client_no'] = $this->lsl_no;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_lsl_group_email_status($status, $id){

            $client_no = $this->lsl_no;
            if ($status == 0) {

                $send_data = $this->disable_group_email($client_no, $id);

                if ($send_data['status'] == 1001) {

                    $d_array = array("success");
                    return $d_array;

                } else {

                    return $send_data['message'];
                }

            } elseif ($status == 1) {

                $send_data = $this->enable_group_email($client_no, $id);

                if ($send_data['status'] == 1001) {

                    $d_array = array("success");
                    return $d_array;

                } else {

                    return $send_data['message'];
                }

            } else {

                return "Invalid Status";
            }


    }

//    public function change_group_email_status_admin($id,$status, $id){
//
//        $use_access = new company_access_class();
//        $get_token = $use_access->get_token_company($id);
//        if (is_array($get_token)){
//
//            $token = $get_token['company_token'];
//            return $this->change_group_email_status($status, $id,$token);
//        } else {
//
//            return "Invalid Company";
//        }
//
//    }

    public function fetch_group_email($id, $group_id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($id);
        if (is_array($get_company)) {

            $body['client_no'] = $get_company['client_no'];
            $body['group_id'] = $group_id;
            $api = "fetch_group_email";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $send_data = $this->send_post($url,  $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Invalid Company";

        }
    }

    public function fetch_lsl_group_email($group_id){



            $body['client_no'] = $this->lsl_no;
            $body['group_id'] = $group_id;
            $api = "fetch_group_email";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $send_data = $this->send_post($url,  $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }

    }

//    public function fetch_group_email_admin($id){
//
//        $use_access = new company_access_class();
//        $get_token = $use_access->get_token_company($id);
//        if (is_array($get_token)){
//
//            $token = $get_token['company_token'];
//            return $this->fetch_group_email($token);
//        } else {
//
//            return "Invalid Company";
//        }
//
//    }

    /*********************************************************************/

    /***************************Add variables***************************/

    public function add_variables($var_name, $replace_var){

        $api= "add_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_name'] = $var_name;
        $body['replace_var'] = $replace_var;


        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['replace'] =$replace_var;
                $d_array['var_name'] =$var_name;
                $d_array['id'] = $send_data['id'];
                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    public function edit_variable($var_id, $var_name, $replace_var){

        $api= "edit_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_id'] = $var_id;
        $body['var_name'] = $var_name;
        $body['replace_var'] = $replace_var;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                $d_array['message'] = "Updated successfully";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    private function enable_variable($id){

        $api= "enable_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_variable($id){

        $api= "disable_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_variable_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_variable($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_variable($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }


    public function fetch_variables(){

        $api= "fetch_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    /*********************************************************************/

    /***************************link variables***************************/

    public function add_link($var_id, $notification_id){

        $api= "add_link_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_id'] = $var_id;
        $body['notification_id'] = $notification_id;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){

                $d_array['notification'] =$notification_id;
                $d_array['var_id'] =$var_id;
                $d_array['id'] = $send_data['id'];
                $d_array['var_name'] = $send_data['var_name'];
                $d_array['replace_var'] = $send_data['replace_var'];
                $d_array['not_type'] = $send_data['not_type'];
                $d_array['message'] = "success";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    public function edit_link($var_id, $note_id, $link_id){

        $api= "edit_link_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['var_id'] = $var_id;
        $body['notification_id'] = $note_id;
        $body['link_id'] = $link_id;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                $d_array['message'] = "Updated successfully";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    private function enable_link($id){

        $api= "enable_link_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['link_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_link($id){

        $api= "disable_link_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['link_id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_link_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_link($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_link($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }


    public function fetch_link(){

        $api= "fetch_link_variable";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    /*********************************************************************/

    /************************Send mail******************************/

    public function emailsend($client_no, $email, $note_type, $var_array){

        $api= "emailsend";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['email'] = $email;
        $body['not_type_id'] = $note_type;
        $body['client_no'] = $client_no;
        //$body['newreplace'] = array();
        $body['newreplace'] = $var_array;
        
        $send_data = $this->send_post_v9($url,$body,$set_header);
//echo gettype($send_data);return; 
        if(is_array($send_data)){
            //if ($send_data){
            if ($send_data['status'] == 1001){


                $d_array['message'] = "Message sent successfully";
                return $d_array;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    /**********************************************************************/
    /******************************client********************************/

    private function send_company($body){

        $api= "notificationclient";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
//        $body['client_no'] = $email;
//        $body['client_token'] = $note_type;
//        $body['client_token_expiry'] = json_encode($var_array);

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            if ($send_data['status'] == 1001){


                return $send_data;

            } else {

                return $send_data['message'];
            }
        } else {

            return "An error occurred";
        }

    }

    public function create_client($client_no, $client_name,$client_token, $token_expiry,$company_id){
        $service_id= $this->service_id;
        $body = array();
        if($client_no ==""){

            return "Invalid Client no";


        } else {

            $body['client_no'] = $client_no;
            if ($client_name !==""){

                $body['client_name'] = $client_name;
                if ($client_token == ""){

                    return "Token required";
                } else {
                    $body['client_token'] = $client_token;
                    if($token_expiry == ""){

                        return "Expiry date require";
                    } else {
                        $body['client_token_expiry'] = $token_expiry;
                        $make_company = $this->send_company($body);

                        if (is_array($make_company)) {
                            $use_service_access = new service_access_class();
                            if ($make_company['status'] == 1001){

                                $status = 1;
                            } else {
                                $status = 0;
                            }
                            $store_access = $use_service_access->register_access($company_id,$service_id,$make_company['status'],$make_company['message'],$status);
                            return "Client Created Successfully";

                        } else {

                            return "Error creating client";
                        }
                    }

                }
            } else {

                return "Client name required";
            }



        }


    }


    public function fetch_clients(){

        $api= "fetch_client";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }


    private function enable_client($id){

        $api= "enable_client";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_client($id){

        $api= "disable_client";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['client_id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_client_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_client($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_client($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }


    public function fetch_com_templates($client_no){


        $api = "fetch_com_templates";
        $url = $this->admin_url . $api;
        $set_header = $this->set_master();
        $body['client_no'] = $client_no;
        $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }

    }

    public function fetch_com_template_lsl(){

        $client_no = $this->lsl_no;
        $get_data = $this->fetch_com_templates($client_no);

        return $get_data;
    }


    public function fetch_com_templates_admin($company_id){

        $use_company = new Reward_company();
        $details = $use_company->get_company($company_id);

        if (is_array($details)) {
            $client_no = $details['client_no'];
            $api = "fetch_com_templates";
            $url = $this->admin_url . $api;
            $set_header = $this->set_master();
            $body['client_no'] = $client_no;
            $send_data = $this->send_post($url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Invalid company";
        }
    }


    public function fetch_templates(){

        $api= "fetch_all_com_templates";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $send_data = $this->send_get($url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    /**************************************Company Templates ********************************************/
    public function add_com_template($note_id, $bcc_group_id, $cc_group_id, $name, $company_id,$note_type_id){


        $use_company = new Reward_company();
        $get_details = $use_company->get_company($company_id);
        if (is_array($get_details)){

            $client_no = $get_details['client_no'];
            $api= "add_com_template";
            $url = $this->admin_url.$api;
            $set_header = $this->set_master();
            $body['client_no'] = $client_no;
            $body['not_id'] = $note_id;
            $body['not_type_id']=$note_type_id;
            $body['bccgroup_id'] = $bcc_group_id;
            $body['ccgroup_id'] = $cc_group_id;
            $body['name'] = $name;


            $send_data = $this->send_post($url,$body,$set_header);

            if (is_array($send_data)){

                if ($send_data['status'] == 1001){

//                    $d_array['id'] = $send_data['id'];
//                    $d_array['subject'] = $send_data['subject'];
//                    $d_array['name'] = $send_data['not_type'];
//                    $d_array['message'] = "success";
                    return $send_data;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }

        } else {

            return "Invalid  Company";
        }
    }

    public function edit_com_template($note_id, $bcc_group_id, $cc_group_id, $name,$subject, $content, $company_id){


        $use_company = new Reward_company();
        $get_details = $use_company->get_company($company_id);
        if (is_array($get_details)){

            $client_no = $get_details['client_no'];
            $api= "edit_com_template";
            $url = $this->admin_url.$api;
            $set_header = $this->set_master();
            $body['client_no'] = $client_no;
            $body['not_type_id'] = $note_id;
            $body['bccgroup_id'] = $bcc_group_id;
            $body['ccgroup_id'] = $cc_group_id;
            $body['name'] = $name;
            $body['subject'] = $subject;
            $body['content'] = $content;


            $send_data = $this->send_post($url,$body,$set_header);

            if (is_array($send_data)){

                if ($send_data['status'] == 1001){

//                    $d_array['id'] = $send_data['id'];
//                    $d_array['subject'] = $send_data['subject'];
//                    $d_array['name'] = $send_data['not_type'];
//                    $d_array['message'] = "success";
                    return $send_data;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }

        } else {

            return "Invalid  Company";
        }
    }


    public function add_lsl_com_template($note_id, $bcc_group_id, $cc_group_id, $name, $note_type_id){




            $client_no = $this->lsl_no;
            $api= "add_com_template";
            $url = $this->admin_url.$api;
            $set_header = $this->set_master();
            $body['client_no'] = $client_no;
            $body['not_id'] = $note_id;
            $body['not_type_id']=$note_type_id;
            $body['bccgroup_id'] = $bcc_group_id;
            $body['ccgroup_id'] = $cc_group_id;
            $body['name'] = $name;


            $send_data = $this->send_post($url,$body,$set_header);

            if (is_array($send_data)){

                if ($send_data['status'] == 1001){

                return $send_data;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }


    }

    public function edit_lsl_com_template($note_id, $bcc_group_id, $cc_group_id, $name,$subject, $content){



            $client_no = $this->lsl_no;
            $api= "edit_com_template";
            $url = $this->admin_url.$api;
            $set_header = $this->set_master();
            $body['client_no'] = $client_no;
            $body['not_type_id'] = $note_id;
            $body['bccgroup_id'] = $bcc_group_id;
            $body['ccgroup_id'] = $cc_group_id;
            $body['name'] = $name;
            $body['subject'] = $subject;
            $body['content'] = $content;


            $send_data = $this->send_post($url,$body,$set_header);

            if (is_array($send_data)){

                if ($send_data['status'] == 1001){

                    return $send_data;

                } else {

                    return $send_data['message'];
                }
            } else {

                return "An error occurred";
            }


    }

    private function enable_com_template($id){

        $api= "enable_com_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['com_not_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_com_template($id){

        $api= "disable_com_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['com_not_id'] = $id;
        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_com_template_status($status, $id){
        if ($status == 0){

            $send_data = $this->disable_com_template($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_com_template($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }

    public function fetch_template_variables($id){

        $api= "fetch_link_variable_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_type_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function fetch_default_template($id){

        $api= "fetch_single_default_templates";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_id'] = $id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data['data'];
        } else {

            return "An error occurred";
        }

    }


    public function fetch_type_template($type_id){

        $api= "fetch_single_default_template_type";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['not_type'] = $type_id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function fetch_com_single_template($template_id){

        $api= "fetch_com_single_template";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['com_not_id'] = $template_id;
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }


    public function edit_email_settings( $company_id, $setting_id, $smtp_flag, $host, $username, $password, $smtp_secure, $sender_email, $sender_name, $port, $smtp_auto_tls){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);
        if (is_array($get_company)) {

            $client_no = $get_company['client_no'];
            if (isset($setting_id) && isset($smtp_flag) && isset($host) && isset($username) && isset($password) && isset($smtp_secure) && isset($sender_email) && isset($sender_name) && isset($port) && isset($smtp_auto_tls)) {

                $api = "edit_email_setting";
                $url = $this->admin_url . $api;
                $set_header = $this->set_master();
                $body['setting_id'] = $setting_id;
                $body['client_no'] = $client_no;
                $body['smtp_flag'] = $smtp_flag;
                $body['host'] = $host;
                $body['password'] = $password;
                $body['smtpsecure'] = $smtp_secure;
                $body['sender_email'] = $sender_email;
                $body['sender_name'] = $sender_name;
                $body['port'] = $port;
                $body['smtpautotls'] = $smtp_auto_tls;

                $send_data = $this->send_post($url, $body, $set_header);

                if (is_array($send_data)) {

                    return $send_data;
                } else {

                    return "An error occurred";
                }
            } else {

                return "Missing Parameter";
            }
        } else {

            return "Invalid Company";
        }
    }


    private function enable_email_setting($id){

        $api= "enable_email_setting";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['setting_id'] = $id;

        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    private function disable_email_setting($id){

        $api= "disable_email_setting";
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
        $body['setting_id'] = $id;

        $send_data = $this->send_post($url, $body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return "An error occurred";
        }

    }

    public function change_email_settings($status, $id){
        if ($status == 0){

            $send_data = $this->disable_email_setting($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } elseif ($status == 1) {

            $send_data = $this->enable_email_setting($id);

            if ($send_data['status'] == 1001){

                $d_array = array("success");
                return $d_array;

            } else {

                return $send_data['message'];
            }

        } else {

            return "Invalid Status";
        }


    }
}

//$t_array['first_name'] = "Aces";
//$t_array['last_name'] = "Spades";

//$page_test = new notification_class();
//$html_array = $page_test->fetch_default_template(9);
//echo $html_array[0]['content'];
//echo json_encode($page_test->fetch_default_template(9));
//echo json_encode($page_test->add_com_template(5,"","","test123",10));
//echo json_encode($page_test->create_client("12","Cadbury","122","2020-09-18",18));
//echo json_encode($page_test->emailsend("Client-LSL","adeoye@loyaltysolutionsnigeria.com","1",$t_array));
//echo json_encode($page_test->fetch_type_template(1));
//echo json_encode($page_test->fetch_email_group_admin(10));
//echo json_encode($page_test->fetch_templates());
//echo json_encode($page_test->fetch_com_templates("Client-LSL"));
//echo json_encode($page_test->add_variables(1009, "testing", "#testing"));
//echo json_encode($page_test->change_group_status(0,14, 1009));
//echo json_encode($page_test->add_group_email(1009,14,"test@test.com"));
//echo json_encode($page_test->fetch_email_group(1009));
//echo json_encode($page_test->edit_com_mail_group(1009, 4, "new test"));
//echo json_encode($page_test->add_com_mail_group(1009,"Test group"));
//echo json_encode($page_test->edit_admin_template(7,3,"hello","<html><body>test123</body></html>"));
//echo json_encode($page_test->edit_default_template_type("edit_test", 9));
//echo json_encode($page_test->add_admin_templates(1,"test2", "<html><body>test</body></html>"));
//echo json_encode($page_test->add_template_type("test1291"));
//echo json_encode($page_test->fetch_admin_templates());
//echo json_encode($page_test->change_admin_status(1,1));
//echo json_encode($page_test->fetch_template_types());
//echo "<br>";
//echo json_encode($page_test->change_template_type_status(1,1));