<?php
require_once("main_class.php");
require_once("user_role_class.php");
require_once("permission_class.php");

class Create_pages extends Rewardsbox_main {
	
	private $pages_path = "../pages/";
	private $scripts_path = "../scripts/";
	private $delpath = "../bin/page";
    private $del_script = "../bin/script";
	private $defaultpage = "default";
	private $defaultpage_script = "default_script";
	private $extension = ".php";
	private $table = "usr_mgt_page";
	
	public function create_page ($page_name){
		
		$page_name = str_replace(" ","_",trim(strtolower($page_name)));
		$columns = array("page_name", "page_code","status");
		$table = "usr_mgt_page";
		$pagecode = md5($page_name);
		$values = array($page_name,"$pagecode","1");
		
		$thirdwhere['column_name'] ="page_name";
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$page_name;
		$where[] = $thirdwhere;
		
		$create_page = $this->insert_check_duplicate($table,$columns, $values, $where);
		
		if ($create_page > 0) {


			    $newpage = $this->pages_path . $page_name . $this->extension;
                $copy_source = $this->pages_path . $this->defaultpage . $this->extension;
                    $new_script = $this->scripts_path.$page_name.$this->extension;
                    $copy_script = $this->scripts_path . $this->defaultpage_script . $this->extension;

				if (copy($copy_source,$newpage)){
                        copy($copy_script,$new_script);
                    $open_roles = new Reward_user_role();
                    $open_permissions = new Reward_permission();
                    $get_roles = $open_roles->view_all_roles();

                    if (is_array($get_roles)) {

                        $error_roles = array();
                        foreach ($get_roles as $role) {

                            $create_permission = $open_permissions->create_permission($create_page, $role['role_id'],0,0,0,0);
                            if ($create_permission < 1){

                                $error_roles[] =$role['role_name'];
                            }
                        }

                        $error_length = count($error_roles);
                        if ($error_length >0) {

                            return "Page Created .. Errors ".json_encode($error_roles);
                        }else {

                            $insert_array['id'] = $create_page;
                            $insert_array['name'] = $page_name;

                            return $insert_array;
                        }

                    } else {
                        return "Error Creating roles";

                    }
				} else {
					return "Error Creating page";
				}

			
		} elseif ($create_page < 0) {
			return "Page already exists";
			
		} else {
			
			return "An error has occurred";
			
		}
		
	} // end create page
	


	public function change_name_page ($page_name, $new_name){
		$columns = array("page_id","page_name");
		$table = "usr_mgt_page";
		
		$thirdwhere['column_name'] ="page_name";
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$page_name;
		$where[] = $thirdwhere;
		
		$oldname = $this->select_tb($table,$columns,$where);
		//echo json_encode($oldname);
		//echo "<br>";
		if (is_array($oldname)) {
            $path = $this->pages_path;
            $script_path= $this->scripts_path;

		$new_file_name = $path.$new_name.$this->extension;
		$old_file_name = $path.$oldname['data'][0]['page_name'].$this->extension;

		$new_script_name = $script_path.$new_name.$this->extension;
		$old_script_name = $script_path.$oldname['data'][0]['page_name'].$this->extension;
		//echo $old_file_name;
		//echo "<br>";
		$page_id = $oldname['data'][0]['page_id'];
		$new_name_code = md5($page_name);

		$setwhere['column_name'] ="page_id";
		$setwhere['sign'] ="=";
		$setwhere['value'] =$page_id;
		$where_set[] = $setwhere;
		
		$firstset['column_name'] ="page_name";
		$firstset['sign'] ="=";
		$firstset['value'] =$new_name;
		$set[] = $firstset;

            $secondset['column_name'] ="page_code";
            $secondset['sign'] ="=";
            $secondset['value'] =$new_name_code;
            $set[] = $secondset;
		
		//echo $page_id;
		//echo "<br>";
		if (is_array($oldname)) {
				if (rename($old_file_name,$new_file_name)){
				        rename($old_script_name,$new_script_name);
							// update function
							if ($this->update_data($table,$set, $where) == 1){
								
								return "Name Changed";	
							}
							else {
								
								return "Update Error";	
							}
							
									
						} else {
							return "Error Renaming page";
						}
				
		} else {
			
			return 0;
		} 
		
	} else {
			return 0;
		} 
	
	
	
	}// end change name page


public function delete_page ($page_name){
		$columns = array("page_id","page_name");
		$table = "usr_mgt_page";
		
		$thirdwhere['column_name'] ="page_name";
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$page_name;
		$where[] = $thirdwhere;
		
		
		
		$oldname = $this->select_tb($table,$columns,$where);
		
		if (is_array($oldname)) {
		$page_id = $oldname['data'][0]['page_id'];	
		$new_file_name = $this->delpath.$page_name."_".$page_id.$this->extension;
		$new_script_name = $this->del_script.$page_name."_".$page_id.$this->extension;


		
		$old_file_name = $this->pages_path.$oldname['data'][0]['page_name'].$this->extension;
		$old_script_name = $this->scripts_path.$oldname['data'][0]['page_name'].$this->extension;
		
				if (rename($old_file_name,$new_file_name)){
                    rename($old_script_name,$new_script_name);
					if ($this->delete_data($table,$where) == 1) {
					return "Deleted";
					} else {
						return "An error occured";	
					}
				} else {
					return "Unable to locate file";	
				}
			
			
		} else {
			return "File not found";	
		}
		
}



public function change_page_status ($page_id, $new_status){
		$table = "usr_mgt_page";
		$key = $page_id;

		if($new_status == 1){
		    $msg = "Active";

        } else {
		    $msg = "Inactive";

        }
		$change_status=$this->change_status ($pageid, $new_status, $table,$key);
		if ($change_status == 101){

		    return "Page is now ".$msg;
        } elseif ($change_status ==204) {

		    return "Page not found";

        } else {
		    return "An error occurred";

        }
}

public function view_active_pages(){
    $columns = array("page_id","page_name");
    $table = "usr_mgt_page";
    $get_pages = $this->view_all_active_data($table,$columns);

    if (is_array($get_pages)){

        return $get_pages;
    } else{

        return "No Page found";
    }

}

public function view_all_pages(){
    $columns = array("page_id","page_name", "status");
    $table = "usr_mgt_page";

    $get_pages = $this->select_tb($table,$columns);

    if (is_array($get_pages)){

        return $get_pages['data'];

    } else {

        return "No Page Found";
    }
}

public function get_hash_page ($page_id){

	$column = array("page_code");
    $thirdwhere['column_name'] ="status";
    $thirdwhere['sign'] ="=";
    $thirdwhere['value'] =1;
    $where[] = $thirdwhere;

    $firstwhere['column_name'] ="page_id";
    $firstwhere['sign'] ="=";
    $firstwhere['value'] =$page_id;
    $where[] = $firstwhere;
    $get_hash_page = $this->select_tb($this->table,$column, $where);

    if(is_array($get_hash_page)){

        return $get_hash_page['data'][0]['page_code'];
    } else{

        return 0;
    }
}

public function get_page_name ($page_id){

    $column = array("page_name");
    $thirdwhere['column_name'] ="status";
    $thirdwhere['sign'] ="=";
    $thirdwhere['value'] =1;
    $where[] = $thirdwhere;

    $firstwhere['column_name'] ="page_id";
    $firstwhere['sign'] ="=";
    $firstwhere['value'] =$page_id;
    $where[] = $firstwhere;

    $get_page_name = $this->select_tb($this->table,$column, $where);

    if(is_array($get_page_name)){

        return $get_page_name['data'][0]['page_name'];
    } else{

        return "profile";
    }
}

public function get_page_hash ($hash_name){
    $column = array("page_name");
    $thirdwhere['column_name'] ="status";
    $thirdwhere['sign'] ="=";
    $thirdwhere['value'] =1;
    $where[] = $thirdwhere;

    $firstwhere['column_name'] ="page_code";
    $firstwhere['sign'] ="=";
    $firstwhere['value'] =$hash_name;
    $where[] = $firstwhere;

    $get_page_name = $this->select_tb($this->table,$column, $where);

    if(is_array($get_page_name)){

        return $get_page_name['data'][0]['page_name'];
    } else{

        return 0;
    }

}

    public function get_page_id ($page_name){
        $column = array("page_id");
        $thirdwhere['column_name'] ="status";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =1;
        $where[] = $thirdwhere;

        $firstwhere['column_name'] ="page_name";
        $firstwhere['sign'] ="=";
        $firstwhere['value'] =$page_name;
        $where[] = $firstwhere;

        $get_page_id = $this->select_tb($this->table,$column, $where);

        if(is_array($get_page_id)){

            return $get_page_id['data'][0]['page_id'];
        } else{

            return 0;
        }

    }

    public function get_page_access($page_name, $role_id){
	    $get_id = $this->get_page_id($page_name);
	        if ($get_id > 0){
	            $access_check = new Reward_permission();
	                $check_permission = $access_check->check_permission($get_id,$role_id);
	                    if (is_array($check_permission)){

	                        return $check_permission;
                        } else {

	                        return 0;
                        }

            } else {
	            return 0;
            }

    }
} // end class

//$page_test = new Create_pages();
//echo json_encode($page_test->view_active_pages());
//echo json_encode($page_test->view_active_pages());
//echo json_encode ($page_test->create_page("pages"));
//echo json_encode ($page_test->change_name_page("test1","new_test"));
//echo json_encode($page_test->change_name_page("test_3", "test_31"));
//echo json_encode($page_test->delete_page("test_31"));
//echo json_encode($page_test->view_page_type());
//echo json_encode($page_test->change_status(2,1));
//echo json_encode($page_test->edit_page_type("test1",1));
//echo json_encode($page_test->get_page_name(567));
//echo json_encode($page_test->get_hash_page(12));
//echo json_encode($page_test->get_page_hash("b9dacbc67962b9a91e45394e2cf0dbf6"));
//echo json_encode($page_test->get_page_id("test_2"));
?>