<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 12/10/2018
 * Time: 19:45
 */

require_once("curl_class.php");
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("tier_class.php");
require_once ("service_access_class.php");
class portal_user_class extends Rewardsbox_main
{

    private $table = "portal_users";
    private $details_table = "portal_user_details";
    private $url ='http://rewardsboxnigeria.com/customer_portal/public/api/';
    private $header;
    private $token = 9000;
    private $service_id = 2;


    public function confirm_member_no($company_id,$member_no){

        $columns =array("portal_user_id");
        $thirdwhere['column_name'] ="company_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="member_no";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$member_no;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }

    }

    public function view_company_portal($company_id){

        $columns =array("portal_user_id", "member_no");
        $thirdwhere['column_name'] ="company_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;



        $check_no =  $this->select_tb($this->table,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }


    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        return $this->header = array("token: " .$this->token,"content-type: application/json", "cache-control: no-cache");
    }



    public function create_portal_user($first_name, $last_name, $email, $password, $member_no, $company_id, $tier_id, $phone = null){

        if(isset($company_id) && isset($member_no) && isset($first_name) && isset($last_name) && isset($email) && isset($password) && isset($tier_id)){


            if($company_id == ""|| $member_no == "" || $first_name == "" || $last_name == "" || $email == "" || $password == "" || $tier_id == "") {

                return "Blank Parameter";
            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email";
            } elseif (strlen($password) < 6){


                return "Password has minimum of 6 characters";
            } else{

                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)){

                    $client_no = $check_company['client_no'];

                    $use_tier = new tier_class();

                    $check_tier = $use_tier->get_tier_name($tier_id);

                    if (is_array($check_tier)) {

                        if ($check_tier['status'] == 1) {

                            $points = $check_tier['credit_amount'];
                            $send_data = $this->send_member($first_name, $last_name, $email, $password, $password, $client_no, $points, $member_no, $phone);
                           //print_r($send_data);
                            if (is_array($send_data)) {

                                if($send_data['status'] == 200){
                                    $d_array ['first_name']=$send_data['data']['firstname'];
                                    $d_array['last_name'] = $send_data['data']['lastname'];
                                    $d_array ['email']=$send_data['data']['email'];
                                    $d_array['member_no'] = $send_data['data']['member_number'];
                                    $d_array ['address']="";
                                    $d_array['user_id'] = $send_data['data']['member_id'];
                                    $d_array ['points_raw']=$send_data['data']['balance_raw'];
                                    $d_array['points_virtual'] = $send_data['data']['balance_virtual'];
                                    $d_array['phone'] = $phone;

                                    $user_id = $d_array['user_id'];
                                    $save_user = $this->save_portal_user($first_name, $last_name, $email,$member_no,$company_id, $tier_id, $user_id);
                                    //print_r($save_user);
                                    return $d_array;

                                } else {

                                    return $send_data['data'];
                                }

                            } else {


                                return "Error sending data";
                            }
                        } else {

                            return "Tier Inactive";
                        }
                        } else {


                        return "Invalid tier";
                    }
                } else {


                    return "Invalid Company";
                }





            }


        } else {

            return "Missing Parameter";

        }


    }


    public function send_company ($client_name , $client_no, $token){
        $this->set_header();
        $api = "company/create";

        $body['name']= $client_name;
        $body['client_number']= $client_no;
        $body['token'] = $token;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "Registration failed";
        }



    }


    public function save_company($client_name, $client_no, $company_id, $token){

        $send_data = $this->send_company($client_name, $client_no, $token);
        $use_service_access = new service_access_class();
        if (is_array($send_data)){

            if($send_data['status'] == 200){
                $store_access = $use_service_access->register_access($company_id,$this->service_id,$send_data['status'],"success",1);
                return 1;

            } else {
                $store_access = $use_service_access->register_access($company_id,$this->service_id,$send_data['status'],$send_data['message'],0);
                return $send_data['data'];
            }

        } else {

            return $send_data;
        }


    }

    private function save_portal_user($first_name, $last_name, $email, $member_no, $company_id, $tier_id, $user_id ){

        $columns = array("company_id", "member_no", "first_name", "last_name","email", "tier_id", "portal_id","status");
        $values = array($company_id, $member_no, $first_name, $last_name, $email, $tier_id, $user_id,1);

        $thirdwhere['column_name'] = "member_no";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $member_no;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "company_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $company_id;
        $where[] = $thirdwhere;


        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where, 1);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            $insert_array['first_name'] = $first_name;
            $insert_array['last_name'] = $last_name;
            $insert_array['member_no'] = $member_no;
            $insert_array['email'] = $email;
            $insert_array['status'] = 1;

            return $insert_array;

        } elseif ($insert_data < 0) {
            return "Member no already exists";

        } else {
            return "An error occurred";
        }



    }
    public function send_member ($first_name, $last_name, $email, $password, $password_confirm, $client_no,$points, $member_no, $phone){


        $this->set_header();
        $api = "member/create";

        $body['firstname']= $first_name;
        $body['lastname']= $last_name;
        $body['client_number'] = $client_no;
        $body['email']= $email;
        $body['password']= $password;
        $body['password_confirmation'] = $password_confirm;
        $body['point'] = $points;
        $body['member_id'] = $member_no;
        $body['phone'] = $phone;
        $body['status'] = 1;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        //echo json_encode($fields);
        //echo "<br>";
        if(is_array($send_data)){

//            if($send_data['status'] == 200){
//
//
//
//
//
//            } else {
//
//                return json_encode($send_data['data']);
//            }
            return $send_data;
        } else {


            return "Member Registration failed";
        }

    }

    private function send_status ($client_no, $portal_id,$status ){

        $this->set_header();
        $api = "customer/status";

        $body['member_id']= $portal_id;
        $body['status']= $status;
        $body['client_number'] = $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

//        echo json_encode($fields);
//        echo "<br>";
        if(is_array($send_data)){

            return $send_data;
        } else {

            return "Status change failed";
        }

    }


    public function get_currency(){
        $this->set_header();
        $api = "appcurrency";
        $use_curl = new curl_class();
        $send_data = $use_curl->send_get($this->url.$api,$this->header);
        if(is_array($send_data)){

            if($send_data['status'] == 200) {
                return $send_data['data'];
            } else {

                return $send_data['data'];
            }
        } else {


            return "No data found";
        }



    }

    public function get_member ($client_no){


        $this->set_header();
        $api = "company/customer/list";

        $body['company_id']= $client_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }

    }

    public function get_member_balance ($user_id, $client_no){


        $this->set_header();
        $api = "customer/account/total";

        $body['member_id']= $user_id;
        $body['client_number']= $client_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }

    }


    public function get_company_members($client_no){

        $this->set_header();
        $api = "company/customer/list";

        $body['client_number']= $client_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
//print_r($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_company_transaction($client_no,$start_date = null, $end_date = null){

        $this->set_header();
        $api = "company/transaction/list";

        $body['client_number']= $client_no;

        if(isset($start_date) && isset($end_date)){

            $body['start_date']= $start_date;
            $body['end_date']= $end_date;
        }

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

//        if(is_array($send_data)){

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }


    public function get_customer_transaction($client_no, $user_id){

        $this->set_header();
        $api = "customer/transaction/list";

        $body['client_number']= $client_no;
        $body['member_id']= $user_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_customer_order($client_no, $user_id){

        $this->set_header();
        $api = "customer/order/list";

        $body['client_number']= $client_no;
        $body['member_id']= $user_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }


    }


    public function change_portal_status ($client_no, $portal_id, $new_status){

                //$columns = array($key,"status");



        if ($new_status == 1) {



            $msg = "Active";



        } else {

            $new_status = 0;

            $msg= "Inactive";

        }



        $change_status = $this->send_status($client_no, $portal_id, $new_status);

        if(is_array($change_status)) {

            if ($change_status['status'] == 200) {

                $d_array = array();

                //$d_array['reqstatus'] == 1;

                $d_array['status'] = $new_status;

                $d_array['message'] = "Successfully made " . $msg;

                return $d_array;


            }else {

                return $change_status['data'];

            }
        } else {

            return "Error changing status";
        }





    } // end change status

    public function get_customer_order_details($order_id){

        $this->set_header();
        $api = "customer/order";


        $body['order_id']= $order_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }


    }

    public function credit_customer($company_id, $portal_id, $points, $reason){

        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {

            $client_no = $check_company['client_no'];

            $this->set_header();
            $api = "customer/account/credit";


            $body['client_number'] = $client_no;
            $body['member_id'] = $portal_id;
            $body['point'] = $points;
            $body['reason'] = $reason;


            $fields = json_encode($body);
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

            if (is_array($send_data)) {

                if($send_data['status'] == 200){

                    return $send_data['data'];

                } else {

                    return $send_data['message'];
                }
            } else {


                return "No data found";
            }

        } else {

            return "Invalid Company";
        }
    }


    public function debit_customer($company_id, $portal_id, $points, $reason){

        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {

            $client_no = $check_company['client_no'];

            $this->set_header();
            $api = "customer/account/debit";


            $body['client_number'] = $client_no;
            $body['member_id'] = $portal_id;
            $body['point'] = $points;
            $body['reason'] = $reason;


            $fields = json_encode($body);
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

            if (is_array($send_data)) {

                if($send_data['status'] == 200){

                    return $send_data['data'];

                } else {

                    return $send_data['message'];
                }
            } else {


                return "No data found";
            }

        } else {

            return "Invalid Company";
        }
    }



    public function get_single_customer($client_no, $member_no){

        $this->set_header();
        $api = "company/customer/show";

        $body['client_number']= $client_no;
        $body['member_number']= $member_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_points_value($client_no, $naira_value){

        $this->set_header();
        $api = "appcurrency/convert";

        $body['client_number']= $client_no;
        $body['point']= $naira_value;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }


    public function get_com_currency($client_no){

        $this->set_header();
        $api = "appcurrency";

        $body['client_number']= $client_no;



        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function edit_com_currency($client_no,$currency, $rate, $is_currency){

        if($currency == ""){

            return "Currency name required";

        } else {


            if ($is_currency == 0 || $is_currency == 1) {

                if (is_numeric($rate) && $rate > 0) {

                    $this->set_header();
                    $api = "appcurrency/update";

                    $body['client_number'] = $client_no;
                    $body['is_currency_fixed'] = $is_currency;
                    $body['currency'] = $currency;
                    $body['rate'] = $rate;


                    $fields = json_encode($body);
                    $use_curl = new curl_class();
                    $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                    //var_dump($send_data);
//        if(is_array($send_data)){
                    if ($send_data['status'] == 200) {

                        return $send_data['data'];
                    } else {


                        return "No data found";
                    }
                } else {

                    return "Invalid rate";
                }

            } else {

                return "Invalid active flag";
            }
        }
    }


}


//$page_test = new portal_user_class();
//echo json_encode($page_test->get_com_currency(127892));
//echo json_encode($page_test->get_single_customer(127892,2111));
//echo json_encode($page_test->get_points_value(127892,1000));
//echo json_encode($page_test->credit_customer(10, 1,500,"test"));
//echo json_encode($page_test->get_customer_order_details(32));
//echo json_encode($page_test->get_customer_transaction("127892",1));
//echo json_encode($page_test->change_portal_status(127892, 52, 0));
//echo json_encode($page_test->send_status("127892", 52,1));
//echo json_encode($page_test->create_portal_user("test", "john", "test@test4.com", "112w123","993", 10, 1, 127892));
//echo json_encode($page_test->get_company_transaction(127892));
//echo json_encode($page_test->get_customer_transaction(127892, 1));
//echo json_encode($page_test->get_currency());
//echo json_encode ($page_test->send_company("Test_Company9","11111",800));
//echo json_encode($page_test->get_member_balance(1, 127892));
//echo json_encode($page_test->get_company_members(127892));
//echo json_encode($page_test->get_company_data(1));
//echo json_encode($page_test->view_company_portal(10));
//echo json_encode($page_test->confirm_member_no(10,2111));
//echo json_encode($page_test->send_member("King", "Hearts", "king@heart.com", "123456","123456","127892", 40,"3456","1234567890"));
