<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 13/12/2018
 * Time: 10:54
 */

require_once ("curl_class.php");
require_once ("database_class.php");
require_once ("company_category_class.php");
class uber_class extends curl_class
{

    private $start_url = "https://rewardsbox.perxclm.com/uber/api/v1/";
    //private $station_url ="http://staging.fuelvoucher.com.ng/ws/rest/app/dealer/stations/list";
    private $uber_image = "https://www.rewardsboxnigeria.com/rewardsbox/img/uber.png";
    private $token = "123456";
    private $rims_partner_id = 137;
    private $log_table = "uber_order_log";
    private $header = array('content-type: application/json');


    private function get_products (){

        $url = $this->start_url."products";

        $this->set_header();

        $send_data = $this->send_get($url,$this->header);

        if (is_array($send_data)){

            return $send_data;

        } else {

            return $send_data;
        }

    }


    public function get_service_products ($partner_id, $margin, $margin_type){

        $get_data = $this->get_products();


        if (is_array($get_data)){

            if($get_data['status'] == 1001){


                $get_product = $this->arrange_details($partner_id, $margin, $margin_type, $get_data['data']);

                if (is_array($get_product)){

                    return $get_product;
                } else {

                    return $get_product;
                }


            } else {

                return $get_data['message'];
            }


        } else {

            return $get_data;
        }

    }


    public function arrange_details ($partner_id, $margin, $margin_type, $product_array){

        if (is_array($product_array)) {
            $products = array();
            foreach ($product_array as $detail_array) {
                $signal = array();
                $signal['item_code'] = $detail_array['code'];
                $signal['rb_partner_id'] = $partner_id;
//            if($partner_cat_id == 905){
//
//                $detail_array['amount'] = 500000;
//            }
                $signal['item_price'] = (float)$detail_array['price'];
                $signal['item_name'] = $detail_array['name'];

//            $signal['is_variant'] = 0;
//            $signal['max_quantity'] = 1;


                $add_margin = new company_category_class();
                $main_detail = array();

                $main_detail['image'] = $this->uber_image;
                $main_detail['product_name'] = $detail_array['name'];
                if (isset($detail_array['item_desc'])) {
                    $main_detail['description'] = $detail_array['item_desc'];
                } else {

                    $main_detail['description'] = "";
                }

                $main_detail['max_quantity'] = $detail_array['max_no'];
                $main_detail['price'] = $add_margin->apply_margin($margin, $margin_type, $signal['item_price']);
                $signal['selling_price'] = $main_detail['price'];
                $signal['cost_price'] = $signal['item_price'];


                $signal['rims_partner_id'] = $this->rims_partner_id;

                //echo json_encode($signal);
                //echo "<br>";

                $main_detail['signature'] = $this->string_encrypt(json_encode($signal));


                if ($signal['selling_price'] >= $signal['item_price']) {


                    $products[] = $main_detail;

                }


            }

            return $products;

        } else {

            return "Invalid data parameters";
        }
    }



    private function set_header() {

        $this->header=array(
            'Content-type= application/json',
            'token:'. $this->token
        );

    }

    private function build_body($price, $phone_no, $email, $reference, $quantity, $item_code) {
        $data= array();
        if(is_numeric($price) && $price > 0){

            $data['price'] = $price;
        } else {

            return "Invalid Amount";
        }

        if(is_numeric($quantity) && $quantity > 0){

            $data['quantity'] = $quantity;
        } else {

            return "Invalid quantity";
        }


        if($item_code == ""){

            return "Blank item code";
        } else {

            $data['code'] = $item_code;
        }

        if($reference == ""){

            return "Blank reference";
        } else {

            $data['reference'] = $reference;
        }



        $data['phone_no'] = $phone_no;




        if($email == "") {

            return "Blank Email";
        }elseif (filter_var($email, FILTER_VALIDATE_EMAIL)){

            //$return_array['beneficiaryEmail'] = $email;
            $data['email'] = $email;
        } else {

            return "Invalid Email";
        }


//        echo $return_string;
//        echo "<br>";
        return $data;
    }


    private function send_transaction($body, $reference){
        $this->set_header();
        $end_point = $this->start_url."purchase";
        //$send_data = $this->send_post_v3($this->start_url."purchase",$body,$this->header);
        $send_data = $this->send_post_v3($end_point, $body,$this->header);
        $this->save_order_request(json_encode($body), json_encode($send_data));


        if(is_array($send_data)){

            if($send_data['status'] == 1001){

                $response_array['status'] =  1;
                $response_array['message'] =  "success";
                $response_array['codes'] =  $send_data['data'];
                $response_array['data'] = array($reference);

            } else {

                $response_array['status'] =  0;
                $response_array['message'] =  $send_data['message'];
                $response_array['data'] = array($reference);

            }

        } else {

            $response_array['status'] =  0;
            $response_array['message'] = $send_data;
        }

        //echo json_encode($response_array);
        //echo "<hr>";
        return $response_array;
    }

    public function get_uber_voucher($price, $phone_no, $email, $reference, $quantity, $item_code){


        $check_data = $this->build_body($price, $phone_no, $email, $reference, $quantity, $item_code);
        if (is_array($check_data)){

            $send_data = $this->send_transaction($check_data, $reference);

            return $send_data;

        } else {

            return $check_data;
        }

    }



    public function process_transaction($redemption_array, $delivery_array){

//echo json_encode($redemption_array);
//echo "<br>";
        $email = $delivery_array['email'];
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[10]['product_details'][0];



        $quantity = $order_item['quantity'];
        //$payment_code = $order_item['signature']['item_code'];

        $price = $order_item['signature']['cost_price'];
        //$total_price = (float)$price * (int)$quantity;
        $reference = $order_item['voucher_no'];
        $item_code = $order_item['signature']['item_code'];


        $confirm_order = $this->get_uber_voucher($price, $phone_no, $email, $reference, $quantity, $item_code);

        return $confirm_order;




    }


    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }
}


//$page_test = new uber_class();
//echo json_encode($page_test->get_uber_voucher(620, "08122890094", "adeoye@loyaltysolutionsnigeria.com", "abcd", 1, "UBER-620"));
//echo json_encode($page_test->get_products());
//echo json_encode($page_test->get_fuel_stations(213));
//echo json_encode($page_test->get_service_products(8,100,2));
//echo json_encode($page_test->get_fuel_voucher(2000,"08122890094","adeoye1225@gmail.com"));