<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 12:37
 */
require_once("curl_class.php");
require_once ("company_category_class.php");
require_once ("service_access_class.php");
require_once ("company_class.php");

class catalogue_service_class extends curl_class
{
    private $master_token ="1002";
    private $expire_date = 1036800;
    private  $service_id = 3;
    private $url = 'https://rewardsbox.perxclm.com/catalogue/api/company/v1/?API_flag=';
    private $admin_url = 'https://rewardsbox.perxclm.com/catalogue/api/rewardsbox/v1/?API_flag=';
	private $company_url ="https://rewardsbox.perxclm.com/catalogue/api/company/v1/?API_flag=";
    private $log_table = "catalogue_log";

    public function set_header($token){

        return $header = array('content-type: multipart/form-data','master: ' . $this->master_token,'token: ' . $token);
    }


//    public function set_master(){
//
//        return $header = array('content-type: multipart/form-data','token: ' . $this->master_token);
//    }


    public function list_cat_items ($url, $token, $cat_id,$page, $limit,$delivery_type,$sort, $max_price){


        $set_header = $this->set_header($token);

        $data['cat_id'] =json_encode([$cat_id]);
        if($page != null || $page!="") {
            $data['page'] = $page;
        }

        if($limit != null || $limit!="") {
            $data['limit'] = $limit;
        }

        if($delivery_type != null || $delivery_type!="") {
            $data['delivery_type'] = $delivery_type;
        }

        if($sort != null || $sort!="") {
            $data['sort'] = $sort;
        }

        if($max_price != null || $max_price!="") {
            $data['max_price'] = $max_price;
        }


        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }



    }
    
    public function featured_products($token, $limit = 4){

        $url = $this->company_url."featured_items";
        $set_header = $this->set_header($token);

        $data['limit'] =$limit;

        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }


    }

    public function get_featured_products($token, $get_margins){
        $get_data = $this->featured_products($token);
        if (is_array($get_data)) {
            if ($get_data['status'] == 1001) {

                $data_array['total'] = $get_data['total'];
                $product_array = $get_data['result_data'];

                foreach ($get_margins as $margin_array) {
                    $get_data_array = array();
                    $get_array['category_id'] = $margin_array['cat_id'];
                    $get_array['category_name'] = $margin_array['cat_name'];

                    $push_data_array = array();
                    foreach ($product_array as $product_result) {


                        if ($margin_array['partner_category_id'] == $product_result['item_category']) {

                            $push_data_array [] = $product_result;

                        }

                    }
//                    echo json_encode($push_data_array);
//                    echo "<hr>";
                    if (!empty($push_data_array)) {
                        $get_data_array = $this->arrange_list_cat_item(0, $margin_array['margin'], $margin_array['margin_type'], $push_data_array, $margin_array['cat_id']);

                        $get_array['data'] = $get_data_array;
                        $result_array [] = $get_array;
                    }

                }

                $data_array['data'] = $result_array;
                return $data_array;

            } else {

                return $get_data['status_message'];
            }
        } else {

            return "No data found";
        }

    }


    public function get_featured_cat_items_id ($company_id, $cat_id){
        $use_company = new Reward_company();
        $check_company = $use_company->get_company_details($company_id);

        if (is_array($check_company)){
            $client_no = $check_company['client_no'];
            return $this->get_featured_cat_items($client_no, $cat_id);

        }else {

            return $check_company;
        }


    }

    private function get_featured_cat_items ($client_no, $cat_id){

        if(isset($client_no) && isset($cat_id)) {
            $body['client_no'] = $client_no;
            $body['cat_id'] = json_encode(array($cat_id));
            $set_header = $this->set_master();
            $new_url = $this->admin_url . "featured_cat_items";
            $send_data = $this->send_post($new_url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Missing Parameter";
        }
    }

    public function add_featured_items_id ($company_id, $cat_id){
        $use_company = new Reward_company();
        $check_company = $use_company->get_company_details($company_id);

        if (is_array($check_company)){
            $client_no = $check_company['client_no'];
            return $this->add_featured_items($client_no, $cat_id);

        }else {

            return $check_company;
        }


    }

    private function add_featured_items ($client_no, $item_id){

        if(isset($client_no) && isset($item_id)) {
            $body['client_no'] = $client_no;
            $body['item_id'] =  $item_id;
            $set_header = $this->set_master();
            $new_url = $this->admin_url . "add_featured_item";
            $send_data = $this->send_post($new_url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Missing Parameter";
        }
    }

    public function delete_featured_items_id ($company_id, $cat_id){
        $use_company = new Reward_company();
        $check_company = $use_company->get_company_details($company_id);

        if (is_array($check_company)){
            $client_no = $check_company['client_no'];
            return $this->delete_featured_items($client_no, $cat_id);

        }else {

            return $check_company;
        }


    }

    private function delete_featured_items ($client_no, $item_id){

        if(isset($client_no) && isset($item_id)) {
            $body['client_no'] = $client_no;
            $body['item_id'] =  $item_id;
            $set_header = $this->set_master();
            $new_url = $this->admin_url . "delete_featured_item";
            $send_data = $this->send_post($new_url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Missing Parameter";
        }
    }


    public function get_all_featured_items_id ($company_id){
        $use_company = new Reward_company();
        $check_company = $use_company->get_company_details($company_id);

        if (is_array($check_company)){
            $client_no = $check_company['client_no'];
            return $this->get_all_featured_items($client_no);

        }else {

            return $check_company;
        }


    }

    private function get_all_featured_items ($client_no){

        if(isset($client_no)) {
            $body['client_no'] = $client_no;
            $set_header = $this->set_master();
            $new_url = $this->admin_url . "all_featured_items";
            $send_data = $this->send_post($new_url, $body, $set_header);

            if (is_array($send_data)) {

                return $send_data;
            } else {

                return 0;
            }
        } else {

            return "Missing Parameter";
        }
    }

    public function list_multi_cat_items ($url, $token, $category_array, $branch = null, $page, $limit){

        $set_header = $this->set_header($token);
        $data['cat_id'] =json_encode($category_array);
        if ($branch != null) {
            $data ['branch'] = json_encode([$branch]);
        }

        if ($page != null){

            $data ['page'] = $page;
        }

        if ($limit != null){

            $data ['limit'] = $limit;
        }

        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }



    }

    public function arrange_list_cat_item($partner_id, $margin, $margin_type, $result_array, $category_id){
        $add_margin = new company_category_class();
        $products = array();
//            echo json_encode($result_array);
//            echo "<hr>";
        foreach ($result_array as $result){
            $data = array();
            $d_array['p_id'] = $result['item_code'];
            $d_array['c_id'] = $category_id;
//            echo json_encode($d_array);
//            echo "<br>";
            $data['product_code']=base64_encode(json_encode($d_array));
//            echo $data['product_code'];
//            echo "<br>";
            $data['product']=$result['item_name'];
            $data['image']= $result['image_url'];
            $data['location'] = $partner_id;

            $new_price = $add_margin->apply_margin($margin, $margin_type, $result['item_price']);

            if ($new_price >= $result['item_price']){
                $data['price'] = $new_price;

                if(isset($result['sale_flag'])){

                    if ($result['sale_flag'] == 0 || $result['sale_flag'] == 1){

                        $data['sale'] = $result['sale_flag'];
                        if ($result['sale_flag'] == 1){

                            if(isset($result['old_price'])){

                                $old_price = $add_margin->apply_margin($margin, $margin_type, $result['old_price']);
                                $data['old_price'] = $old_price;
                            }
                        }

                    }
                }

                $products[] = $data;

            }

        }

        return $products;
    }

    public function get_multi_service_products($end_point, $token, $partner_id, $api_category_id_array,$get_margin_array, $branch, $page = null, $limit = null){

            $get_data = $this->list_multi_cat_items($end_point, $token,$api_category_id_array,$branch,$page, $limit);

            if(is_array($get_data)){
                if ($get_data['status'] == 1001){
                    $data_array['total'] = $get_data['total'];
                    $product_array = $get_data['result_data'];

                    foreach ($get_margin_array as $margin_array){

                      $get_array['category_id'] = $margin_array['cat_id'];
                      $get_array['category_name'] = $margin_array['cat_name'];
                       $get_data_array = array();
                        foreach ( $product_array as $product_result){

                            if($margin_array['partner_category_id'] == $product_result['item_category']){

                            //$get_data_array []= $product_result;
                                $get_data_array []= $this->arrange_list_detail($partner_id,$margin_array['margin'], $margin_array['margin_type'],$product_result);
                                //$get_mod_details = $this->arrange_list_detail($partner_id,$margin,$margin_type, $get_array['result_data'][0]);
                            }

                        }

                        $get_array['data'] = $get_data_array;
                        $result_array []=$get_array;
                    }

                    $data_array['data'] = $result_array;
                    return $data_array;

                } else {

                    return $get_data['status_message'];
                }

            } else {

                return "No product found";
            }


    }


    public function get_service_products ($url,$token,$partner_cat_id, $partner_id, $margin, $margin_type,$category_id, $page,$limit,$delivery_type=null,$sort = null, $max_price = null){

        if($sort != null || $sort!="") {
            if($sort == 1){

                $sort_name = "ASC";
            } elseif ($sort == 2){

                $sort_name="DESC";
            } else {

                $sort_name = null;
            }

        } else {

            $sort_name = null;
        }

        $get_data = $this->list_cat_items($url, $token, $partner_cat_id,$page,$limit,$delivery_type,$sort_name,$max_price);

        if (is_array($get_data)){

            if ($get_data['status'] == 1001){

                $get_products_array ['total'] = $get_data['total'];
                $get_products = $this->arrange_list_cat_item($partner_id,$margin, $margin_type, $get_data['result_data'],$category_id);

                if (is_array($get_products)){

                    $get_products_array['data'] = $get_products;
                    return $get_products_array;

                } else {

                    return "No product found under category";
                }

            } else {

                return $get_data['status_message'];
            }


        } else {

            return "No products found";
        }

    }

public function get_multi_service_group_products($end_point, $token, $partner_id, $api_category_id_array,$get_margin_array, $branch = null, $page = null, $limit = null, $delivery_type = null, $sort = null, $max_price = null){

        $get_data = $this->list_multi_cat_items($end_point, $token,$api_category_id_array,$branch,$page, $limit);

        if(is_array($get_data)){
            if ($get_data['status'] == 1001){
                $data_array['total'] = $get_data['total'];
                $product_array = $get_data['result_data'];

                    $get_data_array = array();
//                echo "<hr>";
//                echo json_encode($product_array);
                    foreach ( $product_array as $product_result){
                        $send_array = array();
//                        echo "<hr>";
//                        echo json_encode($product_result);
                        //if($margin_array['partner_category_id'] == $product_result['item_category']){

                        if (in_array($product_result['item_category'], array_column($get_margin_array, 'partner_category_id'))) {

                            $key = array_search($product_result['item_category'], array_column($get_margin_array, 'partner_category_id'));

                            $send_array []=$product_result;
                            $return_array = $this->arrange_list_cat_item($partner_id, $get_margin_array[$key]['margin'], $get_margin_array[$key]['margin_type'], $send_array, $get_margin_array[$key]['cat_id']);

                            $get_data_array [] = $return_array[0];


                        }

                    }
                $data_array['data'] = $get_data_array;
                return $data_array;

            } else {

                return $get_data['status_message'];
            }

        } else {

            return "No product found";
        }


    }
    
    public function get_product_details ($url,$token, $partner_id, $margin, $margin_type, $product_code){
        $get_array = $this->list_detail_items($url, $token, $product_code);

        if (is_array($get_array)){

            if($get_array['status'] == 1001){

                $get_mod_details = $this->arrange_list_detail($partner_id,$margin,$margin_type, $get_array['result_data'][0]);

                if (is_array($get_mod_details)){

                    return $get_mod_details;
                } else {

                    return "An error has occurred";
                }

            } else {

                return $get_array['status_message'];
            }
        } else {

            return "No details found";
        }

    }

    public function list_detail_items ($url, $token, $product_code){

        $set_header = $this->set_header($token);
        $new_url = $url."&item_code=".$product_code;
        $send_data = $this->send_get($new_url,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }



    }

    public function get_delivery_cost_response ($token, $array){

        $check_data = $this->get_delivery_cost($token, $array);


        if (is_array($check_data)){

            if ($check_data['status_code'] == 1001){

                $response['status'] = 1;
                $response['price'] = $check_data['price'];
            } else {
                $response['status'] = 0;
                $response['message'] = $check_data['status_message'];
                if (isset($check_data['items'])) {
                    $get_item_status = $this->confirm_item_array($check_data['items']);
                    if (is_array($get_item_status)) {

                        $response['error'] = $get_item_status;
                    } else {

                        $response['error'] = "Invalid Items in Cart";
                    }


                }
            }
            return $response;
        } else {

            return $check_data;
        }

    }

    public function get_delivery_cost ($token, $array){

            $set_header = $this->set_header($token);
            $new_url =$this->company_url."get_delivery_price";
            $send_data = $this->send_post($new_url,$array,$set_header);
            //$this->save_order_request(json_encode($array),json_encode($send_data));
            if (is_array($send_data)){

                return $send_data;
            } else {

                return 0;
            }
        
    }

    public function get_delivery_cost_admin ($array){

        $set_header = $this->set_master();
        $new_url =$this->admin_url."admin_delivery_price";
        $send_data = $this->send_post($new_url,$array,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    
    public function get_delivery_cost_alt ($array){

        $set_header = $this->set_master();
        $new_url =$this->admin_url."get_delivery_price_alt";
        $send_data = $this->send_post($new_url,$array,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }

    }

    public function arrange_list_detail($partner_id, $margin, $margin_type,$detail_array){

        $signal = array();
        $signal['item_code'] = $detail_array['item_code'];
        $signal['rb_partner_id'] = $partner_id;
        $signal['item_price'] = $detail_array['item_price'];
        $signal['item_name'] = $detail_array['item_name'];
        $signal['is_variant'] = $detail_array['is_variant'];
        $signal['max_quantity'] = $detail_array['qty'];
        $signal['delivery_type'] = $detail_array['delivery_type'];
        $signal['branch_details'] = $detail_array['partnerbranch'];




        $add_margin = new company_category_class();
        $main_detail = array();

        $main_detail['product_name'] = $detail_array['item_name'];
        if (isset($detail_array['item_desc'])) {
            $main_detail['description'] = $detail_array['item_desc'];
        } else {

            $main_detail['description'] ="";
        }
        $main_detail['delivery_type'] = $detail_array['delivery_type'];
        $main_detail['max_quantity'] = $detail_array['qty'];
        $main_detail['price'] = $add_margin->apply_margin($margin, $margin_type,$detail_array['item_price']);
        $signal['selling_price'] = $main_detail['price'];
        $main_detail['image'] = $detail_array['image'];
        $main_detail['branch_details'] = $detail_array['partnerbranch'];
        $main_detail['is_variant'] = $detail_array['is_variant'];
        $signal['rims_partner_id'] = $detail_array['rims_partner_id'];

            if(isset($detail_array['sale_flag'])){

                if ($detail_array['sale_flag'] == 0 || $detail_array['sale_flag'] == 1){

                    $main_detail['sale'] = $detail_array['sale_flag'];
                    if ($detail_array['sale_flag'] == 1){

                        if(isset($detail_array['old_price'])){

                            $old_price = $add_margin->apply_margin($margin, $margin_type, $detail_array['old_price']);
                            $main_detail['old_price'] = $old_price;
                        }
                    }

                }
            }


        if ($detail_array['is_variant'] == 1){
            $signal['attr_type'] = $detail_array['attr_type'];
            $mod_attribute_array = array();
            foreach ($detail_array['attributes'] as $attribute_array)
            {
                $attribute_array['type'] = $signal['attr_type'];

                $mod_attribute_array [] = $attribute_array;
            }
        //$signal['attributes'] = $detail_array['attributes'];
            $main_detail['attributes'] = $mod_attribute_array;

            if($detail_array['attr_type'] == 1) {
                $signal['attributes'] = $mod_attribute_array;

                //$signal['combinations'] = $detail_array['combinations'];


                foreach ($detail_array['combinations'] as $price_combination) {
                    $combination_array = $price_combination;
                    $signal_array = $price_combination;
                    $combination_array['price'] = $add_margin->apply_margin($margin, $margin_type, $price_combination['price']);
                    $signal_array['selling_price'] = $combination_array['price'];
                    $main_detail['combinations'][] = $combination_array;
                    $signal['combinations'][] = $signal_array;

                }
            }
        }
        $main_detail['signature'] = $this->string_encrypt(json_encode($signal));
        return $main_detail;
    }

private function check_combination_array($main_array, $target_array){

    foreach ($main_array as $test) {
        if (count(array_intersect($test['comb'], $target_array)) == count($target_array)) {

            $result_array ['price'] = $test['price'];
            $result_array['selling_price'] = $test['selling_price'];
            return $result_array;
        }


    }
    return 0;
}

   public function check_purchase_details ($price, $delivery_type, $branch_id = null,$variants= null, $signature_array, $remark = null){

      $check_delivery_type = $this->check_delivery_type($delivery_type, $branch_id);

      if ($check_delivery_type == 1){

          if (isset($signature_array['is_variant'])){



                  if ($signature_array['is_variant'] == 0 || $signature_array['is_variant'] == 1) {
                      if ($signature_array['is_variant'] == 1) {

                          if (isset($signature_array['attr_type'])) {

                              if($signature_array['attr_type'] == 1) {
                                  if (is_array($variants)) {
                                      if (isset($signature_array['combinations'])) {


                                          if (is_array($signature_array['combinations'])) {


                                              $check_comb_price = $this->check_combination_array($signature_array['combinations'], $variants);
                                              if (is_array($check_comb_price)) {

                                                  if ($check_comb_price['selling_price'] == $price) {

                                                      $return_array['selling_price'] = $price;
                                                      $return_array['cost_price'] = $check_comb_price['price'];
                                                      return $return_array;

                                                  } else {

                                                      return "Price mis-match";
                                                  }

                                              } else {

                                                  return "combination not found";
                                              }


                                          } else {

                                              return "Combination is not an array";
                                          }

                                      } else {

                                          return "Cannot find combination";
                                      }

                                  } else {

                                      return "Invalid variants sent";
                                  }
                              } else {
                                  if (isset($remark)){
                                      if ($remark == ""){

                                          return "Blank or Missing Remark Information";

                                      } else {

                                          if (isset($signature_array['selling_price'])) {

                                              if ($price == $signature_array['selling_price']) {
                                                  $return_array['selling_price'] = $price;
                                                  $return_array['cost_price'] = $signature_array['item_price'];
                                                  return $return_array;

                                              } else {

                                                  return "Price mismatch";
                                              }
                                          } else {

                                              return "price not set";
                                          }
                                      }

                                  } else {

                                      return "Additional information required";
                                  }


                              }
                          } else {

                              return "Invalid Attribute type";
                          }
                      } else {

                          if (isset($signature_array['selling_price'])) {

                              if ($price == $signature_array['selling_price']) {
                                  $return_array['selling_price'] = $price;
                                  $return_array['cost_price'] = $signature_array['item_price'];
                                  return $return_array;

                              } else {

                                  return "Price mismatch";
                              }
                          } else {

                              return "price not set";
                          }
                      }


                  } else {

                      return "Invalid variant status";
                  }

          } else {

              return "Blank variant status";
          }

      } else {

          return $check_delivery_type;
      }

   }


   private function check_delivery_type ($delivery_type, $branch_id = null){

        if ($delivery_type == 1 || $delivery_type == 2){

            if ($delivery_type ==1 && $branch_id == null){

                return "Branch required";
            } elseif ($delivery_type == 1 && !is_numeric($branch_id)){

                return "Invalid branch";
            } else {

                return 1;
            }

        } else {

            return "Invalid delivery type";
        }
   }




    public function process_transaction($rb_array, $delivery_array, $order_no, $is_shipping, $token){
//        echo json_encode($delivery_array);
//        echo "<br>";
        $all_voucher = array();
       $catalogue_array = array();
       $catalogue_array['order_no'] = $order_no;
       if($is_shipping == 0) {
           $catalogue_array['delivery_details']= array();
       } else {
           $catalogue_array['delivery_details']['name'] = $delivery_array['first_name'] . " " . $delivery_array['last_name'];
           $catalogue_array['delivery_details']['price'] = $delivery_array['shipping_cost'];
           $catalogue_array['delivery_details']['phone_no'] = $delivery_array['phone_no'];
           $catalogue_array['delivery_details']['email'] = $delivery_array['email'];
           $catalogue_array['delivery_details']['address'] = $delivery_array['address'];
           $catalogue_array['delivery_details']['state'] = $delivery_array['state_id'];
           $catalogue_array['delivery_details']['city'] = $delivery_array['city_id'];
       }
           foreach ($rb_array[1]['product_details'] as $rb){

            $item_array['item_code']=$rb['signature']['item_code'];
            $item_array['unit_price']=$rb['cost_price'];
            $item_array['delivery_type']=$rb['delivery_type'];

            if(isset($rb['branch_id']) ){

                $item_array['branch_id'] = $rb['branch_id'];
            } else {
                $item_array['branch_id'] = 0;
            }


            if($rb['signature']['is_variant'] == 1) {
                if($rb['signature']['attr_type'] == 1) {
                    $item_array['variants'] = $rb['variants'];
                } elseif ($rb['signature']['attr_type'] == 7){

                    $item_array['attributes'] = $rb['variants'];
                } else {
                    $item_array['remark'] = $rb['remark'];
                }
            }
            $item_array['qty_ordered']=$rb['quantity'];
            $item_array['voucher_no']=$rb['voucher_no'];
            $item_array['ref_no']=$rb['ref_no'];
            $item_array['expiry_date']= date('Y-m-d H:i:s', time() +$this->expire_date);

            $catalogue_array['item_details'][] = $item_array;

            $all_voucher []=$rb['voucher_no'];
           }

        $catalogue_array['delivery_details'] =json_encode($catalogue_array['delivery_details']);
           $catalogue_array['item_details'] = json_encode($catalogue_array['item_details']);


        $send_data = $this->send_order($token, $catalogue_array);
        $this->save_order_request(json_encode($catalogue_array),json_encode($send_data));
       if (is_array($send_data)){
//echo json_encode($send_data);
//echo "<br>";
           if($send_data['status'] == 1001){
               $response_array ['status'] = 1;
               $response_array ['message'] ="success";
               $response_array['data'] = $send_data['result_data'];
               return $response_array;
           } else {

               $response_array ['status'] = 0;
               $response_array ['message'] = $send_data['status_message'];

               if (isset($send_data['items'])) {
                   $get_item_status = $this->confirm_item_array($send_data['items']);
                   if(is_array($get_item_status)){

                       $response_array['error'] = $get_item_status;
                   } else {

                       $response_array['error'] = "Invalid Items in Cart";
                   }

               }

               $response_array['data'] = $all_voucher;
               if ($is_shipping == 1){
                   $response_array['delivery_failed'] = 1;

               }
               return $response_array;
           }


       } else {

           $response_array ['status'] = 99;
           $response_array ['message'] = "Error confirming purchase";
           $response_array['data'] = $all_voucher;
           if ($is_shipping == 1){
               $response_array['delivery_failed'] = 99;

           }
           return $response_array;

       }
    }


    public function send_order ($token, $array){

        $set_header = $this->set_header($token);
        $new_url =$this->company_url."redeem_items";
        $send_data = $this->send_post($new_url,$array,$set_header);

        if (is_array($send_data)){
//
            return $send_data;
        } else {

            return 0;
        }

    }

    public function set_master(){

        return $header = array('content-type: multipart/form-data','token: ' . $this->master_token);
    }


    private function send_company ($body){

        $api = 'create_service';
        $url = $this->admin_url.$api;
        $set_header = $this->set_master();
//        echo json_encode($set_header);
//        echo "<br>";
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }

    public function create_client($client_no, $client_name,$client_token, $token_expiry,$company_id){
        $service_id= $this->service_id;
        $body = array();
        if($client_no ==""){

            return "Invalid Client no";


        } else {

            $body['client_no'] = $client_no;
            $body['client_id'] = $company_id;
            if ($client_name !==""){

                $body['service_name'] = $client_name;
                if ($client_token == ""){

                    return "Token required";
                } else {
                    $body['service_token'] = $client_token;
                    if($token_expiry == ""){

                        return "Expiry date require";
                    } else {
                        $body['expiry'] = $token_expiry;
                        $make_company = $this->send_company($body);

                        if (is_array($make_company)) {
                            $use_service_access = new service_access_class();
                            if ($make_company['status'] == 1001){

                                $status = 1;
                            } else {
                                $status = 0;
                            }
                            $store_access = $use_service_access->register_access($company_id,$service_id,$make_company['status'],$make_company['status_message'],$status);
                            return $make_company;

                        } else {

                            return "Error creating client";
                        }
                    }

                }
            } else {

                return "Client name required";
            }



        }


    }

    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }


    public function get_multi_summary_products ($token, $api_category_id_array,$get_margin_array, $limit = null, $max_price = null){

        $get_products = $this->get_summary_products_api($token, $api_category_id_array,$limit,$max_price);

        if (is_array($get_products)) {
            if ($get_products['status'] == 1001) {

//                echo json_encode($get_margin_array);
//                echo "<hr>";
//                echo json_encode($get_products);
//                echo "<hr>";
                $data_array['total'] = $get_products['total'];
                $product_array = $get_products['result_data'];

                foreach ($get_margin_array as $margin_array) {
                    $get_data_array = array();
                    $get_array['category_id'] = $margin_array['cat_id'];
                    $get_array['category_name'] = $margin_array['cat_name'];

                    $push_data_array = array();
                    foreach ($product_array as $product_result) {


                        if ($margin_array['partner_category_id'] == $product_result['item_category']) {

                            $push_data_array []= $product_result;
                            //$get_data_array[] = $this->arrange_list_cat_item(0,$margin_array['margin'], $margin_array['margin_type'],$product_result,$margin_array['cat_id']);
                            //$get_data_array [] = $this->arrange_list_detail($partner_id, $margin_array['margin'], $margin_array['margin_type'], $product_result);
                            //$get_mod_details = $this->arrange_list_detail($partner_id,$margin,$margin_type, $get_array['result_data'][0]);
                        }

                    }
//                    echo json_encode($push_data_array);
//                    echo "<hr>";
                    if (!empty($push_data_array)) {
                        $get_data_array = $this->arrange_list_cat_item(0, $margin_array['margin'], $margin_array['margin_type'], $push_data_array, $margin_array['cat_id']);
                    }
                    $get_array['data'] = $get_data_array;
                    $result_array [] = $get_array;
                }

                $data_array['data'] = $result_array;
                return $data_array;

            } else {

                return $get_products['status_message'];
            }
        } else {

            return "No data found";
			//return $get_products;
        }

    }

    public function get_summary_products_api($token, $category_array, $limit = 6, $max_price = null){
        $url= $this->company_url."get_random_item";
        $set_header = $this->set_header($token);
        $data['cat_id'] =json_encode($category_array);
        $data ['max_price'] = $max_price;
        $data ['limit'] = $limit;


        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            //return 0;
			return $send_data;
        }


    }

    public function get_multi_search_products ($token, $api_category_id_array,$get_margin_array, $search, $delivery_type = null, $sort = null, $max_price = null){

        if($sort != null || $sort!="") {
            if($sort == 1){

                $sort_name = "ASC";
            } elseif ($sort == 2){

                $sort_name="DESC";
            } else {

                $sort_name = null;
            }

        } else {

            $sort_name = null;
        }
        $get_products = $this->search_catalogue($token, $api_category_id_array,$search, $delivery_type, $sort_name,$max_price);

        if (is_array($get_products)) {
            if ($get_products['status'] == 1001) {

//                echo json_encode($get_margin_array);
//                echo "<hr>";
//                echo json_encode($get_products);
//                echo "<hr>";
                $data_array['total'] = $get_products['total'];
                $product_array = $get_products['result_data'];

                foreach ($get_margin_array as $margin_array) {
                    $get_data_array = array();
                    $get_array['category_id'] = $margin_array['cat_id'];
                    $get_array['category_name'] = $margin_array['cat_name'];

                    $push_data_array = array();
                    foreach ($product_array as $product_result) {


                        if ($margin_array['partner_category_id'] == $product_result['item_category']) {

                            $push_data_array []= $product_result;
                            //$get_data_array[] = $this->arrange_list_cat_item(0,$margin_array['margin'], $margin_array['margin_type'],$product_result,$margin_array['cat_id']);
                            //$get_data_array [] = $this->arrange_list_detail($partner_id, $margin_array['margin'], $margin_array['margin_type'], $product_result);
                            //$get_mod_details = $this->arrange_list_detail($partner_id,$margin,$margin_type, $get_array['result_data'][0]);
                        }

                    }
//                    echo json_encode($push_data_array);
//                    echo "<hr>";
                    if (!empty($push_data_array)) {
                        $get_data_array = $this->arrange_list_cat_item(0, $margin_array['margin'], $margin_array['margin_type'], $push_data_array, $margin_array['cat_id']);

                        $get_array['data'] = $get_data_array;
                        $result_array [] = $get_array;
                    }

                }

                $data_array['data'] = $result_array;
                return $data_array;

            } else {

                return $get_products['status_message'];
            }
        } else {

            return "No data found";
        }

    }


    public function search_catalogue($token, $category_array,$search, $delivery_type, $sort, $max_price = null ){

        $url= $this->company_url."search_item";
        $set_header = $this->set_header($token);
        $data['cat_id'] =json_encode($category_array);
        $data ['max_price'] = $max_price;
        $data ['name'] = $search;
        $data ['delivery_type'] = $delivery_type;
        $data ['sort'] = $sort;


        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }


    }



    public function generate_product_code ($partner_category_id, $item_code){

        $new_company_category = new company_category_class();
        $get_rb_id = $new_company_category->check_rb_category($partner_category_id);

        if (is_array($get_rb_id)) {
            $d_array = array();
            $d_array['p_id'] = $item_code;
            $d_array['c_id'] = $get_rb_id['cat_id'];
//            echo json_encode($d_array);
//            echo "<br>";
            $product_code = base64_encode(json_encode($d_array));
            $return_array['product_code'] = $product_code;
            $return_array['status'] = 1;
            return $return_array;
        } else {

            return $get_rb_id;
        }
    }

    public function confirm_item_array($item_array){

        if (is_array($item_array)){
            $return_array = array();
            foreach ($item_array as $item){
                $send_array = array();
                if($item['code'] == 2002){
                    if(isset($item['ref_no'])){

                        $send_array['ref_no'] = $item['ref_no'];
                    }
                    else {

                        $send_array['ref_no'] = "";
                    }

                    $send_array['response'] = "Out of Stock";
                    $send_array['code'] = 2002;



                }elseif ($item['code'] == 2003){

                    if(isset($item['ref_no']) && isset($item['item_code']) && isset($item['item_category'])){

                        $get_product_code = $this->generate_product_code($item['item_category'], $item['item_code']);

                        if (is_array($get_product_code)){

                            $product_code = $get_product_code['product_code'];

                            $send_array['ref_no'] = $item['ref_no'];
                            $send_array['response'] = "Price Changed";
                            $send_array['code'] = 2003;
                            $send_array['product_code'] = $product_code;

                        } else {

                            if(isset($item['ref_no'])){

                                $send_array['ref_no'] = $item['ref_no'];
                            }
                            else {

                                $send_array['ref_no'] = "";
                            }
                            $send_array['response'] = "Out of Stock";
                            $send_array['code'] = 2002;
                        }


                    } else {

                        if(isset($item['ref_no'])){

                            $send_array['ref_no'] = $item['ref_no'];
                        }
                        else {

                            $send_array['ref_no'] = "";
                        }
                        $send_array['response'] = "Out of Stock";
                        $send_array['code'] = 2002;

                    }

                }elseif ($item['code'] == 2005){

                    if(isset($item['ref_no']) && isset($item['item_code']) && isset($item['item_category']) && isset($item['details'])){

                        $get_product_code = $this->generate_product_code($item['item_category'], $item['item_code']);


                        if (is_array($get_product_code)){

                            $product_code = $get_product_code['product_code'];

                            $send_array['ref_no'] = $item['ref_no'];
                            $send_array['response'] = "Attribute out of stock";
                            $send_array['code'] = 2005;
                            $send_array['product_code'] = $product_code;
                            $send_array['details'] = $item['details'];

                        } else {

                            if(isset($item['ref_no'])){

                                $send_array['ref_no'] = $item['ref_no'];
                            }
                            else {

                                $send_array['ref_no'] = "";
                            }
                            $send_array['response'] = "Out of Stock.";
                            $send_array['code'] = 2002;
                        }


                    } else {

                        if(isset($item['ref_no'])){

                            $send_array['ref_no'] = $item['ref_no'];
                        }
                        else {

                            $send_array['ref_no'] = "";
                        }
                        $send_array['response'] = "Out of Stock..";
                        $send_array['code'] = 2002;

                    }
                } else {

                    if(isset($item['ref_no'])){

                        $send_array['ref_no'] = $item['ref_no'];
                    }
                    else {

                        $send_array['ref_no'] = "";
                    }
                    $send_array['response'] = "Out of Stock...";
                    $send_array['code'] = 2002;

                }


                $return_array[] = $send_array;

            }

            return $return_array;
        } else {

            return "Invalid Array";
        }

    }


    public function check_attr_type_7 ($variant_array){
        if(is_array($variant_array)){

            if(empty($variant_array)){

                return "Blank attribute data";
            } else {


                foreach ($variant_array as $variant){
                    if (isset($variant['id'])){

                        if(is_numeric($variant['id'])){

                            if(isset($variant['variant_id'])){

                                if(is_numeric($variant['variant_id'])){


                                } else {

                                    return "Invalid variant (id)";
                                }

                            } else {

                                return "Missing variant (variant_id)";
                            }

                        } else {

                            return "Invalid variant (id)";
                        }

                    } else {

                        return "Missing variant (id)";
                    }



                }

                return $variant_array;
            }

        } else {

            return "Invalid attribute data";
        }


    }



    public function send_check_order ($token, $array){

        $set_header = $this->set_header($token);
        $new_url =$this->company_url."confirm_item_validity";
        $send_data = $this->send_post($new_url,$array,$set_header);

        if (is_array($send_data)){
//
            return $send_data;
        } else {

            return 0;
        }

    }

    public function validate_order($product_details, $token){

        foreach ($product_details['product_details'] as $rb) {

            $item_array['item_code'] = $rb['signature']['item_code'];
            $item_array['unit_price'] = $rb['cost_price'];
            $item_array['delivery_type'] = $rb['delivery_type'];

            if (isset($rb['branch_id'])) {

                $item_array['branch_id'] = $rb['branch_id'];
            } else {
                $item_array['branch_id'] = 0;
            }


            if ($rb['signature']['is_variant'] == 1) {
                if ($rb['signature']['attr_type'] == 1) {
                    $item_array['variants'] = $rb['variants'];
                } elseif ($rb['signature']['attr_type'] == 7) {

                    $item_array['attributes'] = $rb['variants'];
                } else {
                    $item_array['remark'] = $rb['remark'];
                }
            }
            $item_array['qty_ordered'] = $rb['quantity'];
            $item_array['voucher_no'] = $rb['voucher_no'];
            $item_array['ref_no'] = $rb['ref_no'];
            $item_array['expiry_date'] = date('Y-m-d H:i:s', time() + $this->expire_date);

            $catalogue_array['item_details'][] = $item_array;
        }
        $catalogue_array['item_details'] = json_encode($catalogue_array['item_details']);

        $send_data = $this->send_check_order($token, $catalogue_array);
        if(is_array($send_data)) {
            if ($send_data['status'] == 1001) {
                $response_array ['status'] = 1;
                $response_array ['message'] = "success";
                $response_array['data'] = $send_data['result_data'];
                return $response_array;
            } else {

                $response_array ['status'] = 0;

                $response_array ['message'] = $send_data['status_message'];


                if (isset($send_data['items'])) {
                    $get_item_status = $this->confirm_item_array($send_data['items']);

                    if (is_array($get_item_status)) {

                        $response_array['error'] = $get_item_status;
                    } else {

                        $response_array['error'] = "Invalid Items in Cart";
                    }

                }


                return $response_array;
            }
        } else {

            return "Error Checking Data";
        }

    }

    public function best_selling_products($token, $limit = 10){

        $url = $this->company_url."get_best_selling_items";
        $set_header = $this->set_header($token);

        $data['limit'] =$limit;

        $send_data = $this->send_post($url,$data,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }


    }

    public function get_best_selling_products($token, $get_margins){
        $get_data = $this->best_selling_products($token);
        if (is_array($get_data)) {
            if ($get_data['status'] == 1001) {

                $data_array['total'] = $get_data['total'];
                $product_array = $get_data['result_data'];

                foreach ($get_margins as $margin_array) {

                    $get_array['category_id'] = $margin_array['cat_id'];
                    $get_array['category_name'] = $margin_array['cat_name'];

                    $push_data_array = array();
                    foreach ($product_array as $product_result) {


                        if ($margin_array['partner_category_id'] == $product_result['item_category']) {

                            $push_data_array [] = $product_result;

                        }

                    }

                    if (!empty($push_data_array)) {
                        $get_data_array = $this->arrange_list_cat_item(0, $margin_array['margin'], $margin_array['margin_type'], $push_data_array, $margin_array['cat_id']);

                        $get_array['data'] = $get_data_array;
                        $result_array [] = $get_array;
                    }

                }

                $data_array['data'] = $result_array;
                return $data_array;

            } else {

                return $get_data['status_message'];
            }
        } else {

            return "No data found";
        }

    }


}


