<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 16/11/2018
 * Time: 09:18
 */

require_once ("main_class.php");
require_once ("company_class.php");
class company_contact_class extends Rewardsbox_main
{

    private $table = "user_mgt_com_contact";


    public function create_contact ($company_id, $first_name, $last_name, $email, $phone=0){

        if(isset($company_id) && isset($first_name) && isset($last_name) && isset($email)) {

            if($first_name == "" || $last_name == "" || $company_id == "" || $email == ""){

                return "Blank Parameter";
            } elseif (!is_numeric($company_id)){

                return "False Company";
            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){


                return "Invalid Email";
            } else {
                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)) {

                    $company_name = $check_company['company_name'];

                    $column = array("company_id", "firstname", "lastname", "contact_email", "contact_pno", "status");
                    $value = array($company_id,$first_name, $last_name, $email, $phone, 1);


                    $insert_data = $this->insert_data($this->table, $column, $value);

                    if ($insert_data > 0) {
                        $insert_array['id'] = $insert_data;
                        $insert_array['company_name'] = $company_name;
                        $insert_array['first_name'] = $first_name;
                        $insert_array['last_name'] = $last_name;
                        $insert_array['email'] = $email;
                        $insert_array['phone_no'] = $phone;


                        return $insert_array;


                    } else {
                        return "An error occurred";
                    }
                } else {

                    return "Invalid Company";
                }
            }
        } else {

            return "Missing Parameter";
        }
    }


    public function edit_contact($id, $company_id, $first_name, $last_name, $email, $phone_no = 0) {

        if(isset($id) && isset($company_id)&& isset($first_name) && isset($last_name) && isset($email)) {

            if (!is_numeric($company_id)){

                return "False Company";
            } elseif ($first_name == "" || $last_name == "" || $email == ""){


                return "Blank Parameters";
            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email";
            } else {

                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)) {
                    $key = "contact_id";
                    //$columns_name = "service_name";

                    $firstset['column_name'] = "company_id";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $company_id;
                    $set[] = $firstset;

                    $firstset['column_name'] = "firstname";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $first_name;
                    $set[] = $firstset;

                    $firstset['column_name'] = "lastname";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $last_name;
                    $set[] = $firstset;

                    $firstset['column_name'] = "contact_email";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $email;
                    $set[] = $firstset;

                    $firstset['column_name'] = "contact_pno";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $phone_no;
                    $set[] = $firstset;

                    $first_where['column_name'] = $key;
                    $first_where['sign'] = "=";
                    $first_where['value'] = $id;
                    $where[] = $first_where;

                    $edit_result = $this->update_data($this->table, $set, $where);
                    //print_r($edit_name);

                    if ($edit_result == 1) {
                        return 1;


                    } else {
                        return "Error occurred";
                    }
                } else {

                    return "Invalid Company";
                }
            }
        } else {

            return "Missing Parameter";
        }

    } // end edi name function


    public function change_contact_status ($contact_id, $new_status){
        $key = "contact_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($contact_id, $new_status,$this->table,$key);
        if ($change_status == 1){
            $d_array = array();
            $d_array['status'] = $new_status;
            $d_array['message'] = "Successfully made ".$msg;
            return $d_array;

        } elseif ($change_status ==-2) {
            return "Cannot locate record";

        } elseif ($change_status ==-1) {
            return "Contact already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status

    public function get_all_contacts($company_id){

        $columns = array("contact_id", "user_mgt_company.company_name", "firstname", "lastname", "contact_email","contact_pno", $this->table.".status");

        $firstjoin ['table_name']="user_mgt_company";
        $firstjoin ['first_column']="user_mgt_company.company_id";
        $firstjoin ['second_column']=$this->table.".company_id";
        $leftjoin []=$firstjoin;

        $first_where['column_name'] = $this->table.".company_id";
        $first_where['sign'] = "=";
        $first_where['value'] = $company_id;
        $where[] = $first_where;


        $get_data = $this->select_tb($this->table, $columns, $where,"","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }
}

//$page_test = new company_contact_class();
//echo json_encode($page_test->create_contact(10, "John", "Doe","john@doe.com", ""));
//echo json_encode($page_test->get_all_contacts(10));
//echo json_encode($page_test->edit_contact(1, 10, "Jane", "Smith", "jane@doe.com","08122890094"));
